/*
 * Planck.js v0.1.43
 * 
 * Copyright (c) 2016-2018 Ali Shakiba http://shakiba.me/planck.js
 * Copyright (c) 2006-2013 Erin Catto  http://www.gphysics.com
 * 
 * This software is provided 'as-is', without any express or implied
 * warranty.  In no event will the authors be held liable for any damages
 * arising from the use of this software.
 * 
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 * 
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 */
!function(t){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=t();else if("function"==typeof define&&define.amd)define([],t);else{var i;"undefined"!=typeof window?i=window:"undefined"!=typeof global?i=global:"undefined"!=typeof self&&(i=self),i.planck=t()}}(function(){return function t(i,o,e){function s(r,m){if(!o[r]){if(!i[r]){var a="function"==typeof require&&require;if(!m&&a)return a(r,!0);if(n)return n(r,!0);var h=new Error("Cannot find module '"+r+"'");throw h.code="MODULE_NOT_FOUND",h}var c=o[r]={exports:{}};i[r][0].call(c.exports,function(t){var o=i[r][1][t];return s(o||t)},c,c.exports,t,i,o,e)}return o[r].exports}for(var n="function"==typeof require&&require,r=0;r<e.length;r++)s(e[r]);return s}({1:[function(t,i,o){o.internal={},o.Math=t("./common/Math"),o.Vec2=t("./common/Vec2"),o.Transform=t("./common/Transform"),o.Rot=t("./common/Rot"),o.AABB=t("./collision/AABB"),o.Shape=t("./Shape"),o.Fixture=t("./Fixture"),o.Body=t("./Body"),o.Contact=t("./Contact"),o.Joint=t("./Joint"),o.World=t("./World"),o.Circle=t("./shape/CircleShape"),o.Edge=t("./shape/EdgeShape"),o.Polygon=t("./shape/PolygonShape"),o.Chain=t("./shape/ChainShape"),o.Box=t("./shape/BoxShape"),t("./shape/CollideCircle"),t("./shape/CollideEdgeCircle"),o.internal.CollidePolygons=t("./shape/CollidePolygon"),t("./shape/CollideCirclePolygone"),t("./shape/CollideEdgePolygon"),o.DistanceJoint=t("./joint/DistanceJoint"),o.FrictionJoint=t("./joint/FrictionJoint"),o.GearJoint=t("./joint/GearJoint"),o.MotorJoint=t("./joint/MotorJoint"),o.MouseJoint=t("./joint/MouseJoint"),o.PrismaticJoint=t("./joint/PrismaticJoint"),o.PulleyJoint=t("./joint/PulleyJoint"),o.RevoluteJoint=t("./joint/RevoluteJoint"),o.RopeJoint=t("./joint/RopeJoint"),o.WeldJoint=t("./joint/WeldJoint"),o.WheelJoint=t("./joint/WheelJoint"),o.internal.Sweep=t("./common/Sweep"),o.internal.stats=t("./common/stats"),o.internal.Manifold=t("./Manifold"),o.internal.Distance=t("./collision/Distance"),o.internal.TimeOfImpact=t("./collision/TimeOfImpact"),o.internal.DynamicTree=t("./collision/DynamicTree"),o.internal.Settings=t("./Settings")},{"./Body":2,"./Contact":3,"./Fixture":4,"./Joint":5,"./Manifold":6,"./Settings":7,"./Shape":8,"./World":10,"./collision/AABB":11,"./collision/Distance":13,"./collision/DynamicTree":14,"./collision/TimeOfImpact":15,"./common/Math":18,"./common/Rot":20,"./common/Sweep":21,"./common/Transform":22,"./common/Vec2":23,"./common/stats":26,"./joint/DistanceJoint":27,"./joint/FrictionJoint":28,"./joint/GearJoint":29,"./joint/MotorJoint":30,"./joint/MouseJoint":31,"./joint/PrismaticJoint":32,"./joint/PulleyJoint":33,"./joint/RevoluteJoint":34,"./joint/RopeJoint":35,"./joint/WeldJoint":36,"./joint/WheelJoint":37,"./shape/BoxShape":38,"./shape/ChainShape":39,"./shape/CircleShape":40,"./shape/CollideCircle":41,"./shape/CollideCirclePolygone":42,"./shape/CollideEdgeCircle":43,"./shape/CollideEdgePolygon":44,"./shape/CollidePolygon":45,"./shape/EdgeShape":46,"./shape/PolygonShape":47}],2:[function(t,i,o){function e(t,i){i=m(i,x),n&&r.assert(a.isValid(i.position)),n&&r.assert(a.isValid(i.linearVelocity)),n&&r.assert(c.isFinite(i.angle)),n&&r.assert(c.isFinite(i.angularVelocity)),n&&r.assert(c.isFinite(i.angularDamping)&&i.angularDamping>=0),n&&r.assert(c.isFinite(i.linearDamping)&&i.linearDamping>=0),this.m_world=t,this.m_awakeFlag=i.awake,this.m_autoSleepFlag=i.allowSleep,this.m_bulletFlag=i.bullet,this.m_fixedRotationFlag=i.fixedRotation,this.m_activeFlag=i.active,this.m_islandFlag=!1,this.m_toiFlag=!1,this.m_userData=i.userData,this.m_type=i.type,this.m_type==f?(this.m_mass=1,this.m_invMass=1):(this.m_mass=0,this.m_invMass=0),this.m_I=0,this.m_invI=0,this.m_xf=l.identity(),this.m_xf.p=a.clone(i.position),this.m_xf.q.setAngle(i.angle),this.m_sweep=new _,this.m_sweep.setTransform(this.m_xf),this.c_velocity=new u,this.c_position=new p,this.m_force=a.zero(),this.m_torque=0,this.m_linearVelocity=a.clone(i.linearVelocity),this.m_angularVelocity=i.angularVelocity,this.m_linearDamping=i.linearDamping,this.m_angularDamping=i.angularDamping,this.m_gravityScale=i.gravityScale,this.m_sleepTime=0,this.m_jointList=null,this.m_contactList=null,this.m_fixtureList=null,this.m_prev=null,this.m_next=null}function s(){this.mass=0,this.center=a.zero(),this.I=0}var n=!1;i.exports=e;var r=t("./util/common"),m=t("./util/options"),a=t("./common/Vec2"),h=t("./common/Rot"),c=t("./common/Math"),_=t("./common/Sweep"),l=t("./common/Transform"),u=t("./common/Velocity"),p=t("./common/Position"),y=t("./Fixture"),d=(t("./Shape"),t("./World"),e.STATIC="static"),v=e.KINEMATIC="kinematic",f=e.DYNAMIC="dynamic",x={type:d,position:a.zero(),angle:0,linearVelocity:a.zero(),angularVelocity:0,linearDamping:0,angularDamping:0,fixedRotation:!1,bullet:!1,gravityScale:1,allowSleep:!0,awake:!0,active:!0,userData:null};e.prototype.isWorldLocked=function(){return!(!this.m_world||!this.m_world.isLocked())},e.prototype.getWorld=function(){return this.m_world},e.prototype.getNext=function(){return this.m_next},e.prototype.setUserData=function(t){this.m_userData=t},e.prototype.getUserData=function(){return this.m_userData},e.prototype.getFixtureList=function(){return this.m_fixtureList},e.prototype.getJointList=function(){return this.m_jointList},e.prototype.getContactList=function(){return this.m_contactList},e.prototype.isStatic=function(){return this.m_type==d},e.prototype.isDynamic=function(){return this.m_type==f},e.prototype.isKinematic=function(){return this.m_type==v},e.prototype.setStatic=function(){return this.setType(d),this},e.prototype.setDynamic=function(){return this.setType(f),this},e.prototype.setKinematic=function(){return this.setType(v),this},e.prototype.getType=function(){return this.m_type},e.prototype.setType=function(t){if(n&&r.assert(t===d||t===v||t===f),n&&r.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()&&this.m_type!=t){this.m_type=t,this.resetMassData(),this.m_type==d&&(this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_sweep.forward(),this.synchronizeFixtures()),this.setAwake(!0),this.m_force.setZero(),this.m_torque=0;for(var i=this.m_contactList;i;){var o=i;i=i.next,this.m_world.destroyContact(o.contact)}this.m_contactList=null;for(var e=this.m_world.m_broadPhase,s=this.m_fixtureList;s;s=s.m_next)for(var m=s.m_proxyCount,a=0;a<m;++a)e.touchProxy(s.m_proxies[a].proxyId)}},e.prototype.isBullet=function(){return this.m_bulletFlag},e.prototype.setBullet=function(t){this.m_bulletFlag=!!t},e.prototype.isSleepingAllowed=function(){return this.m_autoSleepFlag},e.prototype.setSleepingAllowed=function(t){this.m_autoSleepFlag=!!t,0==this.m_autoSleepFlag&&this.setAwake(!0)},e.prototype.isAwake=function(){return this.m_awakeFlag},e.prototype.setAwake=function(t){t?0==this.m_awakeFlag&&(this.m_awakeFlag=!0,this.m_sleepTime=0):(this.m_awakeFlag=!1,this.m_sleepTime=0,this.m_linearVelocity.setZero(),this.m_angularVelocity=0,this.m_force.setZero(),this.m_torque=0)},e.prototype.isActive=function(){return this.m_activeFlag},e.prototype.setActive=function(t){if(n&&r.assert(0==this.isWorldLocked()),t!=this.m_activeFlag)if(this.m_activeFlag=!!t,this.m_activeFlag)for(var i=this.m_world.m_broadPhase,o=this.m_fixtureList;o;o=o.m_next)o.createProxies(i,this.m_xf);else{for(i=this.m_world.m_broadPhase,o=this.m_fixtureList;o;o=o.m_next)o.destroyProxies(i);for(var e=this.m_contactList;e;){var s=e;e=e.next,this.m_world.destroyContact(s.contact)}this.m_contactList=null}},e.prototype.isFixedRotation=function(){return this.m_fixedRotationFlag},e.prototype.setFixedRotation=function(t){this.m_fixedRotationFlag!=t&&(this.m_fixedRotationFlag=!!t,this.m_angularVelocity=0,this.resetMassData())},e.prototype.getTransform=function(){return this.m_xf},e.prototype.setTransform=function(t,i){if(n&&r.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()){this.m_xf.set(t,i),this.m_sweep.setTransform(this.m_xf);for(var o=this.m_world.m_broadPhase,e=this.m_fixtureList;e;e=e.m_next)e.synchronize(o,this.m_xf,this.m_xf)}},e.prototype.synchronizeTransform=function(){this.m_sweep.getTransform(this.m_xf,1)},e.prototype.synchronizeFixtures=function(){var t=l.identity();this.m_sweep.getTransform(t,0);for(var i=this.m_world.m_broadPhase,o=this.m_fixtureList;o;o=o.m_next)o.synchronize(i,t,this.m_xf)},e.prototype.advance=function(t){this.m_sweep.advance(t),this.m_sweep.c.set(this.m_sweep.c0),this.m_sweep.a=this.m_sweep.a0,this.m_sweep.getTransform(this.m_xf,1)},e.prototype.getPosition=function(){return this.m_xf.p},e.prototype.setPosition=function(t){this.setTransform(t,this.m_sweep.a)},e.prototype.getAngle=function(){return this.m_sweep.a},e.prototype.setAngle=function(t){this.setTransform(this.m_xf.p,t)},e.prototype.getWorldCenter=function(){return this.m_sweep.c},e.prototype.getLocalCenter=function(){return this.m_sweep.localCenter},e.prototype.getLinearVelocity=function(){return this.m_linearVelocity},e.prototype.getLinearVelocityFromWorldPoint=function(t){var i=a.sub(t,this.m_sweep.c);return a.add(this.m_linearVelocity,a.cross(this.m_angularVelocity,i))},e.prototype.getLinearVelocityFromLocalPoint=function(t){return this.getLinearVelocityFromWorldPoint(this.getWorldPoint(t))},e.prototype.setLinearVelocity=function(t){this.m_type!=d&&(a.dot(t,t)>0&&this.setAwake(!0),this.m_linearVelocity.set(t))},e.prototype.getAngularVelocity=function(){return this.m_angularVelocity},e.prototype.setAngularVelocity=function(t){this.m_type!=d&&(t*t>0&&this.setAwake(!0),this.m_angularVelocity=t)},e.prototype.getLinearDamping=function(){return this.m_linearDamping},e.prototype.setLinearDamping=function(t){this.m_linearDamping=t},e.prototype.getAngularDamping=function(){return this.m_angularDamping},e.prototype.setAngularDamping=function(t){this.m_angularDamping=t},e.prototype.getGravityScale=function(){return this.m_gravityScale},e.prototype.setGravityScale=function(t){this.m_gravityScale=t},e.prototype.getMass=function(){return this.m_mass},e.prototype.getInertia=function(){return this.m_I+this.m_mass*a.dot(this.m_sweep.localCenter,this.m_sweep.localCenter)},e.prototype.getMassData=function(t){t.mass=this.m_mass,t.I=this.getInertia(),t.center.set(this.m_sweep.localCenter)},e.prototype.resetMassData=function(){if(this.m_mass=0,this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_sweep.localCenter.setZero(),this.isStatic()||this.isKinematic())return this.m_sweep.c0.set(this.m_xf.p),this.m_sweep.c.set(this.m_xf.p),void(this.m_sweep.a0=this.m_sweep.a);n&&r.assert(this.isDynamic());for(var t=a.zero(),i=this.m_fixtureList;i;i=i.m_next)if(0!=i.m_density){var o=new s;i.getMassData(o),this.m_mass+=o.mass,t.wAdd(o.mass,o.center),this.m_I+=o.I}this.m_mass>0?(this.m_invMass=1/this.m_mass,t.mul(this.m_invMass)):(this.m_mass=1,this.m_invMass=1),this.m_I>0&&0==this.m_fixedRotationFlag?(this.m_I-=this.m_mass*a.dot(t,t),n&&r.assert(this.m_I>0),this.m_invI=1/this.m_I):(this.m_I=0,this.m_invI=0);var e=a.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t,this.m_xf),this.m_linearVelocity.add(a.cross(this.m_angularVelocity,a.sub(this.m_sweep.c,e)))},e.prototype.setMassData=function(t){if(n&&r.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()&&this.m_type==f){this.m_invMass=0,this.m_I=0,this.m_invI=0,this.m_mass=t.mass,this.m_mass<=0&&(this.m_mass=1),this.m_invMass=1/this.m_mass,t.I>0&&0==this.m_fixedRotationFlag&&(this.m_I=t.I-this.m_mass*a.dot(t.center,t.center),n&&r.assert(this.m_I>0),this.m_invI=1/this.m_I);var i=a.clone(this.m_sweep.c);this.m_sweep.setLocalCenter(t.center,this.m_xf),this.m_linearVelocity.add(a.cross(this.m_angularVelocity,a.sub(this.m_sweep.c,i)))}},e.prototype.applyForce=function(t,i,o){this.m_type==f&&(o&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_force.add(t),this.m_torque+=a.cross(a.sub(i,this.m_sweep.c),t)))},e.prototype.applyForceToCenter=function(t,i){this.m_type==f&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&this.m_force.add(t))},e.prototype.applyTorque=function(t,i){this.m_type==f&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_torque+=t))},e.prototype.applyLinearImpulse=function(t,i,o){this.m_type==f&&(o&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_linearVelocity.wAdd(this.m_invMass,t),this.m_angularVelocity+=this.m_invI*a.cross(a.sub(i,this.m_sweep.c),t)))},e.prototype.applyAngularImpulse=function(t,i){this.m_type==f&&(i&&0==this.m_awakeFlag&&this.setAwake(!0),this.m_awakeFlag&&(this.m_angularVelocity+=this.m_invI*t))},e.prototype.shouldCollide=function(t){if(this.m_type!=f&&t.m_type!=f)return!1;for(var i=this.m_jointList;i;i=i.next)if(i.other==t&&0==i.joint.m_collideConnected)return!1;return!0},e.prototype.createFixture=function(t,i){if(n&&r.assert(0==this.isWorldLocked()),1==this.isWorldLocked())return null;var o=new y(this,t,i);if(this.m_activeFlag){var e=this.m_world.m_broadPhase;o.createProxies(e,this.m_xf)}return o.m_next=this.m_fixtureList,this.m_fixtureList=o,o.m_density>0&&this.resetMassData(),this.m_world.m_newFixture=!0,o},e.prototype.destroyFixture=function(t){if(n&&r.assert(0==this.isWorldLocked()),1!=this.isWorldLocked()){n&&r.assert(t.m_body==this);var i=!1;if(this.m_fixtureList===t)this.m_fixtureList=t.m_next,i=!0;else for(var o=this.m_fixtureList;null!=o;){if(o.m_next===t){o.m_next=t.m_next,i=!0;break}o=o.m_next}n&&r.assert(i);for(var e=this.m_contactList;e;){var s=e.contact;e=e.next;var m=s.getFixtureA(),a=s.getFixtureB();t!=m&&t!=a||this.m_world.destroyContact(s)}if(this.m_activeFlag){var h=this.m_world.m_broadPhase;t.destroyProxies(h)}t.m_body=null,t.m_next=null,this.m_world.publish("remove-fixture",t),this.resetMassData()}},e.prototype.getWorldPoint=function(t){return l.mul(this.m_xf,t)},e.prototype.getWorldVector=function(t){return h.mul(this.m_xf.q,t)},e.prototype.getLocalPoint=function(t){return l.mulT(this.m_xf,t)},e.prototype.getLocalVector=function(t){return h.mulT(this.m_xf.q,t)}},{"./Fixture":4,"./Shape":8,"./World":10,"./common/Math":18,"./common/Position":19,"./common/Rot":20,"./common/Sweep":21,"./common/Transform":22,"./common/Vec2":23,"./common/Velocity":25,"./util/common":50,"./util/options":52}],3:[function(t,i,o){function e(t){this.contact=t,this.prev,this.next,this.other}function s(t,i,o,s,m){this.m_nodeA=new e(this),this.m_nodeB=new e(this),this.m_fixtureA=t,this.m_fixtureB=o,this.m_indexA=i,this.m_indexB=s,this.m_evaluateFcn=m,this.m_manifold=new u,this.m_prev=null,this.m_next=null,this.m_toi=1,this.m_toiCount=0,this.m_toiFlag=!1,this.m_friction=n(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction),this.m_restitution=r(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution),this.m_tangentSpeed=0,this.m_enabledFlag=!0,this.m_islandFlag=!1,this.m_touchingFlag=!1,this.m_filterFlag=!1,this.m_bulletHitFlag=!1,this.v_points=[],this.v_normal=a.zero(),this.v_normalMass=new c,this.v_K=new c,this.v_pointCount,this.v_tangentSpeed,this.v_friction,this.v_restitution,this.v_invMassA,this.v_invMassB,this.v_invIA,this.v_invIB,this.p_localPoints=[],this.p_localNormal=a.zero(),this.p_localPoint=a.zero(),this.p_localCenterA=a.zero(),this.p_localCenterB=a.zero(),this.p_type,this.p_radiusA,this.p_radiusB,this.p_pointCount,this.p_invMassA,this.p_invMassB,this.p_invIA,this.p_invIB}function n(t,i){return m.sqrt(t*i)}function r(t,i){return t>i?t:i}t("./util/common");var m=t("./common/Math"),a=t("./common/Vec2"),h=t("./common/Transform"),c=t("./common/Mat22"),_=t("./common/Rot"),l=t("./Settings"),u=t("./Manifold"),p=t("./collision/Distance");i.exports=s,s.prototype.initConstraint=function(t){var i=this.m_fixtureA,o=this.m_fixtureB,e=i.getShape(),s=o.getShape(),n=i.getBody(),r=o.getBody(),m=this.getManifold(),h=m.pointCount;this.v_invMassA=n.m_invMass,this.v_invMassB=r.m_invMass,this.v_invIA=n.m_invI,this.v_invIB=r.m_invI,this.v_friction=this.m_friction,this.v_restitution=this.m_restitution,this.v_tangentSpeed=this.m_tangentSpeed,this.v_pointCount=h,this.v_K.setZero(),this.v_normalMass.setZero(),this.p_invMassA=n.m_invMass,this.p_invMassB=r.m_invMass,this.p_invIA=n.m_invI,this.p_invIB=r.m_invI,this.p_localCenterA=a.clone(n.m_sweep.localCenter),this.p_localCenterB=a.clone(r.m_sweep.localCenter),this.p_radiusA=e.m_radius,this.p_radiusB=s.m_radius,this.p_type=m.type,this.p_localNormal=a.clone(m.localNormal),this.p_localPoint=a.clone(m.localPoint),this.p_pointCount=h;for(var c=0;c<h;++c){var _=m.points[c],l=this.v_points[c]=new function(){this.rA=a.zero(),this.rB=a.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.normalMass=0,this.tangentMass=0,this.velocityBias=0};t.warmStarting?(l.normalImpulse=t.dtRatio*_.normalImpulse,l.tangentImpulse=t.dtRatio*_.tangentImpulse):(l.normalImpulse=0,l.tangentImpulse=0),l.rA.setZero(),l.rB.setZero(),l.normalMass=0,l.tangentMass=0,l.velocityBias=0,this.p_localPoints[c]=a.clone(_.localPoint)}},s.prototype.getManifold=function(){return this.m_manifold},s.prototype.getWorldManifold=function(t){var i=this.m_fixtureA.getBody(),o=this.m_fixtureB.getBody(),e=this.m_fixtureA.getShape(),s=this.m_fixtureB.getShape();return this.m_manifold.getWorldManifold(t,i.getTransform(),e.m_radius,o.getTransform(),s.m_radius)},s.prototype.setEnabled=function(t){this.m_enabledFlag=!!t},s.prototype.isEnabled=function(){return this.m_enabledFlag},s.prototype.isTouching=function(){return this.m_touchingFlag},s.prototype.getNext=function(){return this.m_next},s.prototype.getFixtureA=function(){return this.m_fixtureA},s.prototype.getFixtureB=function(){return this.m_fixtureB},s.prototype.getChildIndexA=function(){return this.m_indexA},s.prototype.getChildIndexB=function(){return this.m_indexB},s.prototype.flagForFiltering=function(){this.m_filterFlag=!0},s.prototype.setFriction=function(t){this.m_friction=t},s.prototype.getFriction=function(){return this.m_friction},s.prototype.resetFriction=function(){this.m_friction=n(this.m_fixtureA.m_friction,this.m_fixtureB.m_friction)},s.prototype.setRestitution=function(t){this.m_restitution=t},s.prototype.getRestitution=function(){return this.m_restitution},s.prototype.resetRestitution=function(){this.m_restitution=r(this.m_fixtureA.m_restitution,this.m_fixtureB.m_restitution)},s.prototype.setTangentSpeed=function(t){this.m_tangentSpeed=t},s.prototype.getTangentSpeed=function(){return this.m_tangentSpeed},s.prototype.evaluate=function(t,i,o){this.m_evaluateFcn(t,i,this.m_fixtureA,this.m_indexA,o,this.m_fixtureB,this.m_indexB)},s.prototype.update=function(t){this.m_enabledFlag=!0;var i=!1,o=this.m_touchingFlag,e=this.m_fixtureA.isSensor(),s=this.m_fixtureB.isSensor(),n=e||s,r=this.m_fixtureA.getBody(),m=this.m_fixtureB.getBody(),a=r.getTransform(),h=m.getTransform();if(n){var c=this.m_fixtureA.getShape(),_=this.m_fixtureB.getShape();i=p.testOverlap(c,this.m_indexA,_,this.m_indexB,a,h),this.m_manifold.pointCount=0}else{var l=this.m_manifold;this.m_manifold=new u,this.evaluate(this.m_manifold,a,h),i=this.m_manifold.pointCount>0;for(var y=0;y<this.m_manifold.pointCount;++y){var d=this.m_manifold.points[y];d.normalImpulse=0,d.tangentImpulse=0;for(var v=0;v<l.pointCount;++v){var f=l.points[v];if(f.id.key==d.id.key){d.normalImpulse=f.normalImpulse,d.tangentImpulse=f.tangentImpulse;break}}}i!=o&&(r.setAwake(!0),m.setAwake(!0))}this.m_touchingFlag=i,0==o&&1==i&&t&&t.beginContact(this),1==o&&0==i&&t&&t.endContact(this),0==n&&i&&t&&t.preSolve(this,l)},s.prototype.solvePositionConstraint=function(t){return this._solvePositionConstraint(t,!1)},s.prototype.solvePositionConstraintTOI=function(t,i,o){return this._solvePositionConstraint(t,!0,i,o)},s.prototype._solvePositionConstraint=function(t,i,o,e){var s=this.m_fixtureA,n=this.m_fixtureB,r=s.getBody(),c=n.getBody(),p=(r.c_velocity,c.c_velocity,r.c_position),y=c.c_position,d=a.clone(this.p_localCenterA),v=a.clone(this.p_localCenterB),f=0,x=0;i&&r!=o&&r!=e||(f=this.p_invMassA,x=this.p_invIA);var A=0,g=0;i&&c!=o&&c!=e||(A=this.p_invMassB,g=this.p_invIB);for(var b=a.clone(p.c),B=p.a,w=a.clone(y.c),S=y.a,C=0,M=0;M<this.p_pointCount;++M){var I=h.identity(),P=h.identity();I.q.set(B),P.q.set(S),I.p=a.sub(b,_.mul(I.q,d)),P.p=a.sub(w,_.mul(P.q,v));var T,V,z;switch(this.p_type){case u.e_circles:var L=h.mul(I,this.p_localPoint),F=h.mul(P,this.p_localPoints[0]);(T=a.sub(F,L)).normalize(),V=a.wAdd(.5,L,.5,F),z=a.dot(a.sub(F,L),T)-this.p_radiusA-this.p_radiusB;break;case u.e_faceA:T=_.mul(I.q,this.p_localNormal);var q=h.mul(I,this.p_localPoint),k=h.mul(P,this.p_localPoints[M]);z=a.dot(a.sub(k,q),T)-this.p_radiusA-this.p_radiusB,V=k;break;case u.e_faceB:T=_.mul(P.q,this.p_localNormal);q=h.mul(P,this.p_localPoint),k=h.mul(I,this.p_localPoints[M]);z=a.dot(a.sub(k,q),T)-this.p_radiusA-this.p_radiusB,V=k,T.mul(-1)}var R=a.sub(V,b),D=a.sub(V,w);C=m.min(C,z);var E=i?l.toiBaugarte:l.baumgarte,j=l.linearSlop,J=l.maxLinearCorrection,O=m.clamp(E*(z+j),-J,0),N=a.cross(R,T),Y=a.cross(D,T),W=f+A+x*N*N+g*Y*Y,H=W>0?-O/W:0,Z=a.mul(H,T);b.wSub(f,Z),B-=x*a.cross(R,Z),w.wAdd(A,Z),S+=g*a.cross(D,Z)}return p.c.set(b),p.a=B,y.c.set(w),y.a=S,C},s.prototype.initVelocityConstraint=function(t){var i=this.m_fixtureA,o=this.m_fixtureB,e=i.getBody(),s=o.getBody(),n=e.c_velocity,r=s.c_velocity,m=e.c_position,c=s.c_position,u=this.p_radiusA,p=this.p_radiusB,y=this.getManifold(),d=this.v_invMassA,v=this.v_invMassB,f=this.v_invIA,x=this.v_invIB,A=a.clone(this.p_localCenterA),g=a.clone(this.p_localCenterB),b=a.clone(m.c),B=m.a,w=a.clone(n.v),S=n.w,C=a.clone(c.c),M=c.a,I=a.clone(r.v),P=r.w,T=h.identity(),V=h.identity();T.q.set(B),V.q.set(M),T.p.wSet(1,b,-1,_.mul(T.q,A)),V.p.wSet(1,C,-1,_.mul(V.q,g));var z=y.getWorldManifold(null,T,u,V,p);this.v_normal.set(z.normal);for(var L=0;L<this.v_pointCount;++L){var F=this.v_points[L];F.rA.set(a.sub(z.points[L],b)),F.rB.set(a.sub(z.points[L],C));var q=a.cross(F.rA,this.v_normal),k=a.cross(F.rB,this.v_normal),R=d+v+f*q*q+x*k*k;F.normalMass=R>0?1/R:0;var D=a.cross(this.v_normal,1),E=a.cross(F.rA,D),j=a.cross(F.rB,D),J=d+v+f*E*E+x*j*j;F.tangentMass=J>0?1/J:0,F.velocityBias=0;var O=a.dot(this.v_normal,I)+a.dot(this.v_normal,a.cross(P,F.rB))-a.dot(this.v_normal,w)-a.dot(this.v_normal,a.cross(S,F.rA));O<-l.velocityThreshold&&(F.velocityBias=-this.v_restitution*O)}if(2==this.v_pointCount&&t.blockSolve){var N=this.v_points[0],Y=this.v_points[1],W=a.cross(N.rA,this.v_normal),H=a.cross(N.rB,this.v_normal),Z=a.cross(Y.rA,this.v_normal),K=a.cross(Y.rB,this.v_normal),G=d+v+f*W*W+x*H*H,U=d+v+f*Z*Z+x*K*K,X=d+v+f*W*Z+x*H*K;G*G<1e3*(G*U-X*X)?(this.v_K.ex.set(G,X),this.v_K.ey.set(X,U),this.v_normalMass.set(this.v_K.getInverse())):this.v_pointCount=1}m.c.set(b),m.a=B,n.v.set(w),n.w=S,c.c.set(C),c.a=M,r.v.set(I),r.w=P},s.prototype.warmStartConstraint=function(t){for(var i=this.m_fixtureA,o=this.m_fixtureB,e=i.getBody(),s=o.getBody(),n=e.c_velocity,r=s.c_velocity,m=(e.c_position,s.c_position,this.v_invMassA),h=this.v_invIA,c=this.v_invMassB,_=this.v_invIB,l=a.clone(n.v),u=n.w,p=a.clone(r.v),y=r.w,d=this.v_normal,v=a.cross(d,1),f=0;f<this.v_pointCount;++f){var x=this.v_points[f],A=a.wAdd(x.normalImpulse,d,x.tangentImpulse,v);u-=h*a.cross(x.rA,A),l.wSub(m,A),y+=_*a.cross(x.rB,A),p.wAdd(c,A)}n.v.set(l),n.w=u,r.v.set(p),r.w=y},s.prototype.storeConstraintImpulses=function(t){for(var i=this.m_manifold,o=0;o<this.v_pointCount;++o)i.points[o].normalImpulse=this.v_points[o].normalImpulse,i.points[o].tangentImpulse=this.v_points[o].tangentImpulse},s.prototype.solveVelocityConstraint=function(t){for(var i=this.m_fixtureA.m_body,o=this.m_fixtureB.m_body,e=i.c_velocity,s=(i.c_position,o.c_velocity),n=(o.c_position,this.v_invMassA),r=this.v_invIA,h=this.v_invMassB,_=this.v_invIB,l=a.clone(e.v),u=e.w,p=a.clone(s.v),y=s.w,d=this.v_normal,v=a.cross(d,1),f=this.v_friction,x=0;x<this.v_pointCount;++x){var A=this.v_points[x];(C=a.zero()).wAdd(1,p,1,a.cross(y,A.rB)),C.wSub(1,l,1,a.cross(u,A.rA));var g=a.dot(C,v)-this.v_tangentSpeed,b=A.tangentMass*-g,B=f*A.normalImpulse;b=(M=m.clamp(A.tangentImpulse+b,-B,B))-A.tangentImpulse,A.tangentImpulse=M;var w=a.mul(b,v);l.wSub(n,w),u-=r*a.cross(A.rA,w),p.wAdd(h,w),y+=_*a.cross(A.rB,w)}if(1==this.v_pointCount||0==t.blockSolve)for(var S=0;S<this.v_pointCount;++S){var C;A=this.v_points[S];(C=a.zero()).wAdd(1,p,1,a.cross(y,A.rB)),C.wSub(1,l,1,a.cross(u,A.rA));var M,I=a.dot(C,d);b=-A.normalMass*(I-A.velocityBias);b=(M=m.max(A.normalImpulse+b,0))-A.normalImpulse,A.normalImpulse=M;w=a.mul(b,d);l.wSub(n,w),u-=r*a.cross(A.rA,w),p.wAdd(h,w),y+=_*a.cross(A.rB,w)}else{var P=this.v_points[0],T=this.v_points[1],V=a.neo(P.normalImpulse,T.normalImpulse),z=a.zero().add(p).add(a.cross(y,P.rB)).sub(l).sub(a.cross(u,P.rA)),L=a.zero().add(p).add(a.cross(y,T.rB)).sub(l).sub(a.cross(u,T.rA)),F=a.dot(z,d),q=a.dot(L,d),k=a.neo(F-P.velocityBias,q-T.velocityBias);k.sub(c.mul(this.v_K,V));for(;;){var R=a.neg(c.mul(this.v_normalMass,k));if(R.x>=0&&R.y>=0){var D=a.sub(R,V),E=a.mul(D.x,d),j=a.mul(D.y,d);l.wSub(n,E,n,j),u-=r*(a.cross(P.rA,E)+a.cross(T.rA,j)),p.wAdd(h,E,h,j),y+=_*(a.cross(P.rB,E)+a.cross(T.rB,j)),P.normalImpulse=R.x,T.normalImpulse=R.y;break}if(R.x=-P.normalMass*k.x,R.y=0,F=0,q=this.v_K.ex.y*R.x+k.y,R.x>=0&&q>=0){D=a.sub(R,V),E=a.mul(D.x,d),j=a.mul(D.y,d);l.wSub(n,E,n,j),u-=r*(a.cross(P.rA,E)+a.cross(T.rA,j)),p.wAdd(h,E,h,j),y+=_*(a.cross(P.rB,E)+a.cross(T.rB,j)),P.normalImpulse=R.x,T.normalImpulse=R.y;break}if(R.x=0,R.y=-T.normalMass*k.y,F=this.v_K.ey.x*R.y+k.x,q=0,R.y>=0&&F>=0){D=a.sub(R,V),E=a.mul(D.x,d),j=a.mul(D.y,d);l.wSub(n,E,n,j),u-=r*(a.cross(P.rA,E)+a.cross(T.rA,j)),p.wAdd(h,E,h,j),y+=_*(a.cross(P.rB,E)+a.cross(T.rB,j)),P.normalImpulse=R.x,T.normalImpulse=R.y;break}if(R.x=0,R.y=0,F=k.x,q=k.y,F>=0&&q>=0){D=a.sub(R,V),E=a.mul(D.x,d),j=a.mul(D.y,d);l.wSub(n,E,n,j),u-=r*(a.cross(P.rA,E)+a.cross(T.rA,j)),p.wAdd(h,E,h,j),y+=_*(a.cross(P.rB,E)+a.cross(T.rB,j)),P.normalImpulse=R.x,T.normalImpulse=R.y;break}break}}e.v.set(l),e.w=u,s.v.set(p),s.w=y};var y=[];s.addType=function(t,i,o){y[t]=y[t]||{},y[t][i]=o},s.create=function(t,i,o,e){var n,r,m=t.getType(),a=o.getType();if(r=y[m]&&y[m][a])n=new s(t,i,o,e,r);else{if(!(r=y[a]&&y[a][m]))return null;n=new s(o,e,t,i,r)}t=n.getFixtureA(),o=n.getFixtureB(),i=n.getChildIndexA(),e=n.getChildIndexB();var h=t.getBody(),c=o.getBody();return n.m_nodeA.contact=n,n.m_nodeA.other=c,n.m_nodeA.prev=null,n.m_nodeA.next=h.m_contactList,null!=h.m_contactList&&(h.m_contactList.prev=n.m_nodeA),h.m_contactList=n.m_nodeA,n.m_nodeB.contact=n,n.m_nodeB.other=h,n.m_nodeB.prev=null,n.m_nodeB.next=c.m_contactList,null!=c.m_contactList&&(c.m_contactList.prev=n.m_nodeB),c.m_contactList=n.m_nodeB,0==t.isSensor()&&0==o.isSensor()&&(h.setAwake(!0),c.setAwake(!0)),n},s.destroy=function(t,i){var o=t.m_fixtureA,e=t.m_fixtureB,s=o.getBody(),n=e.getBody();t.isTouching()&&i.endContact(t),t.m_nodeA.prev&&(t.m_nodeA.prev.next=t.m_nodeA.next),t.m_nodeA.next&&(t.m_nodeA.next.prev=t.m_nodeA.prev),t.m_nodeA==s.m_contactList&&(s.m_contactList=t.m_nodeA.next),t.m_nodeB.prev&&(t.m_nodeB.prev.next=t.m_nodeB.next),t.m_nodeB.next&&(t.m_nodeB.next.prev=t.m_nodeB.prev),t.m_nodeB==n.m_contactList&&(n.m_contactList=t.m_nodeB.next),t.m_manifold.pointCount>0&&0==o.isSensor()&&0==e.isSensor()&&(s.setAwake(!0),n.setAwake(!0));var r=o.getType(),m=e.getType(),a=y[r][m].destroyFcn;"function"==typeof a&&a(t)}},{"./Manifold":6,"./Settings":7,"./collision/Distance":13,"./common/Mat22":16,"./common/Math":18,"./common/Rot":20,"./common/Transform":22,"./common/Vec2":23,"./util/common":50}],4:[function(t,i,o){function e(t,i){this.aabb=new m,this.fixture=t,this.childIndex=i,this.proxyId}function s(t,i,o){i.shape?(o=i,i=i.shape):"number"==typeof o&&(o={density:o}),o=n(o,a),this.m_body=t,this.m_friction=o.friction,this.m_restitution=o.restitution,this.m_density=o.density,this.m_isSensor=o.isSensor,this.m_filterGroupIndex=o.filterGroupIndex,this.m_filterCategoryBits=o.filterCategoryBits,this.m_filterMaskBits=o.filterMaskBits,this.m_shape=i,this.m_next=null,this.m_proxies=[],this.m_proxyCount=0;for(var s=this.m_shape.getChildCount(),r=0;r<s;++r)this.m_proxies[r]=new e(this,r);this.m_userData=o.userData}i.exports=s;t("./util/common");var n=t("./util/options"),r=t("./common/Vec2"),m=t("./collision/AABB"),a={userData:null,friction:.2,restitution:0,density:0,isSensor:!1,filterGroupIndex:0,filterCategoryBits:1,filterMaskBits:65535};s.prototype.getType=function(){return this.m_shape.getType()},s.prototype.getShape=function(){return this.m_shape},s.prototype.isSensor=function(){return this.m_isSensor},s.prototype.setSensor=function(t){t!=this.m_isSensor&&(this.m_body.setAwake(!0),this.m_isSensor=t)},s.prototype.getUserData=function(){return this.m_userData},s.prototype.setUserData=function(t){this.m_userData=t},s.prototype.getBody=function(){return this.m_body},s.prototype.getNext=function(){return this.m_next},s.prototype.getDensity=function(){return this.m_density},s.prototype.setDensity=function(t){this.m_density=t},s.prototype.getFriction=function(){return this.m_friction},s.prototype.setFriction=function(t){this.m_friction=t},s.prototype.getRestitution=function(){return this.m_restitution},s.prototype.setRestitution=function(t){this.m_restitution=t},s.prototype.testPoint=function(t){return this.m_shape.testPoint(this.m_body.getTransform(),t)},s.prototype.rayCast=function(t,i,o){return this.m_shape.rayCast(t,i,this.m_body.getTransform(),o)},s.prototype.getMassData=function(t){this.m_shape.computeMass(t,this.m_density)},s.prototype.getAABB=function(t){return this.m_proxies[t].aabb},s.prototype.createProxies=function(t,i){this.m_proxyCount=this.m_shape.getChildCount();for(var o=0;o<this.m_proxyCount;++o){var e=this.m_proxies[o];this.m_shape.computeAABB(e.aabb,i,o),e.proxyId=t.createProxy(e.aabb,e)}},s.prototype.destroyProxies=function(t){for(var i=0;i<this.m_proxyCount;++i){var o=this.m_proxies[i];t.destroyProxy(o.proxyId),o.proxyId=null}this.m_proxyCount=0},s.prototype.synchronize=function(t,i,o){for(var e=0;e<this.m_proxyCount;++e){var s=this.m_proxies[e],n=new m,a=new m;this.m_shape.computeAABB(n,i,s.childIndex),this.m_shape.computeAABB(a,o,s.childIndex),s.aabb.combine(n,a);var h=r.sub(o.p,i.p);t.moveProxy(s.proxyId,s.aabb,h)}},s.prototype.setFilterData=function(t){this.m_filterGroupIndex=t.groupIndex,this.m_filterCategoryBits=t.categoryBits,this.m_filterMaskBits=t.maskBits,this.refilter()},s.prototype.getFilterGroupIndex=function(){return this.m_filterGroupIndex},s.prototype.getFilterCategoryBits=function(){return this.m_filterCategoryBits},s.prototype.getFilterMaskBits=function(){return this.m_filterMaskBits},s.prototype.refilter=function(){if(null!=this.m_body){for(var t=this.m_body.getContactList();t;){var i=t.contact,o=i.getFixtureA(),e=i.getFixtureB();o!=this&&e!=this||i.flagForFiltering(),t=t.next}var s=this.m_body.getWorld();if(null!=s)for(var n=s.m_broadPhase,r=0;r<this.m_proxyCount;++r)n.touchProxy(this.m_proxies[r].proxyId)}},s.prototype.shouldCollide=function(t){if(t.m_filterGroupIndex==this.m_filterGroupIndex&&0!=t.m_filterGroupIndex)return t.m_filterGroupIndex>0;return 0!=(t.m_filterMaskBits&this.m_filterCategoryBits)&&0!=(t.m_filterCategoryBits&this.m_filterMaskBits)}},{"./collision/AABB":11,"./common/Vec2":23,"./util/common":50,"./util/options":52}],5:[function(t,i,o){function e(){this.other=null,this.joint=null,this.prev=null,this.next=null}function s(t,i,o){i=t.bodyA||i,o=t.bodyB||o,n&&r.assert(i),n&&r.assert(o),n&&r.assert(i!=o),this.m_type="unknown-joint",this.m_bodyA=i,this.m_bodyB=o,this.m_index=0,this.m_collideConnected=!!t.collideConnected,this.m_prev=null,this.m_next=null,this.m_edgeA=new e,this.m_edgeB=new e,this.m_islandFlag=!1,this.m_userData=t.userData}var n=!1;i.exports=s;var r=t("./util/common");s.prototype.isActive=function(){return this.m_bodyA.isActive()&&this.m_bodyB.isActive()},s.prototype.getType=function(){return this.m_type},s.prototype.getBodyA=function(){return this.m_bodyA},s.prototype.getBodyB=function(){return this.m_bodyB},s.prototype.getNext=function(){return this.m_next},s.prototype.getUserData=function(){return this.m_userData},s.prototype.setUserData=function(t){this.m_userData=t},s.prototype.getCollideConnected=function(){return this.m_collideConnected},s.prototype.getAnchorA=function(){},s.prototype.getAnchorB=function(){},s.prototype.getReactionForce=function(t){},s.prototype.getReactionTorque=function(t){},s.prototype.shiftOrigin=function(t){},s.prototype.initVelocityConstraints=function(t){},s.prototype.solveVelocityConstraints=function(t){},s.prototype.solvePositionConstraints=function(t){}},{"./util/common":50}],6:[function(t,i,o){function e(){this.type,this.localNormal=a.zero(),this.localPoint=a.zero(),this.points=[new s,new s],this.pointCount=0}function s(){this.localPoint=a.zero(),this.normalImpulse=0,this.tangentImpulse=0,this.id=new n}function n(){this.cf=new r;Object.defineProperty(this,"key",{get:function(){return this.cf.indexA+4*this.cf.indexB+16*this.cf.typeA+64*this.cf.typeB},enumerable:!0,configurable:!0})}function r(){this.indexA,this.indexB,this.typeA,this.typeB}function m(){this.v=a.zero(),this.id=new n}t("./util/common");var a=t("./common/Vec2"),h=t("./common/Transform"),c=t("./common/Math"),_=t("./common/Rot");i.exports=e,i.exports.clipSegmentToLine=function(t,i,o,s,n){var r=0,m=a.dot(o,i[0].v)-s,h=a.dot(o,i[1].v)-s;if(m<=0&&t[r++].set(i[0]),h<=0&&t[r++].set(i[1]),m*h<0){var c=m/(m-h);t[r].v.wSet(1-c,i[0].v,c,i[1].v),t[r].id.cf.indexA=n,t[r].id.cf.indexB=i[0].id.cf.indexB,t[r].id.cf.typeA=e.e_vertex,t[r].id.cf.typeB=e.e_face,++r}return r},i.exports.clipVertex=m,i.exports.getPointStates=function(t,i,o,e){for(var s=0;s<o.pointCount;++s){var n=o.points[s].id;t[s]=l.removeState;for(var r=0;r<e.pointCount;++r)if(e.points[r].id.key==n.key){t[s]=l.persistState;break}}for(s=0;s<e.pointCount;++s)for(n=e.points[s].id,i[s]=l.addState,r=0;r<o.pointCount;++r)if(o.points[r].id.key==n.key){i[s]=l.persistState;break}},i.exports.PointState=l,e.e_circles=0,e.e_faceA=1,e.e_faceB=2,e.e_vertex=0,e.e_face=1,n.prototype.set=function(t){this.cf.set(t.cf)},r.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.typeA=t.typeA,this.typeB=t.typeB},e.prototype.getWorldManifold=function(t,i,o,s,n){if(0!=this.pointCount){var r=(t=t||new function(){this.normal,this.points=[],this.separations=[]}).normal,m=t.points,l=t.separations;switch(this.type){case e.e_circles:r=a.neo(1,0);var u=h.mul(i,this.localPoint),p=h.mul(s,this.points[0].localPoint),y=a.sub(p,u);a.lengthSquared(y)>c.EPSILON*c.EPSILON&&(r.set(y),r.normalize()),m[0]=a.mid(u,p),l[0]=-n-o,m.length=1,l.length=1;break;case e.e_faceA:r=_.mul(i.q,this.localNormal);for(var d=h.mul(i,this.localPoint),v=0;v<this.pointCount;++v){var f=h.mul(s,this.points[v].localPoint),x=a.clone(f).wAdd(o-a.dot(a.sub(f,d),r),r),A=a.clone(f).wSub(n,r);m[v]=a.mid(x,A),l[v]=a.dot(a.sub(A,x),r)}m.length=this.pointCount,l.length=this.pointCount;break;case e.e_faceB:r=_.mul(s.q,this.localNormal);for(d=h.mul(s,this.localPoint),v=0;v<this.pointCount;++v){f=h.mul(i,this.points[v].localPoint),A=a.zero().wSet(1,f,n-a.dot(a.sub(f,d),r),r),x=a.zero().wSet(1,f,-o,r);m[v]=a.mid(x,A),l[v]=a.dot(a.sub(x,A),r)}m.length=this.pointCount,l.length=this.pointCount,r.mul(-1)}return t.normal=r,t.points=m,t.separations=l,t}};var l={nullState:0,addState:1,persistState:2,removeState:3};m.prototype.set=function(t){this.v.set(t.v),this.id.set(t.id)}},{"./common/Math":18,"./common/Rot":20,"./common/Transform":22,"./common/Vec2":23,"./util/common":50}],7:[function(t,i,o){var e=o;e.maxManifoldPoints=2,e.maxPolygonVertices=12,e.aabbExtension=.1,e.aabbMultiplier=2,e.linearSlop=.005,e.linearSlopSquared=e.linearSlop*e.linearSlop,e.angularSlop=2/180*Math.PI,e.polygonRadius=2*e.linearSlop,e.maxSubSteps=8,e.maxTOIContacts=32,e.maxTOIIterations=20,e.maxDistnceIterations=20,e.velocityThreshold=1,e.maxLinearCorrection=.2,e.maxAngularCorrection=8/180*Math.PI,e.maxTranslation=2,e.maxTranslationSquared=e.maxTranslation*e.maxTranslation,e.maxRotation=.5*Math.PI,e.maxRotationSquared=e.maxRotation*e.maxRotation,e.baumgarte=.2,e.toiBaugarte=.75,e.timeToSleep=.5,e.linearSleepTolerance=.01,e.linearSleepToleranceSqr=Math.pow(e.linearSleepTolerance,2),e.angularSleepTolerance=2/180*Math.PI,e.angularSleepToleranceSqr=Math.pow(e.angularSleepTolerance,2)},{}],8:[function(t,i,o){function e(){this.m_type,this.m_radius}i.exports=e;t("./common/Math");e.isValid=function(t){return!!t},e.prototype.getRadius=function(){return this.m_radius},e.prototype.getType=function(){return this.m_type},e.prototype._clone=function(){},e.prototype.getChildCount=function(){},e.prototype.testPoint=function(t,i){},e.prototype.rayCast=function(t,i,o,e){},e.prototype.computeAABB=function(t,i,o){},e.prototype.computeMass=function(t,i){},e.prototype.computeDistanceProxy=function(t){}},{"./common/Math":18}],9:[function(t,i,o){function e(t){this.dt=0,this.inv_dt=0,this.velocityIterations=0,this.positionIterations=0,this.warmStarting=!1,this.blockSolve=!0,this.inv_dt0=0,this.dtRatio=1}function s(t){this.m_world=t,this.m_stack=[],this.m_bodies=[],this.m_contacts=[],this.m_joints=[]}i.exports=s,i.exports.TimeStep=e;var n=t("./Settings"),r=t("./util/common"),m=t("./common/Vec2"),a=t("./common/Math"),h=(t("./Body"),t("./Contact"),t("./Joint"),t("./collision/TimeOfImpact")),c=h.Input,_=h.Output,l=t("./collision/Distance");l.Input,l.Output,l.Proxy,l.Cache;e.prototype.reset=function(t){this.dt>0&&(this.inv_dt0=this.inv_dt),this.dt=t,this.inv_dt=0==t?0:1/t,this.dtRatio=t*this.inv_dt0},s.prototype.clear=function(){this.m_stack.length=0,this.m_bodies.length=0,this.m_contacts.length=0,this.m_joints.length=0},s.prototype.addBody=function(t){this.m_bodies.push(t)},s.prototype.addContact=function(t){this.m_contacts.push(t)},s.prototype.addJoint=function(t){this.m_joints.push(t)},s.prototype.solveWorld=function(t){for(var i=this.m_world,o=i.m_bodyList;o;o=o.m_next)o.m_islandFlag=!1;for(var e=i.m_contactList;e;e=e.m_next)e.m_islandFlag=!1;for(var s=i.m_jointList;s;s=s.m_next)s.m_islandFlag=!1;for(var n=this.m_stack,r=i.m_bodyList;r;r=r.m_next)if(0,!r.m_islandFlag&&0!=r.isAwake()&&0!=r.isActive()&&!r.isStatic()){for(this.clear(),n.push(r),r.m_islandFlag=!0;n.length>0;){o=n.pop();if(this.addBody(o),o.setAwake(!0),!o.isStatic()){for(var m=o.m_contactList;m;m=m.next){var a=m.contact;if(!a.m_islandFlag&&(0!=a.isEnabled()&&0!=a.isTouching())){var h=a.m_fixtureA.m_isSensor,c=a.m_fixtureB.m_isSensor;if(!h&&!c){this.addContact(a),a.m_islandFlag=!0;(l=m.other).m_islandFlag||(n.push(l),l.m_islandFlag=!0)}}}for(var _=o.m_jointList;_;_=_.next)if(1!=_.joint.m_islandFlag){var l;0!=(l=_.other).isActive()&&(this.addJoint(_.joint),_.joint.m_islandFlag=!0,l.m_islandFlag||(n.push(l),l.m_islandFlag=!0))}}}this.solveIsland(t);for(var u=0;u<this.m_bodies.length;++u){(o=this.m_bodies[u]).isStatic()&&(o.m_islandFlag=!1)}}},s.prototype.solveIsland=function(t){for(var i=this.m_world,o=i.m_gravity,e=i.m_allowSleep,s=t.dt,r=0;r<this.m_bodies.length;++r){var h=this.m_bodies[r],c=m.clone(h.m_sweep.c),_=h.m_sweep.a,l=m.clone(h.m_linearVelocity),u=h.m_angularVelocity;h.m_sweep.c0.set(h.m_sweep.c),h.m_sweep.a0=h.m_sweep.a,h.isDynamic()&&(l.wAdd(s*h.m_gravityScale,o),l.wAdd(s*h.m_invMass,h.m_force),u+=s*h.m_invI*h.m_torque,l.mul(1/(1+s*h.m_linearDamping)),u*=1/(1+s*h.m_angularDamping)),h.c_position.c=c,h.c_position.a=_,h.c_velocity.v=l,h.c_velocity.w=u}for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].initConstraint(t)}for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].initVelocityConstraint(t)}if(t.warmStarting)for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].warmStartConstraint(t)}for(r=0;r<this.m_joints.length;++r){this.m_joints[r].initVelocityConstraints(t)}for(r=0;r<t.velocityIterations;++r){for(var p=0;p<this.m_joints.length;++p){this.m_joints[p].solveVelocityConstraints(t)}for(p=0;p<this.m_contacts.length;++p){this.m_contacts[p].solveVelocityConstraint(t)}}for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].storeConstraintImpulses(t)}for(r=0;r<this.m_bodies.length;++r){h=this.m_bodies[r],c=m.clone(h.c_position.c),_=h.c_position.a,l=m.clone(h.c_velocity.v),u=h.c_velocity.w;var y=m.mul(s,l);if(m.lengthSquared(y)>n.maxTranslationSquared){var d=n.maxTranslation/y.length();l.mul(d)}var v=s*u;if(v*v>n.maxRotationSquared){u*=d=n.maxRotation/a.abs(v)}c.wAdd(s,l),_+=s*u,h.c_position.c.set(c),h.c_position.a=_,h.c_velocity.v.set(l),h.c_velocity.w=u}var f=!1;for(r=0;r<t.positionIterations;++r){var x=0;for(p=0;p<this.m_contacts.length;++p){var A=this.m_contacts[p].solvePositionConstraint(t);x=a.min(x,A)}var g=x>=-3*n.linearSlop,b=!0;for(p=0;p<this.m_joints.length;++p){var B=this.m_joints[p].solvePositionConstraints(t);b=b&&B}if(g&&b){f=!0;break}}for(r=0;r<this.m_bodies.length;++r){(h=this.m_bodies[r]).m_sweep.c.set(h.c_position.c),h.m_sweep.a=h.c_position.a,h.m_linearVelocity.set(h.c_velocity.v),h.m_angularVelocity=h.c_velocity.w,h.synchronizeTransform()}if(this.postSolveIsland(),e){var w=1/0,S=n.linearSleepToleranceSqr,C=n.angularSleepToleranceSqr;for(r=0;r<this.m_bodies.length;++r){(h=this.m_bodies[r]).isStatic()||(0==h.m_autoSleepFlag||h.m_angularVelocity*h.m_angularVelocity>C||m.lengthSquared(h.m_linearVelocity)>S?(h.m_sleepTime=0,w=0):(h.m_sleepTime+=s,w=a.min(w,h.m_sleepTime)))}if(w>=n.timeToSleep&&f)for(r=0;r<this.m_bodies.length;++r){(h=this.m_bodies[r]).setAwake(!1)}}},s.prototype.printBodies=function(t){for(var i=0;i<this.m_bodies.length;++i){var o=this.m_bodies[i];r.debug(t,o.c_position.a,o.c_position.c.x,o.c_position.c.y,o.c_velocity.w,o.c_velocity.v.x,o.c_velocity.v.y)}};var u=new e;s.prototype.solveWorldTOI=function(t){var i=this.m_world;if(i.m_stepComplete){for(var o=i.m_bodyList;o;o=o.m_next)o.m_islandFlag=!1,o.m_sweep.alpha0=0;for(var e=i.m_contactList;e;e=e.m_next)e.m_toiFlag=!1,e.m_islandFlag=!1,e.m_toiCount=0,e.m_toi=1}for(;;){var s=null,r=1;for(e=i.m_contactList;e;e=e.m_next)if(0!=e.isEnabled()&&!(e.m_toiCount>n.maxSubSteps)){var m=1;if(e.m_toiFlag)m=e.m_toi;else{var l=e.getFixtureA(),p=e.getFixtureB();if(l.isSensor()||p.isSensor())continue;var y=l.getBody(),d=p.getBody(),v=y.isAwake()&&!y.isStatic(),f=d.isAwake()&&!d.isStatic();if(0==v&&0==f)continue;var x=y.isBullet()||!y.isDynamic(),A=d.isBullet()||!d.isDynamic();if(0==x&&0==A)continue;var g=y.m_sweep.alpha0;y.m_sweep.alpha0<d.m_sweep.alpha0?(g=d.m_sweep.alpha0,y.m_sweep.advance(g)):d.m_sweep.alpha0<y.m_sweep.alpha0&&(g=y.m_sweep.alpha0,d.m_sweep.advance(g));var b=e.getChildIndexA(),B=e.getChildIndexB(),w=(y.m_sweep,d.m_sweep,new c);w.proxyA.set(l.getShape(),b),w.proxyB.set(p.getShape(),B),w.sweepA.set(y.m_sweep),w.sweepB.set(d.m_sweep),w.tMax=1;var S=new _;h(S,w);var C=S.t;m=S.state==_.e_touching?a.min(g+(1-g)*C,1):1,e.m_toi=m,e.m_toiFlag=!0}m<r&&(s=e,r=m)}if(null==s||1-10*a.EPSILON<r){i.m_stepComplete=!0;break}l=s.getFixtureA(),p=s.getFixtureB(),y=l.getBody(),d=p.getBody();var M=y.m_sweep.clone(),I=d.m_sweep.clone();if(y.advance(r),d.advance(r),s.update(i),s.m_toiFlag=!1,++s.m_toiCount,0!=s.isEnabled()&&0!=s.isTouching()){y.setAwake(!0),d.setAwake(!0),this.clear(),this.addBody(y),this.addBody(d),this.addContact(s),y.m_islandFlag=!0,d.m_islandFlag=!0,s.m_islandFlag=!0;for(var P=[y,d],T=0;T<P.length;++T){if((R=P[T]).isDynamic())for(var V=R.m_contactList;V;V=V.next){var z=V.contact;if(!z.m_islandFlag){var L=V.other;if(!L.isDynamic()||R.isBullet()||L.isBullet()){var F=z.m_fixtureA.m_isSensor,q=z.m_fixtureB.m_isSensor;if(!F&&!q){var k=L.m_sweep.clone();0==L.m_islandFlag&&L.advance(r),z.update(i),0!=z.isEnabled()&&0!=z.isTouching()?(z.m_islandFlag=!0,this.addContact(z),L.m_islandFlag||(L.m_islandFlag=!0,L.isStatic()||L.setAwake(!0),this.addBody(L))):(L.m_sweep.set(k),L.synchronizeTransform())}}}}}u.reset((1-r)*t.dt),u.dtRatio=1,u.positionIterations=20,u.velocityIterations=t.velocityIterations,u.warmStarting=!1,this.solveIslandTOI(u,y,d);for(T=0;T<this.m_bodies.length;++T){var R;if((R=this.m_bodies[T]).m_islandFlag=!1,R.isDynamic()){R.synchronizeFixtures();for(V=R.m_contactList;V;V=V.next)V.contact.m_toiFlag=!1,V.contact.m_islandFlag=!1}}if(i.findNewContacts(),i.m_subStepping){i.m_stepComplete=!1;break}}else s.setEnabled(!1),y.m_sweep.set(M),d.m_sweep.set(I),y.synchronizeTransform(),d.synchronizeTransform()}},s.prototype.solveIslandTOI=function(t,i,o){this.m_world;for(var e=0;e<this.m_bodies.length;++e){(_=this.m_bodies[e]).c_position.c.set(_.m_sweep.c),_.c_position.a=_.m_sweep.a,_.c_velocity.v.set(_.m_linearVelocity),_.c_velocity.w=_.m_angularVelocity}for(e=0;e<this.m_contacts.length;++e){this.m_contacts[e].initConstraint(t)}for(e=0;e<t.positionIterations;++e){for(var s=0,r=0;r<this.m_contacts.length;++r){var h=this.m_contacts[r].solvePositionConstraintTOI(t,i,o);s=a.min(s,h)}if(s>=-1.5*n.linearSlop)break}i.m_sweep.c0.set(i.c_position.c),i.m_sweep.a0=i.c_position.a,o.m_sweep.c0.set(o.c_position.c),o.m_sweep.a0=o.c_position.a;for(e=0;e<this.m_contacts.length;++e){this.m_contacts[e].initVelocityConstraint(t)}for(e=0;e<t.velocityIterations;++e)for(r=0;r<this.m_contacts.length;++r){this.m_contacts[r].solveVelocityConstraint(t)}var c=t.dt;for(e=0;e<this.m_bodies.length;++e){var _=this.m_bodies[e],l=m.clone(_.c_position.c),u=_.c_position.a,p=m.clone(_.c_velocity.v),y=_.c_velocity.w,d=m.mul(c,p);if(m.dot(d,d)>n.maxTranslationSquared){var v=n.maxTranslation/d.length();p.mul(v)}var f=c*y;if(f*f>n.maxRotationSquared){y*=v=n.maxRotation/a.abs(f)}l.wAdd(c,p),u+=c*y,_.c_position.c=l,_.c_position.a=u,_.c_velocity.v=p,_.c_velocity.w=y,_.m_sweep.c=l,_.m_sweep.a=u,_.m_linearVelocity=p,_.m_angularVelocity=y,_.synchronizeTransform()}this.postSolveIsland()},s.prototype.postSolveIsland=function(){for(var t=new function(){this.normalImpulses=[],this.tangentImpulses=[]},i=0;i<this.m_contacts.length;++i){for(var o=this.m_contacts[i],e=0;e<o.v_points.length;++e)t.normalImpulses.push(o.v_points[e].normalImpulse),t.tangentImpulses.push(o.v_points[e].tangentImpulse);this.m_world.postSolve(o,t)}}},{"./Body":2,"./Contact":3,"./Joint":5,"./Settings":7,"./collision/Distance":13,"./collision/TimeOfImpact":15,"./common/Math":18,"./common/Vec2":23,"./util/common":50}],10:[function(t,i,o){function e(t){if(!(this instanceof e))return new e(t);t&&n.isValid(t)&&(t={gravity:t}),t=s(t,c),this.m_solver=new m(this),this.m_broadPhase=new r,this.m_contactList=null,this.m_contactCount=0,this.m_bodyList=null,this.m_bodyCount=0,this.m_jointList=null,this.m_jointCount=0,this.m_stepComplete=!0,this.m_allowSleep=t.allowSleep,this.m_gravity=n.clone(t.gravity),this.m_clearForces=!0,this.m_newFixture=!1,this.m_locked=!1,this.m_warmStarting=t.warmStarting,this.m_continuousPhysics=t.continuousPhysics,this.m_subStepping=t.subStepping,this.m_blockSolve=t.blockSolve,this.m_velocityIterations=t.velocityIterations,this.m_positionIterations=t.positionIterations,this.m_t=0,this.m_stepCount=0,this.addPair=this.createContact.bind(this)}i.exports=e;var s=t("./util/options"),n=(t("./util/common"),t("./common/Vec2")),r=t("./collision/BroadPhase"),m=t("./Solver"),a=t("./Body"),h=t("./Contact"),c={gravity:n.zero(),allowSleep:!0,warmStarting:!0,continuousPhysics:!0,subStepping:!1,blockSolve:!0,velocityIterations:8,positionIterations:3};e.prototype.getBodyList=function(){return this.m_bodyList},e.prototype.getJointList=function(){return this.m_jointList},e.prototype.getContactList=function(){return this.m_contactList},e.prototype.getBodyCount=function(){return this.m_bodyCount},e.prototype.getJointCount=function(){return this.m_jointCount},e.prototype.getContactCount=function(){return this.m_contactCount},e.prototype.setGravity=function(t){this.m_gravity=t},e.prototype.getGravity=function(){return this.m_gravity},e.prototype.isLocked=function(){return this.m_locked},e.prototype.setAllowSleeping=function(t){if(t!=this.m_allowSleep&&(this.m_allowSleep=t,0==this.m_allowSleep))for(var i=this.m_bodyList;i;i=i.m_next)i.setAwake(!0)},e.prototype.getAllowSleeping=function(){return this.m_allowSleep},e.prototype.setWarmStarting=function(t){this.m_warmStarting=t},e.prototype.getWarmStarting=function(){return this.m_warmStarting},e.prototype.setContinuousPhysics=function(t){this.m_continuousPhysics=t},e.prototype.getContinuousPhysics=function(){return this.m_continuousPhysics},e.prototype.setSubStepping=function(t){this.m_subStepping=t},e.prototype.getSubStepping=function(){return this.m_subStepping},e.prototype.setAutoClearForces=function(t){this.m_clearForces=t},e.prototype.getAutoClearForces=function(){return this.m_clearForces},e.prototype.clearForces=function(){for(var t=this.m_bodyList;t;t=t.getNext())t.m_force.setZero(),t.m_torque=0},e.prototype.queryAABB=function(t,i){var o=this.m_broadPhase;this.m_broadPhase.query(t,function(t){var e=o.getUserData(t);return i(e.fixture)})},e.prototype.rayCast=function(t,i,o){var e=this.m_broadPhase;this.m_broadPhase.rayCast({maxFraction:1,p1:t,p2:i},function(t,i){var s=e.getUserData(i),r=s.fixture,m=s.childIndex,a={};if(r.rayCast(a,t,m)){var h=a.fraction,c=n.add(n.mul(1-h,t.p1),n.mul(h,t.p2));return o(r,c,a.normal,h)}return t.maxFraction})},e.prototype.getProxyCount=function(){return this.m_broadPhase.getProxyCount()},e.prototype.getTreeHeight=function(){return this.m_broadPhase.getTreeHeight()},e.prototype.getTreeBalance=function(){return this.m_broadPhase.getTreeBalance()},e.prototype.getTreeQuality=function(){return this.m_broadPhase.getTreeQuality()},e.prototype.shiftOrigin=function(t){if(!this.m_locked){for(var i=this.m_bodyList;i;i=i.m_next)i.m_xf.p.sub(t),i.m_sweep.c0.sub(t),i.m_sweep.c.sub(t);for(var o=this.m_jointList;o;o=o.m_next)o.shiftOrigin(t);this.m_broadPhase.shiftOrigin(t)}},e.prototype.createBody=function(t,i){if(this.isLocked())return null;t&&n.isValid(t)&&(t={position:t,angle:i});var o=new a(this,t);return o.m_prev=null,o.m_next=this.m_bodyList,this.m_bodyList&&(this.m_bodyList.m_prev=o),this.m_bodyList=o,++this.m_bodyCount,o},e.prototype.createDynamicBody=function(t,i){return t?n.isValid(t)&&(t={position:t,angle:i}):t={},t.type="dynamic",this.createBody(t)},e.prototype.createKinematicBody=function(t,i){return t?n.isValid(t)&&(t={position:t,angle:i}):t={},t.type="kinematic",this.createBody(t)},e.prototype.destroyBody=function(t){if(!this.isLocked()){if(t.m_destroyed)return!1;for(var i=t.m_jointList;i;){var o=i;i=i.next,this.publish("remove-joint",o.joint),this.destroyJoint(o.joint),t.m_jointList=i}t.m_jointList=null;for(var e=t.m_contactList;e;){var s=e;e=e.next,this.destroyContact(s.contact),t.m_contactList=e}t.m_contactList=null;for(var n=t.m_fixtureList;n;){var r=n;n=n.m_next,this.publish("remove-fixture",r),r.destroyProxies(this.m_broadPhase),t.m_fixtureList=n}return t.m_fixtureList=null,t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_bodyList&&(this.m_bodyList=t.m_next),t.m_destroyed=!0,--this.m_bodyCount,!0}},e.prototype.createJoint=function(t){if(this.isLocked())return null;if(t.m_prev=null,t.m_next=this.m_jointList,this.m_jointList&&(this.m_jointList.m_prev=t),this.m_jointList=t,++this.m_jointCount,t.m_edgeA.joint=t,t.m_edgeA.other=t.m_bodyB,t.m_edgeA.prev=null,t.m_edgeA.next=t.m_bodyA.m_jointList,t.m_bodyA.m_jointList&&(t.m_bodyA.m_jointList.prev=t.m_edgeA),t.m_bodyA.m_jointList=t.m_edgeA,t.m_edgeB.joint=t,t.m_edgeB.other=t.m_bodyA,t.m_edgeB.prev=null,t.m_edgeB.next=t.m_bodyB.m_jointList,t.m_bodyB.m_jointList&&(t.m_bodyB.m_jointList.prev=t.m_edgeB),t.m_bodyB.m_jointList=t.m_edgeB,0==t.m_collideConnected)for(var i=t.m_bodyB.getContactList();i;i=i.next)i.other==t.m_bodyA&&i.contact.flagForFiltering();return t},e.prototype.destroyJoint=function(t){if(!this.isLocked()){t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_jointList&&(this.m_jointList=t.m_next);var i=t.m_bodyA,o=t.m_bodyB;if(i.setAwake(!0),o.setAwake(!0),t.m_edgeA.prev&&(t.m_edgeA.prev.next=t.m_edgeA.next),t.m_edgeA.next&&(t.m_edgeA.next.prev=t.m_edgeA.prev),t.m_edgeA==i.m_jointList&&(i.m_jointList=t.m_edgeA.next),t.m_edgeA.prev=null,t.m_edgeA.next=null,t.m_edgeB.prev&&(t.m_edgeB.prev.next=t.m_edgeB.next),t.m_edgeB.next&&(t.m_edgeB.next.prev=t.m_edgeB.prev),t.m_edgeB==o.m_jointList&&(o.m_jointList=t.m_edgeB.next),t.m_edgeB.prev=null,t.m_edgeB.next=null,--this.m_jointCount,0==t.m_collideConnected)for(var e=o.getContactList();e;)e.other==i&&e.contact.flagForFiltering(),e=e.next;this.publish("remove-joint",t)}};var _=new m.TimeStep;e.prototype.step=function(t,i,o){if((0|i)!==i&&(i=0),i=i||this.m_velocityIterations,o=o||this.m_positionIterations,this.m_stepCount++,this.m_newFixture&&(this.findNewContacts(),this.m_newFixture=!1),this.m_locked=!0,_.reset(t),_.velocityIterations=i,_.positionIterations=o,_.warmStarting=this.m_warmStarting,_.blockSolve=this.m_blockSolve,this.updateContacts(),this.m_stepComplete&&t>0){this.m_solver.solveWorld(_);for(var e=this.m_bodyList;e;e=e.getNext())0!=e.m_islandFlag&&(e.isStatic()||e.synchronizeFixtures());this.findNewContacts()}this.m_continuousPhysics&&t>0&&this.m_solver.solveWorldTOI(_),this.m_clearForces&&this.clearForces(),this.m_locked=!1},e.prototype.findNewContacts=function(){this.m_broadPhase.updatePairs(this.addPair)},e.prototype.createContact=function(t,i){var o=t.fixture,e=i.fixture,s=t.childIndex,n=i.childIndex,r=o.getBody(),m=e.getBody();if(r!=m){for(var a=m.getContactList();a;){if(a.other==r){var c=a.contact.getFixtureA(),_=a.contact.getFixtureB(),l=a.contact.getChildIndexA(),u=a.contact.getChildIndexB();if(c==o&&_==e&&l==s&&u==n)return;if(c==e&&_==o&&l==n&&u==s)return}a=a.next}if(0!=m.shouldCollide(r)&&0!=e.shouldCollide(o)){var p=h.create(o,s,e,n);null!=p&&(p.m_prev=null,null!=this.m_contactList&&(p.m_next=this.m_contactList,this.m_contactList.m_prev=p),this.m_contactList=p,++this.m_contactCount)}}},e.prototype.updateContacts=function(){for(var t,i=this.m_contactList;t=i;){i=t.getNext();var o=t.getFixtureA(),e=t.getFixtureB(),s=t.getChildIndexA(),n=t.getChildIndexB(),r=o.getBody(),m=e.getBody();if(t.m_filterFlag){if(0==m.shouldCollide(r)){this.destroyContact(t);continue}if(0==e.shouldCollide(o)){this.destroyContact(t);continue}t.m_filterFlag=!1}var a=r.isAwake()&&!r.isStatic(),h=m.isAwake()&&!m.isStatic();if(0!=a||0!=h){var c=o.m_proxies[s].proxyId,_=e.m_proxies[n].proxyId;0!=this.m_broadPhase.testOverlap(c,_)?t.update(this):this.destroyContact(t)}}},e.prototype.destroyContact=function(t){h.destroy(t,this),t.m_prev&&(t.m_prev.m_next=t.m_next),t.m_next&&(t.m_next.m_prev=t.m_prev),t==this.m_contactList&&(this.m_contactList=t.m_next),--this.m_contactCount},e.prototype._listeners=null,e.prototype.on=function(t,i){return"string"!=typeof t||"function"!=typeof i?this:(this._listeners||(this._listeners={}),this._listeners[t]||(this._listeners[t]=[]),this._listeners[t].push(i),this)},e.prototype.off=function(t,i){if("string"!=typeof t||"function"!=typeof i)return this;var o=this._listeners&&this._listeners[t];if(!o||!o.length)return this;var e=o.indexOf(i);return e>=0&&o.splice(e,1),this},e.prototype.publish=function(t,i,o,e){var s=this._listeners&&this._listeners[t];if(!s||!s.length)return 0;for(var n=0;n<s.length;n++)s[n].call(this,i,o,e);return s.length},e.prototype.beginContact=function(t){this.publish("begin-contact",t)},e.prototype.endContact=function(t){this.publish("end-contact",t)},e.prototype.preSolve=function(t,i){this.publish("pre-solve",t,i)},e.prototype.postSolve=function(t,i){this.publish("post-solve",t,i)}},{"./Body":2,"./Contact":3,"./Solver":9,"./collision/BroadPhase":12,"./common/Vec2":23,"./util/common":50,"./util/options":52}],11:[function(t,i,o){function e(t,i){if(!(this instanceof e))return new e(t,i);this.lowerBound=n.zero(),this.upperBound=n.zero(),"object"==typeof t&&this.lowerBound.set(t),"object"==typeof i&&this.upperBound.set(i)}t("../Settings");var s=t("../common/Math"),n=t("../common/Vec2");i.exports=e,e.prototype.isValid=function(){return e.isValid(this)},e.isValid=function(t){var i=n.sub(t.upperBound,t.lowerBound);return i.x>=0&&i.y>=0&&n.isValid(t.lowerBound)&&n.isValid(t.upperBound)},e.prototype.getCenter=function(){return n.neo(.5*(this.lowerBound.x+this.upperBound.x),.5*(this.lowerBound.y+this.upperBound.y))},e.prototype.getExtents=function(){return n.neo(.5*(this.upperBound.x-this.lowerBound.x),.5*(this.upperBound.y-this.lowerBound.y))},e.prototype.getPerimeter=function(){return 2*(this.upperBound.x-this.lowerBound.x+this.upperBound.y-this.lowerBound.y)},e.prototype.combine=function(t,i){i=i||this,this.lowerBound.set(s.min(t.lowerBound.x,i.lowerBound.x),s.min(t.lowerBound.y,i.lowerBound.y)),this.upperBound.set(s.max(t.upperBound.x,i.upperBound.x),s.max(t.upperBound.y,i.upperBound.y))},e.prototype.combinePoints=function(t,i){this.lowerBound.set(s.min(t.x,i.x),s.min(t.y,i.y)),this.upperBound.set(s.max(t.x,i.x),s.max(t.y,i.y))},e.prototype.set=function(t){this.lowerBound.set(t.lowerBound.x,t.lowerBound.y),this.upperBound.set(t.upperBound.x,t.upperBound.y)},e.prototype.contains=function(t){var i=!0;return i=i&&this.lowerBound.x<=t.lowerBound.x,i=i&&this.lowerBound.y<=t.lowerBound.y,i=i&&t.upperBound.x<=this.upperBound.x,i=i&&t.upperBound.y<=this.upperBound.y},e.prototype.extend=function(t){e.extend(this,t)},e.extend=function(t,i){t.lowerBound.x-=i,t.lowerBound.y-=i,t.upperBound.x+=i,t.upperBound.y+=i},e.testOverlap=function(t,i){var o=i.lowerBound.x-t.upperBound.x,e=t.lowerBound.x-i.upperBound.x,s=i.lowerBound.y-t.upperBound.y,n=t.lowerBound.y-i.upperBound.y;return!(o>0||s>0||e>0||n>0)},e.areEqual=function(t,i){return n.areEqual(t.lowerBound,i.lowerBound)&&n.areEqual(t.upperBound,i.upperBound)},e.diff=function(t,i){var o=s.max(0,s.min(t.upperBound.x,i.upperBound.x)-s.max(i.lowerBound.x,t.lowerBound.x)),e=s.max(0,s.min(t.upperBound.y,i.upperBound.y)-s.max(i.lowerBound.y,t.lowerBound.y));return(t.upperBound.x-t.lowerBound.x)*(t.upperBound.y-t.lowerBound.y)+(i.upperBound.x-i.lowerBound.x)*(i.upperBound.y-i.lowerBound.y)-o*e},e.prototype.rayCast=function(t,i){for(var o=-1/0,e=1/0,r=i.p1,m=n.sub(i.p2,i.p1),a=n.abs(m),h=n.zero(),c="x";null!==c;c="x"===c?"y":null)if(a.x<s.EPSILON){if(r[c]<this.lowerBound[c]||this.upperBound[c]<r[c])return!1}else{var _=1/m[c],l=(this.lowerBound[c]-r[c])*_,u=(this.upperBound[c]-r[c])*_,p=-1;if(l>u){var y=l;l=u,u=y,p=1}if(l>o&&(h.setZero(),h[c]=p,o=l),e=s.min(e,u),o>e)return!1}return!(o<0||i.maxFraction<o)&&(t.fraction=o,t.normal=h,!0)},e.prototype.toString=function(){return JSON.stringify(this)}},{"../Settings":7,"../common/Math":18,"../common/Vec2":23}],12:[function(t,i,o){function e(){this.m_tree=new r,this.m_proxyCount=0,this.m_moveBuffer=[],this.queryCallback=this.queryCallback.bind(this)}t("../Settings"),t("../util/common");var s=t("../common/Math"),n=t("./AABB"),r=t("./DynamicTree");i.exports=e,e.prototype.getUserData=function(t){return this.m_tree.getUserData(t)},e.prototype.testOverlap=function(t,i){var o=this.m_tree.getFatAABB(t),e=this.m_tree.getFatAABB(i);return n.testOverlap(o,e)},e.prototype.getFatAABB=function(t){return this.m_tree.getFatAABB(t)},e.prototype.getProxyCount=function(){return this.m_proxyCount},e.prototype.getTreeHeight=function(){return this.m_tree.getHeight()},e.prototype.getTreeBalance=function(){return this.m_tree.getMaxBalance()},e.prototype.getTreeQuality=function(){return this.m_tree.getAreaRatio()},e.prototype.query=function(t,i){this.m_tree.query(t,i)},e.prototype.rayCast=function(t,i){this.m_tree.rayCast(t,i)},e.prototype.shiftOrigin=function(t){this.m_tree.shiftOrigin(t)},e.prototype.createProxy=function(t,i){var o=this.m_tree.createProxy(t,i);return this.m_proxyCount++,this.bufferMove(o),o},e.prototype.destroyProxy=function(t){this.unbufferMove(t),this.m_proxyCount--,this.m_tree.destroyProxy(t)},e.prototype.moveProxy=function(t,i,o){this.m_tree.moveProxy(t,i,o)&&this.bufferMove(t)},e.prototype.touchProxy=function(t){this.bufferMove(t)},e.prototype.bufferMove=function(t){this.m_moveBuffer.push(t)},e.prototype.unbufferMove=function(t){for(var i=0;i<this.m_moveBuffer.length;++i)this.m_moveBuffer[i]==t&&(this.m_moveBuffer[i]=null)},e.prototype.updatePairs=function(t){for(this.m_callback=t;this.m_moveBuffer.length>0;)if(this.m_queryProxyId=this.m_moveBuffer.pop(),null!==this.m_queryProxyId){var i=this.m_tree.getFatAABB(this.m_queryProxyId);this.m_tree.query(i,this.queryCallback)}},e.prototype.queryCallback=function(t){if(t==this.m_queryProxyId)return!0;var i=s.min(t,this.m_queryProxyId),o=s.max(t,this.m_queryProxyId),e=this.m_tree.getUserData(i),n=this.m_tree.getUserData(o);return this.m_callback(e,n),!0}},{"../Settings":7,"../common/Math":18,"../util/common":50,"./AABB":11,"./DynamicTree":14}],13:[function(t,i,o){function e(){this.proxyA=new m,this.proxyB=new m,this.transformA=null,this.transformB=null,this.useRadii=!1}function s(){this.pointA=u.zero(),this.pointB=u.zero(),this.distance,this.iterations}function n(){this.metric=0,this.indexA=[],this.indexB=[],this.count=0}function r(t,i,o){++_.gjkCalls;var e=o.proxyA,s=o.proxyB,n=o.transformA,r=o.transformB,m=new h;m.readCache(i,e,n,s,r);for(var a=m.m_v,d=c.maxDistnceIterations,v=[],f=[],x=0,A=0;A<d;){x=m.m_count;for(var g=0;g<x;++g)v[g]=a[g].indexA,f[g]=a[g].indexB;if(m.solve(),3==m.m_count)break;(I=m.getClosestPoint()).lengthSquared();var b=m.getSearchDirection();if(b.lengthSquared()<l.EPSILON*l.EPSILON)break;var B=a[m.m_count];B.indexA=e.getSupport(p.mulT(n.q,u.neg(b))),B.wA=y.mul(n,e.getVertex(B.indexA)),B.indexB=s.getSupport(p.mulT(r.q,b)),B.wB=y.mul(r,s.getVertex(B.indexB)),B.w=u.sub(B.wB,B.wA),++A,++_.gjkIters;var w=!1;for(g=0;g<x;++g)if(B.indexA==v[g]&&B.indexB==f[g]){w=!0;break}if(w)break;++m.m_count}if(_.gjkMaxIters=l.max(_.gjkMaxIters,A),m.getWitnessPoints(t.pointA,t.pointB),t.distance=u.distance(t.pointA,t.pointB),t.iterations=A,m.writeCache(i),o.useRadii){var S=e.m_radius,C=s.m_radius;if(t.distance>S+C&&t.distance>l.EPSILON){t.distance-=S+C;var M=u.sub(t.pointB,t.pointA);M.normalize(),t.pointA.wAdd(S,M),t.pointB.wSub(C,M)}else{var I=u.mid(t.pointA,t.pointB);t.pointA.set(I),t.pointB.set(I),t.distance=0}}}function m(){this.m_buffer=[],this.m_vertices=[],this.m_count=0,this.m_radius=0}function a(){this.indexA,this.indexB,this.wA=u.zero(),this.wB=u.zero(),this.w=u.zero(),this.a}function h(){this.m_v1=new a,this.m_v2=new a,this.m_v3=new a,this.m_v=[this.m_v1,this.m_v2,this.m_v3],this.m_count}i.exports=r,i.exports.Input=e,i.exports.Output=s,i.exports.Proxy=m,i.exports.Cache=n;var c=t("../Settings"),_=(t("../util/common"),t("../common/stats")),l=t("../common/Math"),u=t("../common/Vec2"),p=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),y=(t("../common/Sweep"),t("../common/Transform"));t("../common/Velocity"),t("../common/Position");_.gjkCalls=0,_.gjkIters=0,_.gjkMaxIters=0,m.prototype.getVertexCount=function(){return this.m_count},m.prototype.getVertex=function(t){return this.m_vertices[t]},m.prototype.getSupport=function(t){for(var i=0,o=u.dot(this.m_vertices[0],t),e=0;e<this.m_count;++e){var s=u.dot(this.m_vertices[e],t);s>o&&(i=e,o=s)}return i},m.prototype.getSupportVertex=function(t){return this.m_vertices[this.getSupport(t)]},m.prototype.set=function(t,i){t.computeDistanceProxy(this,i)},a.prototype.set=function(t){this.indexA=t.indexA,this.indexB=t.indexB,this.wA=u.clone(t.wA),this.wB=u.clone(t.wB),this.w=u.clone(t.w),this.a=t.a},h.prototype.print=function(){return 3==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y,this.m_v3.a,this.m_v3.wA.x,this.m_v3.wA.y,this.m_v3.wB.x,this.m_v3.wB.y].toString():2==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y,this.m_v2.a,this.m_v2.wA.x,this.m_v2.wA.y,this.m_v2.wB.x,this.m_v2.wB.y].toString():1==this.m_count?["+"+this.m_count,this.m_v1.a,this.m_v1.wA.x,this.m_v1.wA.y,this.m_v1.wB.x,this.m_v1.wB.y].toString():"+"+this.m_count},h.prototype.readCache=function(t,i,o,e,s){this.m_count=t.count;for(var n=0;n<this.m_count;++n){(c=this.m_v[n]).indexA=t.indexA[n],c.indexB=t.indexB[n];var r=i.getVertex(c.indexA),m=e.getVertex(c.indexB);c.wA=y.mul(o,r),c.wB=y.mul(s,m),c.w=u.sub(c.wB,c.wA),c.a=0}if(this.m_count>1){var a=t.metric,h=this.getMetric();(h<.5*a||2*a<h||h<l.EPSILON)&&(this.m_count=0)}if(0==this.m_count){var c;(c=this.m_v[0]).indexA=0,c.indexB=0;r=i.getVertex(0),m=e.getVertex(0);c.wA=y.mul(o,r),c.wB=y.mul(s,m),c.w=u.sub(c.wB,c.wA),c.a=1,this.m_count=1}},h.prototype.writeCache=function(t){t.metric=this.getMetric(),t.count=this.m_count;for(var i=0;i<this.m_count;++i)t.indexA[i]=this.m_v[i].indexA,t.indexB[i]=this.m_v[i].indexB},h.prototype.getSearchDirection=function(){switch(this.m_count){case 1:return u.neg(this.m_v1.w);case 2:var t=u.sub(this.m_v2.w,this.m_v1.w);return u.cross(t,u.neg(this.m_v1.w))>0?u.cross(1,t):u.cross(t,1);default:return u.zero()}},h.prototype.getClosestPoint=function(){switch(this.m_count){case 0:return u.zero();case 1:return u.clone(this.m_v1.w);case 2:return u.wAdd(this.m_v1.a,this.m_v1.w,this.m_v2.a,this.m_v2.w);case 3:default:return u.zero()}},h.prototype.getWitnessPoints=function(t,i){switch(this.m_count){case 0:break;case 1:t.set(this.m_v1.wA),i.set(this.m_v1.wB);break;case 2:t.wSet(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),i.wSet(this.m_v1.a,this.m_v1.wB,this.m_v2.a,this.m_v2.wB);break;case 3:t.wSet(this.m_v1.a,this.m_v1.wA,this.m_v2.a,this.m_v2.wA),t.wAdd(this.m_v3.a,this.m_v3.wA),i.set(t)}},h.prototype.getMetric=function(){switch(this.m_count){case 0:case 1:return 0;case 2:return u.distance(this.m_v1.w,this.m_v2.w);case 3:return u.cross(u.sub(this.m_v2.w,this.m_v1.w),u.sub(this.m_v3.w,this.m_v1.w));default:return 0}},h.prototype.solve=function(){switch(this.m_count){case 1:break;case 2:this.solve2();break;case 3:this.solve3()}},h.prototype.solve2=function(){var t=this.m_v1.w,i=this.m_v2.w,o=u.sub(i,t),e=-u.dot(t,o);if(e<=0)return this.m_v1.a=1,void(this.m_count=1);var s=u.dot(i,o);if(s<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);var n=1/(s+e);this.m_v1.a=s*n,this.m_v2.a=e*n,this.m_count=2},h.prototype.solve3=function(){var t=this.m_v1.w,i=this.m_v2.w,o=this.m_v3.w,e=u.sub(i,t),s=u.dot(t,e),n=u.dot(i,e),r=-s,m=u.sub(o,t),a=u.dot(t,m),h=u.dot(o,m),c=-a,_=u.sub(o,i),l=u.dot(i,_),p=u.dot(o,_),y=-l,d=u.cross(e,m),v=d*u.cross(i,o),f=d*u.cross(o,t),x=d*u.cross(t,i);if(r<=0&&c<=0)return this.m_v1.a=1,void(this.m_count=1);if(n>0&&r>0&&x<=0){var A=1/(n+r);return this.m_v1.a=n*A,this.m_v2.a=r*A,void(this.m_count=2)}if(h>0&&c>0&&f<=0){var g=1/(h+c);return this.m_v1.a=h*g,this.m_v3.a=c*g,this.m_count=2,void this.m_v2.set(this.m_v3)}if(n<=0&&y<=0)return this.m_v2.a=1,this.m_count=1,void this.m_v1.set(this.m_v2);if(h<=0&&p<=0)return this.m_v3.a=1,this.m_count=1,void this.m_v1.set(this.m_v3);if(p>0&&y>0&&v<=0){var b=1/(p+y);return this.m_v2.a=p*b,this.m_v3.a=y*b,this.m_count=2,void this.m_v1.set(this.m_v3)}var B=1/(v+f+x);this.m_v1.a=v*B,this.m_v2.a=f*B,this.m_v3.a=x*B,this.m_count=3},r.testOverlap=function(t,i,o,m,a,h){var c=new e;c.proxyA.set(t,i),c.proxyB.set(o,m),c.transformA=a,c.transformB=h,c.useRadii=!0;var _=new n,u=new s;return r(u,_,c),u.distance<10*l.EPSILON}},{"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../common/stats":26,"../util/common":50}],14:[function(t,i,o){function e(t){this.id=t,this.aabb=new h,this.userData=null,this.parent=null,this.child1=null,this.child2=null,this.height=-1,this.toString=function(){return this.id+": "+this.userData}}function s(){this.m_root=null,this.m_nodes={},this.m_lastProxyId=0,this.m_pool=new r({create:function(){return new e}})}var n=t("../Settings"),r=(t("../util/common"),t("../util/Pool")),m=t("../common/Vec2"),a=t("../common/Math"),h=t("./AABB");i.exports=s,e.prototype.isLeaf=function(){return null==this.child1},s.prototype.getUserData=function(t){var i=this.m_nodes[t];return i.userData},s.prototype.getFatAABB=function(t){var i=this.m_nodes[t];return i.aabb},s.prototype.allocateNode=function(){var t=this.m_pool.allocate();return t.id=++this.m_lastProxyId,t.userData=null,t.parent=null,t.child1=null,t.child2=null,t.height=-1,this.m_nodes[t.id]=t,t},s.prototype.freeNode=function(t){this.m_pool.release(t),t.height=-1,delete this.m_nodes[t.id]},s.prototype.createProxy=function(t,i){var o=this.allocateNode();return o.aabb.set(t),h.extend(o.aabb,n.aabbExtension),o.userData=i,o.height=0,this.insertLeaf(o),o.id},s.prototype.destroyProxy=function(t){var i=this.m_nodes[t];this.removeLeaf(i),this.freeNode(i)},s.prototype.moveProxy=function(t,i,o){var e=this.m_nodes[t];return!e.aabb.contains(i)&&(this.removeLeaf(e),e.aabb.set(i),i=e.aabb,h.extend(i,n.aabbExtension),o.x<0?i.lowerBound.x+=o.x*n.aabbMultiplier:i.upperBound.x+=o.x*n.aabbMultiplier,o.y<0?i.lowerBound.y+=o.y*n.aabbMultiplier:i.upperBound.y+=o.y*n.aabbMultiplier,this.insertLeaf(e),!0)},s.prototype.insertLeaf=function(t){if(null==this.m_root)return this.m_root=t,void(this.m_root.parent=null);for(var i=t.aabb,o=this.m_root;0==o.isLeaf();){var e=o.child1,s=o.child2,n=o.aabb.getPerimeter(),r=new h;r.combine(o.aabb,i);var m,c=r.getPerimeter(),_=2*c,l=2*(c-n);if(e.isLeaf()){(y=new h).combine(i,e.aabb),m=y.getPerimeter()+l}else{(y=new h).combine(i,e.aabb);var u=e.aabb.getPerimeter();m=y.getPerimeter()-u+l}var p;if(s.isLeaf()){(y=new h).combine(i,s.aabb),p=y.getPerimeter()+l}else{var y;(y=new h).combine(i,s.aabb);u=s.aabb.getPerimeter();p=y.getPerimeter()-u+l}if(_<m&&_<p)break;o=m<p?e:s}var d=o,v=d.parent,f=this.allocateNode();for(f.parent=v,f.userData=null,f.aabb.combine(i,d.aabb),f.height=d.height+1,null!=v?(v.child1==d?v.child1=f:v.child2=f,f.child1=d,f.child2=t,d.parent=f,t.parent=f):(f.child1=d,f.child2=t,d.parent=f,t.parent=f,this.m_root=f),o=t.parent;null!=o;){e=(o=this.balance(o)).child1,s=o.child2;o.height=1+a.max(e.height,s.height),o.aabb.combine(e.aabb,s.aabb),o=o.parent}},s.prototype.removeLeaf=function(t){if(t!=this.m_root){var i,o=t.parent,e=o.parent;if(i=o.child1==t?o.child2:o.child1,null!=e){e.child1==o?e.child1=i:e.child2=i,i.parent=e,this.freeNode(o);for(var s=e;null!=s;){var n=(s=this.balance(s)).child1,r=s.child2;s.aabb.combine(n.aabb,r.aabb),s.height=1+a.max(n.height,r.height),s=s.parent}}else this.m_root=i,i.parent=null,this.freeNode(o)}else this.m_root=null},s.prototype.balance=function(t){var i=t;if(i.isLeaf()||i.height<2)return t;var o=i.child1,e=i.child2,s=e.height-o.height;if(s>1){var n=e.child1,r=e.child2;return e.child1=i,e.parent=i.parent,i.parent=e,null!=e.parent?e.parent.child1==t?e.parent.child1=e:e.parent.child2=e:this.m_root=e,n.height>r.height?(e.child2=n,i.child2=r,r.parent=i,i.aabb.combine(o.aabb,r.aabb),e.aabb.combine(i.aabb,n.aabb),i.height=1+a.max(o.height,r.height),e.height=1+a.max(i.height,n.height)):(e.child2=r,i.child2=n,n.parent=i,i.aabb.combine(o.aabb,n.aabb),e.aabb.combine(i.aabb,r.aabb),i.height=1+a.max(o.height,n.height),e.height=1+a.max(i.height,r.height)),e}if(s<-1){var m=o.child1,h=o.child2;return o.child1=i,o.parent=i.parent,i.parent=o,null!=o.parent?o.parent.child1==i?o.parent.child1=o:o.parent.child2=o:this.m_root=o,m.height>h.height?(o.child2=m,i.child1=h,h.parent=i,i.aabb.combine(e.aabb,h.aabb),o.aabb.combine(i.aabb,m.aabb),i.height=1+a.max(e.height,h.height),o.height=1+a.max(i.height,m.height)):(o.child2=h,i.child1=m,m.parent=i,i.aabb.combine(e.aabb,m.aabb),o.aabb.combine(i.aabb,h.aabb),i.height=1+a.max(e.height,m.height),o.height=1+a.max(i.height,h.height)),o}return i},s.prototype.getHeight=function(){return null==this.m_root?0:this.m_root.height},s.prototype.getAreaRatio=function(){if(null==this.m_root)return 0;for(var t,i=this.m_root.aabb.getPerimeter(),o=0,e=l.allocate().preorder();t=e.next();)t.height<0||(o+=t.aabb.getPerimeter());return l.release(e),o/i},s.prototype.computeHeight=function(t){var i;if((i=void 0!==t?this.m_nodes[t]:this.m_root).isLeaf())return 0;var o=ComputeHeight(i.child1),e=ComputeHeight(i.child2);return 1+a.max(o,e)},s.prototype.validateStructure=function(t){if(null!=t){this.m_root;var i=t.child1,o=t.child2;t.isLeaf()||(this.validateStructure(i),this.validateStructure(o))}},s.prototype.validateMetrics=function(t){if(null!=t){var i=t.child1,o=t.child2;if(!t.isLeaf()){var e=this.m_nodes[i].height,s=this.m_nodes[o].height,n=(a.max(e,s),new h);n.combine(i.aabb,o.aabb),this.validateMetrics(i),this.validateMetrics(o)}}},s.prototype.validate=function(){ValidateStructure(this.m_root),ValidateMetrics(this.m_root)},s.prototype.getMaxBalance=function(){for(var t,i=0,o=l.allocate().preorder();t=o.next();)if(!(t.height<=1)){var e=a.abs(t.child2.height-t.child1.height);i=a.max(i,e)}return l.release(o),i},s.prototype.rebuildBottomUp=function(){for(var t,i=[],o=0,e=l.allocate().preorder();t=e.next();)t.height<0||(t.isLeaf()?(t.parent=null,i[o]=t,++o):this.freeNode(t));for(l.release(e);o>1;){for(var s=1/0,n=-1,r=-1,m=0;m<o;++m)for(var c=i[m].aabb,_=m+1;_<o;++_){var u=i[_].aabb,p=new h;p.combine(c,u);var y=p.getPerimeter();y<s&&(n=m,r=_,s=y)}var d=i[n],v=i[r],f=this.allocateNode();f.child1=d,f.child2=v,f.height=1+a.max(d.height,v.height),f.aabb.combine(d.aabb,v.aabb),f.parent=null,d.parent=f,v.parent=f,i[r]=i[o-1],i[n]=f,--o}this.m_root=i[0],this.validate()},s.prototype.shiftOrigin=function(t){for(var i,o=l.allocate().preorder();i=o.next();){var e=i.aabb;e.lowerBound.x-=t.x,e.lowerBound.y-=t.y,e.lowerBound.x-=t.x,e.lowerBound.y-=t.y}l.release(o)},s.prototype.query=function(t,i){var o=_.allocate();for(o.push(this.m_root);o.length>0;){var e=o.pop();if(null!=e&&h.testOverlap(e.aabb,t))if(e.isLeaf()){if(0==i(e.id))return}else o.push(e.child1),o.push(e.child2)}_.release(o)},s.prototype.rayCast=function(t,i){var o=t.p1,e=t.p2,s=m.sub(e,o);s.normalize();var n=m.cross(1,s),r=m.abs(n),l=t.maxFraction,u=new h,p=m.wAdd(1-l,o,l,e);u.combinePoints(o,p);var y=_.allocate(),d=c.allocate();for(y.push(this.m_root);y.length>0;){var v=y.pop();if(null!=v&&0!=h.testOverlap(v.aabb,u)){var f=v.aabb.getCenter(),x=v.aabb.getExtents();if(!(a.abs(m.dot(n,m.sub(o,f)))-m.dot(r,x)>0))if(v.isLeaf()){d.p1=m.clone(t.p1),d.p2=m.clone(t.p2),d.maxFraction=l;var A=i(d,v.id);if(0==A)return;A>0&&(l=A,p=m.wAdd(1-l,o,l,e),u.combinePoints(o,p))}else y.push(v.child1),y.push(v.child2)}}_.release(y),c.release(d)};var c=new r({create:function(){return{}},release:function(t){}}),_=new r({create:function(){return[]},release:function(t){t.length=0}}),l=new r({create:function(){return new function(){var t=[],i=[];return{preorder:function(o){return t.length=0,t.push(o),i.length=0,i.push(0),this},next:function(){for(;t.length>0;){var o=t.length-1,e=t[o];if(0===i[o])return i[o]=1,e;if(1===i[o]&&(i[o]=2,e.child1))return t.push(e.child1),i.push(1),e.child1;if(2===i[o]&&(i[o]=3,e.child2))return t.push(e.child2),i.push(1),e.child2;t.pop(),i.pop()}},close:function(){t.length=0}}}},release:function(t){t.close()}})},{"../Settings":7,"../common/Math":18,"../common/Vec2":23,"../util/Pool":48,"../util/common":50,"./AABB":11}],15:[function(t,i,o){function e(){this.state,this.t}function s(){this.m_proxyA=new f,this.m_proxyB=new f,this.m_sweepA,this.m_sweepB,this.m_type,this.m_localPoint=_.zero(),this.m_axis=_.zero()}var n=!1;i.exports=function(t,i){var o=a.now();++h.toiCalls,t.state=e.e_unknown,t.t=i.tMax;var _=i.proxyA,l=i.proxyB,u=i.sweepA,f=i.sweepB;u.normalize(),f.normalize();var A=i.tMax,g=_.m_radius+l.m_radius,b=c.max(r.linearSlop,g-3*r.linearSlop),B=.25*r.linearSlop;n&&m.assert(b>B);var w=0,S=r.maxTOIIterations,C=0,M=new x,I=new d;for(I.proxyA=i.proxyA,I.proxyB=i.proxyB,I.useRadii=!1;;){var P=p.identity(),T=p.identity();u.getTransform(P,w),f.getTransform(T,w),I.transformA=P,I.transformB=T;var V=new v;if(y(V,M,I),V.distance<=0){t.state=e.e_overlapped,t.t=0;break}if(V.distance<b+B){t.state=e.e_touching,t.t=w;break}var z=new s;z.initialize(M,_,u,l,f,w);for(var L=!1,F=A,q=0;;){var k=z.findMinSeparation(F);if(z.indexA,z.indexB,k>b+B){t.state=e.e_separated,t.t=A,L=!0;break}if(k>b-B){w=F;break}var R=z.evaluate(w);if(z.indexA,z.indexB,R<b-B){t.state=e.e_failed,t.t=w,L=!0;break}if(R<=b+B){t.state=e.e_touching,t.t=w,L=!0;break}for(var D=0,E=w,j=F;;){var J;J=1&D?E+(b-R)*(j-E)/(k-R):.5*(E+j),++D,++h.toiRootIters;var O=z.evaluate(J);if(z.indexA,z.indexB,c.abs(O-b)<B){F=J;break}if(O>b?(E=J,R=O):(j=J,k=O),50==D)break}if(h.toiMaxRootIters=c.max(h.toiMaxRootIters,D),++q==r.maxPolygonVertices)break}if(++C,++h.toiIters,L)break;if(C==S){t.state=e.e_failed,t.t=w;break}}h.toiMaxIters=c.max(h.toiMaxIters,C);var N=a.diff(o);h.toiMaxTime=c.max(h.toiMaxTime,N),h.toiTime+=N},i.exports.Input=function(){this.proxyA=new f,this.proxyB=new f,this.sweepA=new u,this.sweepB=new u,this.tMax},i.exports.Output=e;var r=t("../Settings"),m=t("../util/common"),a=t("../util/Timer"),h=t("../common/stats"),c=t("../common/Math"),_=t("../common/Vec2"),l=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),u=t("../common/Sweep"),p=t("../common/Transform"),y=(t("../common/Velocity"),t("../common/Position"),t("./Distance")),d=y.Input,v=y.Output,f=y.Proxy,x=y.Cache;e.e_unknown=0,e.e_failed=1,e.e_overlapped=2,e.e_touching=3,e.e_separated=4,h.toiTime=0,h.toiMaxTime=0,h.toiCalls=0,h.toiIters=0,h.toiMaxIters=0,h.toiRootIters=0,h.toiMaxRootIters=0;s.prototype.initialize=function(t,i,o,e,s,r){this.m_proxyA=i,this.m_proxyB=e;var a=t.count;n&&m.assert(0<a&&a<3),this.m_sweepA=o,this.m_sweepB=s;var h=p.identity(),c=p.identity();if(this.m_sweepA.getTransform(h,r),this.m_sweepB.getTransform(c,r),1==a){this.m_type=1;var u=this.m_proxyA.getVertex(t.indexA[0]),y=this.m_proxyB.getVertex(t.indexB[0]),d=p.mul(h,u),v=p.mul(c,y);this.m_axis.wSet(1,v,-1,d);return B=this.m_axis.normalize()}if(t.indexA[0]==t.indexA[1]){this.m_type=3;var f=e.getVertex(t.indexB[0]),x=e.getVertex(t.indexB[1]);this.m_axis=_.cross(_.sub(x,f),1),this.m_axis.normalize();var A=l.mul(c.q,this.m_axis);this.m_localPoint=_.mid(f,x);v=p.mul(c,this.m_localPoint),u=i.getVertex(t.indexA[0]),d=p.mul(h,u);return(B=_.dot(d,A)-_.dot(v,A))<0&&(this.m_axis=_.neg(this.m_axis),B=-B),B}this.m_type=2;var g=this.m_proxyA.getVertex(t.indexA[0]),b=this.m_proxyA.getVertex(t.indexA[1]);this.m_axis=_.cross(_.sub(b,g),1),this.m_axis.normalize();A=l.mul(h.q,this.m_axis);this.m_localPoint=_.mid(g,b);var B;d=p.mul(h,this.m_localPoint),y=this.m_proxyB.getVertex(t.indexB[0]),v=p.mul(c,y);return(B=_.dot(v,A)-_.dot(d,A))<0&&(this.m_axis=_.neg(this.m_axis),B=-B),B},s.prototype.compute=function(t,i){var o=p.identity(),e=p.identity();switch(this.m_sweepA.getTransform(o,i),this.m_sweepB.getTransform(e,i),this.m_type){case 1:if(t){var s=l.mulT(o.q,this.m_axis),r=l.mulT(e.q,_.neg(this.m_axis));this.indexA=this.m_proxyA.getSupport(s),this.indexB=this.m_proxyB.getSupport(r)}var a=this.m_proxyA.getVertex(this.indexA),h=this.m_proxyB.getVertex(this.indexB),c=p.mul(o,a),u=p.mul(e,h);return _.dot(u,this.m_axis)-_.dot(c,this.m_axis);case 2:var y=l.mul(o.q,this.m_axis);c=p.mul(o,this.m_localPoint);if(t){r=l.mulT(e.q,_.neg(y));this.indexA=-1,this.indexB=this.m_proxyB.getSupport(r)}h=this.m_proxyB.getVertex(this.indexB),u=p.mul(e,h);return _.dot(u,y)-_.dot(c,y);case 3:y=l.mul(e.q,this.m_axis),u=p.mul(e,this.m_localPoint);if(t){s=l.mulT(o.q,_.neg(y));this.indexB=-1,this.indexA=this.m_proxyA.getSupport(s)}a=this.m_proxyA.getVertex(this.indexA),c=p.mul(o,a);return _.dot(c,y)-_.dot(u,y);default:return n&&m.assert(!1),t&&(this.indexA=-1,this.indexB=-1),0}},s.prototype.findMinSeparation=function(t){return this.compute(!0,t)},s.prototype.evaluate=function(t){return this.compute(!1,t)}},{"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../common/stats":26,"../util/Timer":49,"../util/common":50,"./Distance":13}],16:[function(t,i,o){function e(t,i,o,e){"object"==typeof t&&null!==t?(this.ex=s.clone(t),this.ey=s.clone(i)):"number"==typeof t?(this.ex=s.neo(t,o),this.ey=s.neo(i,e)):(this.ex=s.zero(),this.ey=s.zero())}i.exports=e;t("../util/common"),t("./Math");var s=t("./Vec2");e.prototype.toString=function(){return JSON.stringify(this)},e.isValid=function(t){return t&&s.isValid(t.ex)&&s.isValid(t.ey)},e.assert=function(t){},e.prototype.set=function(t,i,o,e){"number"==typeof t&&"number"==typeof i&&"number"==typeof o&&"number"==typeof e?(this.ex.set(t,o),this.ey.set(i,e)):"object"==typeof t&&"object"==typeof i?(this.ex.set(t),this.ey.set(i)):"object"==typeof t&&(this.ex.set(t.ex),this.ey.set(t.ey))},e.prototype.setIdentity=function(){this.ex.x=1,this.ey.x=0,this.ex.y=0,this.ey.y=1},e.prototype.setZero=function(){this.ex.x=0,this.ey.x=0,this.ex.y=0,this.ey.y=0},e.prototype.getInverse=function(){var t=this.ex.x,i=this.ey.x,o=this.ex.y,s=this.ey.y,n=t*s-i*o;0!=n&&(n=1/n);var r=new e;return r.ex.x=n*s,r.ey.x=-n*i,r.ex.y=-n*o,r.ey.y=n*t,r},e.prototype.solve=function(t){var i=this.ex.x,o=this.ey.x,e=this.ex.y,n=this.ey.y,r=i*n-o*e;0!=r&&(r=1/r);var m=s.zero();return m.x=r*(n*t.x-o*t.y),m.y=r*(i*t.y-e*t.x),m},e.mul=function(t,i){if(i&&"x"in i&&"y"in i){var o=t.ex.x*i.x+t.ey.x*i.y,n=t.ex.y*i.x+t.ey.y*i.y;return s.neo(o,n)}if(i&&"ex"in i&&"ey"in i)return new e(s.mul(t,i.ex),s.mul(t,i.ey))},e.mulT=function(t,i){if(i&&"x"in i&&"y"in i)return s.neo(s.dot(i,t.ex),s.dot(i,t.ey));if(i&&"ex"in i&&"ey"in i){return new e(s.neo(s.dot(t.ex,i.ex),s.dot(t.ey,i.ex)),s.neo(s.dot(t.ex,i.ey),s.dot(t.ey,i.ey)))}},e.abs=function(t){return new e(s.abs(t.ex),s.abs(t.ey))},e.add=function(t,i){return new e(s.add(t.ex+i.ex),s.add(t.ey+i.ey))}},{"../util/common":50,"./Math":18,"./Vec2":23}],17:[function(t,i,o){function e(t,i,o){"object"==typeof t&&null!==t?(this.ex=n.clone(t),this.ey=n.clone(i),this.ez=n.clone(o)):(this.ex=n(),this.ey=n(),this.ez=n())}i.exports=e;t("../util/common"),t("./Math");var s=t("./Vec2"),n=t("./Vec3");e.prototype.toString=function(){return JSON.stringify(this)},e.isValid=function(t){return t&&n.isValid(t.ex)&&n.isValid(t.ey)&&n.isValid(t.ez)},e.assert=function(t){},e.prototype.setZero=function(){return this.ex.setZero(),this.ey.setZero(),this.ez.setZero(),this},e.prototype.solve33=function(t){var i=n.dot(this.ex,n.cross(this.ey,this.ez));0!=i&&(i=1/i);var o=new n;return o.x=i*n.dot(t,n.cross(this.ey,this.ez)),o.y=i*n.dot(this.ex,n.cross(t,this.ez)),o.z=i*n.dot(this.ex,n.cross(this.ey,t)),o},e.prototype.solve22=function(t){var i=this.ex.x,o=this.ey.x,e=this.ex.y,n=this.ey.y,r=i*n-o*e;0!=r&&(r=1/r);var m=s.zero();return m.x=r*(n*t.x-o*t.y),m.y=r*(i*t.y-e*t.x),m},e.prototype.getInverse22=function(t){var i=this.ex.x,o=this.ey.x,e=this.ex.y,s=this.ey.y,n=i*s-o*e;0!=n&&(n=1/n),t.ex.x=n*s,t.ey.x=-n*o,t.ex.z=0,t.ex.y=-n*e,t.ey.y=n*i,t.ey.z=0,t.ez.x=0,t.ez.y=0,t.ez.z=0},e.prototype.getSymInverse33=function(t){var i=n.dot(this.ex,n.cross(this.ey,this.ez));0!=i&&(i=1/i);var o=this.ex.x,e=this.ey.x,s=this.ez.x,r=this.ey.y,m=this.ez.y,a=this.ez.z;t.ex.x=i*(r*a-m*m),t.ex.y=i*(s*m-e*a),t.ex.z=i*(e*m-s*r),t.ey.x=t.ex.y,t.ey.y=i*(o*a-s*s),t.ey.z=i*(s*e-o*m),t.ez.x=t.ex.z,t.ez.y=t.ey.z,t.ez.z=i*(o*r-e*e)},e.mul=function(t,i){if(i&&"z"in i&&"y"in i&&"x"in i){var o=t.ex.x*i.x+t.ey.x*i.y+t.ez.x*i.z,e=t.ex.y*i.x+t.ey.y*i.y+t.ez.y*i.z,r=t.ex.z*i.x+t.ey.z*i.y+t.ez.z*i.z;return new n(o,e,r)}if(i&&"y"in i&&"x"in i){o=t.ex.x*i.x+t.ey.x*i.y,e=t.ex.y*i.x+t.ey.y*i.y;return s.neo(o,e)}},e.add=function(t,i){return new n(t.x+i.x,t.y+i.y,t.z+i.z)}},{"../util/common":50,"./Math":18,"./Vec2":23,"./Vec3":24}],18:[function(t,i,o){t("../util/common");var e=t("../util/create"),s=Math,n=i.exports=e(s);n.EPSILON=1e-9,n.isFinite=function(t){return"number"==typeof t&&isFinite(t)&&!isNaN(t)},n.assert=function(t){},n.invSqrt=function(t){return 1/s.sqrt(t)},n.nextPowerOfTwo=function(t){return t|=t>>1,t|=t>>2,t|=t>>4,t|=t>>8,(t|=t>>16)+1},n.isPowerOfTwo=function(t){return t>0&&0==(t&t-1)},n.mod=function(t,i,o){return void 0===i?(o=1,i=0):void 0===o&&(o=i,i=0),o>i?(t=(t-i)%(o-i))+(t<0?o:i):(t=(t-o)%(i-o))+(t<=0?i:o)},n.clamp=function(t,i,o){return t<i?i:t>o?o:t},n.random=function(t,i){return void 0===t?(i=1,t=0):void 0===i&&(i=t,t=0),t==i?t:s.random()*(i-t)+t}},{"../util/common":50,"../util/create":51}],19:[function(t,i,o){function e(){this.c=s.zero(),this.a=0}i.exports=e;var s=t("./Vec2"),n=t("./Rot");e.prototype.getTransform=function(t,i){return t.q.set(this.a),t.p.set(s.sub(this.c,n.mul(t.q,i))),t}},{"./Rot":20,"./Vec2":23}],20:[function(t,i,o){function e(t){if(!(this instanceof e))return new e(t);"number"==typeof t?this.setAngle(t):"object"==typeof t?this.set(t):this.setIdentity()}i.exports=e;t("../util/common");var s=t("./Vec2"),n=t("./Math");e.neo=function(t){var i=Object.create(e.prototype);return i.setAngle(t),i},e.clone=function(t){var i=Object.create(e.prototype);return i.s=t.s,i.c=t.c,i},e.identity=function(t){var i=Object.create(e.prototype);return i.s=0,i.c=1,i},e.isValid=function(t){return t&&n.isFinite(t.s)&&n.isFinite(t.c)},e.assert=function(t){},e.prototype.setIdentity=function(){this.s=0,this.c=1},e.prototype.set=function(t){"object"==typeof t?(this.s=t.s,this.c=t.c):(this.s=n.sin(t),this.c=n.cos(t))},e.prototype.setAngle=function(t){this.s=n.sin(t),this.c=n.cos(t)},e.prototype.getAngle=function(){return n.atan2(this.s,this.c)},e.prototype.getXAxis=function(){return s.neo(this.c,this.s)},e.prototype.getYAxis=function(){return s.neo(-this.s,this.c)},e.mul=function(t,i){if("c"in i&&"s"in i){var o=e.identity();return o.s=t.s*i.c+t.c*i.s,o.c=t.c*i.c-t.s*i.s,o}if("x"in i&&"y"in i)return s.neo(t.c*i.x-t.s*i.y,t.s*i.x+t.c*i.y)},e.mulSub=function(t,i,o){var e=t.c*(i.x-o.x)-t.s*(i.y-o.y),n=t.s*(i.x-o.y)+t.c*(i.y-o.y);return s.neo(e,n)},e.mulT=function(t,i){if("c"in i&&"s"in i){var o=e.identity();return o.s=t.c*i.s-t.s*i.c,o.c=t.c*i.c+t.s*i.s,o}if("x"in i&&"y"in i)return s.neo(t.c*i.x+t.s*i.y,-t.s*i.x+t.c*i.y)}},{"../util/common":50,"./Math":18,"./Vec2":23}],21:[function(t,i,o){function e(t,i){s&&n.assert(void 0===t),s&&n.assert(void 0===i),this.localCenter=m.zero(),this.c=m.zero(),this.a=0,this.alpha0=0,this.c0=m.zero(),this.a0=0}var s=!1;i.exports=e;var n=t("../util/common"),r=t("./Math"),m=t("./Vec2"),a=t("./Rot"),h=t("./Transform");e.prototype.setTransform=function(t){var i=h.mul(t,this.localCenter);this.c.set(i),this.c0.set(i),this.a=t.q.getAngle(),this.a0=t.q.getAngle()},e.prototype.setLocalCenter=function(t,i){this.localCenter.set(t);var o=h.mul(i,this.localCenter);this.c.set(o),this.c0.set(o)},e.prototype.getTransform=function(t,i){i=void 0===i?0:i,t.q.setAngle((1-i)*this.a0+i*this.a),t.p.wSet(1-i,this.c0,i,this.c),t.p.sub(a.mul(t.q,this.localCenter))},e.prototype.advance=function(t){s&&n.assert(this.alpha0<1);var i=(t-this.alpha0)/(1-this.alpha0);this.c0.wSet(i,this.c,1-i,this.c0),this.a0=i*this.a+(1-i)*this.a0,this.alpha0=t},e.prototype.forward=function(){this.a0=this.a,this.c0.set(this.c)},e.prototype.normalize=function(){var t=r.mod(this.a0,-r.PI,+r.PI);this.a-=this.a0-t,this.a0=t},e.prototype.clone=function(){var t=new e;return t.localCenter.set(this.localCenter),t.alpha0=this.alpha0,t.a0=this.a0,t.a=this.a,t.c0.set(this.c0),t.c.set(this.c),t},e.prototype.set=function(t){this.localCenter.set(t.localCenter),this.alpha0=t.alpha0,this.a0=t.a0,this.a=t.a,this.c0.set(t.c0),this.c.set(t.c)}},{"../util/common":50,"./Math":18,"./Rot":20,"./Transform":22,"./Vec2":23}],22:[function(t,i,o){function e(t,i){if(!(this instanceof e))return new e(t,i);this.p=s.zero(),this.q=n.identity(),void 0!==t&&this.p.set(t),void 0!==i&&this.q.set(i)}i.exports=e;t("../util/common");var s=t("./Vec2"),n=t("./Rot");e.clone=function(t){var i=Object.create(e.prototype);return i.p=s.clone(t.p),i.q=n.clone(t.q),i},e.neo=function(t,i){var o=Object.create(e.prototype);return o.p=s.clone(t),o.q=n.clone(i),o},e.identity=function(){var t=Object.create(e.prototype);return t.p=s.zero(),t.q=n.identity(),t},e.prototype.setIdentity=function(){this.p.setZero(),this.q.setIdentity()},e.prototype.set=function(t,i){e.isValid(t)?(this.p.set(t.p),this.q.set(t.q)):(this.p.set(t),this.q.set(i))},e.isValid=function(t){return t&&s.isValid(t.p)&&n.isValid(t.q)},e.assert=function(t){},e.mul=function(t,i){if(Array.isArray(i)){for(var o=[],r=0;r<i.length;r++)o[r]=e.mul(t,i[r]);return o}if("x"in i&&"y"in i){var m=t.q.c*i.x-t.q.s*i.y+t.p.x,a=t.q.s*i.x+t.q.c*i.y+t.p.y;return s.neo(m,a)}if("p"in i&&"q"in i){var h=e.identity();return h.q=n.mul(t.q,i.q),h.p=s.add(n.mul(t.q,i.p),t.p),h}},e.mulT=function(t,i){if("x"in i&&"y"in i){var o=i.x-t.p.x,r=i.y-t.p.y,m=t.q.c*o+t.q.s*r,a=-t.q.s*o+t.q.c*r;return s.neo(m,a)}if("p"in i&&"q"in i){var h=e.identity();return h.q.set(n.mulT(t.q,i.q)),h.p.set(n.mulT(t.q,s.sub(i.p,t.p))),h}}},{"../util/common":50,"./Rot":20,"./Vec2":23}],23:[function(t,i,o){function e(t,i){if(!(this instanceof e))return new e(t,i);void 0===t?(this.x=0,this.y=0):"object"==typeof t?(this.x=t.x,this.y=t.y):(this.x=t,this.y=i),s&&e.assert(this)}var s=!1;i.exports=e;var n=t("../util/common"),r=t("./Math");e.zero=function(){var t=Object.create(e.prototype);return t.x=0,t.y=0,t},e.neo=function(t,i){var o=Object.create(e.prototype);return o.x=t,o.y=i,o},e.clone=function(t,i){return s&&e.assert(t),s&&n.assert(!i),e.neo(t.x,t.y)},e.prototype.toString=function(){return JSON.stringify(this)},e.isValid=function(t){return t&&r.isFinite(t.x)&&r.isFinite(t.y)},e.assert=function(t){if(s&&!e.isValid(t))throw new Error("Invalid Vec2!")},e.prototype.clone=function(t){return e.clone(this,t)},e.prototype.setZero=function(){return this.x=0,this.y=0,this},e.prototype.set=function(t,i){return"object"==typeof t?(s&&e.assert(t),this.x=t.x,this.y=t.y):(s&&r.assert(t),s&&r.assert(i),this.x=t,this.y=i),this},e.prototype.wSet=function(t,i,o,n){s&&r.assert(t),s&&e.assert(i);var m=t*i.x,a=t*i.y;return void 0===o&&void 0===n||(s&&r.assert(o),s&&e.assert(n),m+=o*n.x,a+=o*n.y),this.x=m,this.y=a,this},e.prototype.add=function(t){return s&&e.assert(t),this.x+=t.x,this.y+=t.y,this},e.prototype.wAdd=function(t,i,o,n){s&&r.assert(t),s&&e.assert(i);var m=t*i.x,a=t*i.y;return void 0===o&&void 0===n||(s&&r.assert(o),s&&e.assert(n),m+=o*n.x,a+=o*n.y),this.x+=m,this.y+=a,this},e.prototype.wSub=function(t,i,o,n){s&&r.assert(t),s&&e.assert(i);var m=t*i.x,a=t*i.y;return void 0===o&&void 0===n||(s&&r.assert(o),s&&e.assert(n),m+=o*n.x,a+=o*n.y),this.x-=m,this.y-=a,this},e.prototype.sub=function(t){return s&&e.assert(t),this.x-=t.x,this.y-=t.y,this},e.prototype.mul=function(t){return s&&r.assert(t),this.x*=t,this.y*=t,this},e.prototype.length=function(){return e.lengthOf(this)},e.prototype.lengthSquared=function(){return e.lengthSquared(this)},e.prototype.normalize=function(){var t=this.length();if(t<r.EPSILON)return 0;var i=1/t;return this.x*=i,this.y*=i,t},e.lengthOf=function(t){return s&&e.assert(t),r.sqrt(t.x*t.x+t.y*t.y)},e.lengthSquared=function(t){return s&&e.assert(t),t.x*t.x+t.y*t.y},e.distance=function(t,i){s&&e.assert(t),s&&e.assert(i);var o=t.x-i.x,n=t.y-i.y;return r.sqrt(o*o+n*n)},e.distanceSquared=function(t,i){s&&e.assert(t),s&&e.assert(i);var o=t.x-i.x,n=t.y-i.y;return o*o+n*n},e.areEqual=function(t,i){return s&&e.assert(t),s&&e.assert(i),t==i||"object"==typeof i&&null!==i&&t.x==i.x&&t.y==i.y},e.skew=function(t){return s&&e.assert(t),e.neo(-t.y,t.x)},e.dot=function(t,i){return s&&e.assert(t),s&&e.assert(i),t.x*i.x+t.y*i.y},e.cross=function(t,i){return"number"==typeof i?(s&&e.assert(t),s&&r.assert(i),e.neo(i*t.y,-i*t.x)):"number"==typeof t?(s&&r.assert(t),s&&e.assert(i),e.neo(-t*i.y,t*i.x)):(s&&e.assert(t),s&&e.assert(i),t.x*i.y-t.y*i.x)},e.addCross=function(t,i,o){return"number"==typeof o?(s&&e.assert(i),s&&r.assert(o),e.neo(o*i.y+t.x,-o*i.x+t.y)):"number"==typeof i?(s&&r.assert(i),s&&e.assert(o),e.neo(-i*o.y+t.x,i*o.x+t.y)):void(s&&n.assert(!1))},e.add=function(t,i){return s&&e.assert(t),s&&e.assert(i),e.neo(t.x+i.x,t.y+i.y)},e.wAdd=function(t,i,o,s){var n=e.zero();return n.wAdd(t,i,o,s),n},e.sub=function(t,i){return s&&e.assert(t),s&&e.assert(i),e.neo(t.x-i.x,t.y-i.y)},e.mul=function(t,i){return"object"==typeof t?(s&&e.assert(t),s&&r.assert(i),e.neo(t.x*i,t.y*i)):"object"==typeof i?(s&&r.assert(t),s&&e.assert(i),e.neo(t*i.x,t*i.y)):void 0},e.prototype.neg=function(){return this.x=-this.x,this.y=-this.y,this},e.neg=function(t){return s&&e.assert(t),e.neo(-t.x,-t.y)},e.abs=function(t){return s&&e.assert(t),e.neo(r.abs(t.x),r.abs(t.y))},e.mid=function(t,i){return s&&e.assert(t),s&&e.assert(i),e.neo(.5*(t.x+i.x),.5*(t.y+i.y))},e.upper=function(t,i){return s&&e.assert(t),s&&e.assert(i),e.neo(r.max(t.x,i.x),r.max(t.y,i.y))},e.lower=function(t,i){return s&&e.assert(t),s&&e.assert(i),e.neo(r.min(t.x,i.x),r.min(t.y,i.y))},e.prototype.clamp=function(t){var i=this.x*this.x+this.y*this.y;if(i>t*t){var o=r.invSqrt(i);this.x*=o*t,this.y*=o*t}return this},e.clamp=function(t,i){return(t=e.neo(t.x,t.y)).clamp(i),t}},{"../util/common":50,"./Math":18}],24:[function(t,i,o){function e(t,i,o){if(!(this instanceof e))return new e(t,i,o);void 0===t?(this.x=0,this.y=0,this.z=0):"object"==typeof t?(this.x=t.x,this.y=t.y,this.z=t.z):(this.x=t,this.y=i,this.z=o),s&&e.assert(this)}var s=!1;i.exports=e;t("../util/common");var n=t("./Math");e.prototype.toString=function(){return JSON.stringify(this)},e.isValid=function(t){return t&&n.isFinite(t.x)&&n.isFinite(t.y)&&n.isFinite(t.z)},e.assert=function(t){if(s&&!e.isValid(t))throw new Error("Invalid Vec3!")},e.prototype.setZero=function(){return this.x=0,this.y=0,this.z=0,this},e.prototype.set=function(t,i,o){return this.x=t,this.y=i,this.z=o,this},e.prototype.add=function(t){return this.x+=t.x,this.y+=t.y,this.z+=t.z,this},e.prototype.sub=function(t){return this.x-=t.x,this.y-=t.y,this.z-=t.z,this},e.prototype.mul=function(t){return this.x*=t,this.y*=t,this.z*=t,this},e.areEqual=function(t,i){return t==i||"object"==typeof i&&null!==i&&t.x==i.x&&t.y==i.y&&t.z==i.z},e.dot=function(t,i){return t.x*i.x+t.y*i.y+t.z*i.z},e.cross=function(t,i){return new e(t.y*i.z-t.z*i.y,t.z*i.x-t.x*i.z,t.x*i.y-t.y*i.x)},e.add=function(t,i){return new e(t.x+i.x,t.y+i.y,t.z+i.z)},e.sub=function(t,i){return new e(t.x-i.x,t.y-i.y,t.z-i.z)},e.mul=function(t,i){return new e(i*t.x,i*t.y,i*t.z)},e.prototype.neg=function(t){return this.x=-this.x,this.y=-this.y,this.z=-this.z,this},e.neg=function(t){return new e(-t.x,-t.y,-t.z)}},{"../util/common":50,"./Math":18}],25:[function(t,i,o){i.exports=function(){this.v=e.zero(),this.w=0};var e=t("./Vec2")},{"./Vec2":23}],26:[function(t,i,o){o.toString=function(t){t="string"==typeof t?t:"\n";var i="";for(var o in this)"function"!=typeof this[o]&&"object"!=typeof this[o]&&(i+=o+": "+this[o]+t);return i}},{}],27:[function(t,i,o){function e(t,i,o,n,r){if(!(this instanceof e))return new e(t,i,o,n,r);t=s(t,_),c.call(this,t,i,n),this.m_type=e.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(o),this.m_localAnchorB=t.localAnchorB||n.getLocalPoint(r),this.m_length=a.distance(r,o),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=0,this.m_gamma=0,this.m_bias=0,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}i.exports=e;var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),m=t("../common/Math"),a=t("../common/Vec2"),h=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),c=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));e.TYPE="distance-joint";var _={frequencyHz:0,dampingRatio:0};(e.prototype=n((e._super=c).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.setLength=function(t){this.m_length=t},e.prototype.getLength=function(){return this.m_length},e.prototype.setFrequency=function(t){this.m_frequencyHz=t},e.prototype.getFrequency=function(){return this.m_frequencyHz},e.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},e.prototype.getDampingRatio=function(){return this.m_dampingRatio},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return a.mul(t*this.m_impulse,this.m_u)},e.prototype.getReactionTorque=function(t){return 0},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,c=this.m_bodyB.c_position.a,_=this.m_bodyB.c_velocity.v,l=this.m_bodyB.c_velocity.w,u=h.neo(o),p=h.neo(c);this.m_rA=h.mul(u,a.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=h.mul(p,a.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_u=a.sub(a.add(n,this.m_rB),a.add(i,this.m_rA));var y=this.m_u.length();y>r.linearSlop?this.m_u.mul(1/y):this.m_u.set(0,0);var d=a.cross(this.m_rA,this.m_u),v=a.cross(this.m_rB,this.m_u),f=this.m_invMassA+this.m_invIA*d*d+this.m_invMassB+this.m_invIB*v*v;if(this.m_mass=0!=f?1/f:0,this.m_frequencyHz>0){var x=y-this.m_length,A=2*m.PI*this.m_frequencyHz,g=2*this.m_mass*this.m_dampingRatio*A,b=this.m_mass*A*A,B=t.dt;this.m_gamma=B*(g+B*b),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=x*B*b*this.m_gamma,f+=this.m_gamma,this.m_mass=0!=f?1/f:0}else this.m_gamma=0,this.m_bias=0;if(t.warmStarting){this.m_impulse*=t.dtRatio;var w=a.mul(this.m_impulse,this.m_u);e.wSub(this.m_invMassA,w),s-=this.m_invIA*a.cross(this.m_rA,w),_.wAdd(this.m_invMassB,w),l+=this.m_invIB*a.cross(this.m_rB,w)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(e),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(_),this.m_bodyB.c_velocity.w=l},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,e=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=a.add(i,a.cross(o,this.m_rA)),r=a.add(e,a.cross(s,this.m_rB)),m=a.dot(this.m_u,r)-a.dot(this.m_u,n),h=-this.m_mass*(m+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=h;var c=a.mul(h,this.m_u);i.wSub(this.m_invMassA,c),o-=this.m_invIA*a.cross(this.m_rA,c),e.wAdd(this.m_invMassB,c),s+=this.m_invIB*a.cross(this.m_rB,c),this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v.set(e),this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){if(this.m_frequencyHz>0)return!0;var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=h.neo(o),c=h.neo(s),_=h.mulSub(n,this.m_localAnchorA,this.m_localCenterA),l=h.mulSub(c,this.m_localAnchorB,this.m_localCenterB),u=a.sub(a.add(e,l),a.add(i,_)),p=u.normalize()-this.m_length;p=m.clamp(p,-r.maxLinearCorrection,r.maxLinearCorrection);var y=-this.m_mass*p,d=a.mul(y,u);return i.wSub(this.m_invMassA,d),o-=this.m_invIA*a.cross(_,d),e.wAdd(this.m_invMassB,d),s+=this.m_invIB*a.cross(l,d),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=o,this.m_bodyB.c_position.c.set(e),this.m_bodyB.c_position.a=s,m.abs(p)<r.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":51,"../util/options":52}],28:[function(t,i,o){function e(t,i,o,n){if(!(this instanceof e))return new e(t,i,o,n);t=s(t,_),c.call(this,t,i,o),this.m_type=e.TYPE,n?(this.m_localAnchorA=i.getLocalPoint(n),this.m_localAnchorB=o.getLocalPoint(n)):(this.m_localAnchorA=m.zero(),this.m_localAnchorB=m.zero()),this.m_linearImpulse=m.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}i.exports=e;t("../util/common");var s=t("../util/options"),n=t("../util/create"),r=(t("../Settings"),t("../common/Math")),m=t("../common/Vec2"),a=(t("../common/Vec3"),t("../common/Mat22")),h=(t("../common/Mat33"),t("../common/Rot")),c=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));e.TYPE="friction-joint";var _={maxForce:0,maxTorque:0};(e.prototype=n((e._super=c).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.setMaxForce=function(t){this.m_maxForce=t},e.prototype.getMaxForce=function(){return this.m_maxForce},e.prototype.setMaxTorque=function(t){this.m_maxTorque=t},e.prototype.getMaxTorque=function(){return this.m_maxTorque},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return t*this.m_linearImpulse},e.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,c=h.neo(i),_=h.neo(s);this.m_rA=h.mul(c,m.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=h.mul(_,m.sub(this.m_localAnchorB,this.m_localCenterB));var l=this.m_invMassA,u=this.m_invMassB,p=this.m_invIA,y=this.m_invIB,d=new a;if(d.ex.x=l+u+p*this.m_rA.y*this.m_rA.y+y*this.m_rB.y*this.m_rB.y,d.ex.y=-p*this.m_rA.x*this.m_rA.y-y*this.m_rB.x*this.m_rB.y,d.ey.x=d.ex.y,d.ey.y=l+u+p*this.m_rA.x*this.m_rA.x+y*this.m_rB.x*this.m_rB.x,this.m_linearMass=d.getInverse(),this.m_angularMass=p+y,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var v=m.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);o.wSub(l,v),e-=p*(m.cross(this.m_rA,v)+this.m_angularImpulse),n.wAdd(u,v),r+=y*(m.cross(this.m_rB,v)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,e=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,h=this.m_invMassB,c=this.m_invIA,_=this.m_invIB,l=t.dt,u=s-o,p=-this.m_angularMass*u,y=this.m_angularImpulse,d=l*this.m_maxTorque;this.m_angularImpulse=r.clamp(this.m_angularImpulse+p,-d,d),o-=c*(p=this.m_angularImpulse-y),s+=_*p;u=m.sub(m.add(e,m.cross(s,this.m_rB)),m.add(i,m.cross(o,this.m_rA))),p=m.neg(a.mul(this.m_linearMass,u)),y=this.m_linearImpulse;this.m_linearImpulse.add(p);d=l*this.m_maxForce;this.m_linearImpulse.lengthSquared()>d*d&&(this.m_linearImpulse.normalize(),this.m_linearImpulse.mul(d)),p=m.sub(this.m_linearImpulse,y),i.wSub(n,p),o-=c*m.cross(this.m_rA,p),e.wAdd(h,p),s+=_*m.cross(this.m_rB,p),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=e,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],29:[function(t,i,o){function e(t,i,o,m,a,h){if(!(this instanceof e))return new e(t,i,o,m,a,h);t=r(t,y),l.call(this,t,i,o),this.m_type=e.TYPE,s&&n.assert(m.m_type==u.TYPE||m.m_type==p.TYPE),s&&n.assert(a.m_type==u.TYPE||a.m_type==p.TYPE),this.m_joint1=m,this.m_joint2=a,this.m_type1=this.m_joint1.getType(),this.m_type2=this.m_joint2.getType();var d,v;this.m_bodyC=this.m_joint1.getBodyA(),this.m_bodyA=this.m_joint1.getBodyB();var f=this.m_bodyA.m_xf,x=this.m_bodyA.m_sweep.a,A=this.m_bodyC.m_xf,g=this.m_bodyC.m_sweep.a;if(this.m_type1==u.TYPE){var b=m;this.m_localAnchorC=b.m_localAnchorA,this.m_localAnchorA=b.m_localAnchorB,this.m_referenceAngleA=b.m_referenceAngle,this.m_localAxisC=c.zero(),d=x-g-this.m_referenceAngleA}else{var B=m;this.m_localAnchorC=B.m_localAnchorA,this.m_localAnchorA=B.m_localAnchorB,this.m_referenceAngleA=B.m_referenceAngle,this.m_localAxisC=B.m_localXAxisA;var w=this.m_localAnchorC,S=_.mulT(A.q,c.add(_.mul(f.q,this.m_localAnchorA),c.sub(f.p,A.p)));d=c.dot(S,this.m_localAxisC)-c.dot(w,this.m_localAxisC)}this.m_bodyD=this.m_joint2.getBodyA(),this.m_bodyB=this.m_joint2.getBodyB();var C=this.m_bodyB.m_xf,M=this.m_bodyB.m_sweep.a,I=this.m_bodyD.m_xf,P=this.m_bodyD.m_sweep.a;if(this.m_type2==u.TYPE){b=a;this.m_localAnchorD=b.m_localAnchorA,this.m_localAnchorB=b.m_localAnchorB,this.m_referenceAngleB=b.m_referenceAngle,this.m_localAxisD=c.zero(),v=M-P-this.m_referenceAngleB}else{B=a;this.m_localAnchorD=B.m_localAnchorA,this.m_localAnchorB=B.m_localAnchorB,this.m_referenceAngleB=B.m_referenceAngle,this.m_localAxisD=B.m_localXAxisA;var T=this.m_localAnchorD,V=_.mulT(I.q,c.add(_.mul(C.q,this.m_localAnchorB),c.sub(C.p,I.p)));v=c.dot(V,this.m_localAxisD)-c.dot(T,this.m_localAxisD)}this.m_ratio=h||t.ratio,this.m_constant=d+this.m_ratio*v,this.m_impulse=0,this.m_lcA,this.m_lcB,this.m_lcC,this.m_lcD,this.m_mA,this.m_mB,this.m_mC,this.m_mD,this.m_iA,this.m_iB,this.m_iC,this.m_iD,this.m_JvAC,this.m_JvBD,this.m_JwA,this.m_JwB,this.m_JwC,this.m_JwD,this.m_mass}var s=!1;i.exports=e;var n=t("../util/common"),r=t("../util/options"),m=t("../util/create"),a=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),u=t("./RevoluteJoint"),p=t("./PrismaticJoint");e.TYPE="gear-joint";var y={ratio:1};(e.prototype=m((e._super=l).prototype)).getJoint1=function(){return this.m_joint1},e.prototype.getJoint2=function(){return this.m_joint2},e.prototype.setRatio=function(t){s&&n.assert(h.isFinite(t)),this.m_ratio=t},e.prototype.getRatio=function(){return this.m_ratio},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return t*(this.m_impulse*this.m_JvAC)},e.prototype.getReactionTorque=function(t){return t*(this.m_impulse*this.m_JwA)},e.prototype.initVelocityConstraints=function(t){this.m_lcA=this.m_bodyA.m_sweep.localCenter,this.m_lcB=this.m_bodyB.m_sweep.localCenter,this.m_lcC=this.m_bodyC.m_sweep.localCenter,this.m_lcD=this.m_bodyD.m_sweep.localCenter,this.m_mA=this.m_bodyA.m_invMass,this.m_mB=this.m_bodyB.m_invMass,this.m_mC=this.m_bodyC.m_invMass,this.m_mD=this.m_bodyD.m_invMass,this.m_iA=this.m_bodyA.m_invI,this.m_iB=this.m_bodyB.m_invI,this.m_iC=this.m_bodyC.m_invI,this.m_iD=this.m_bodyD.m_invI;var i=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,m=this.m_bodyC.c_position.a,a=this.m_bodyC.c_velocity.v,h=this.m_bodyC.c_velocity.w,l=this.m_bodyD.c_position.a,p=this.m_bodyD.c_velocity.v,y=this.m_bodyD.c_velocity.w,d=_.neo(i),v=_.neo(s),f=_.neo(m),x=_.neo(l);if(this.m_mass=0,this.m_type1==u.TYPE)this.m_JvAC=c.zero(),this.m_JwA=1,this.m_JwC=1,this.m_mass+=this.m_iA+this.m_iC;else{var A=_.mul(f,this.m_localAxisC),g=_.mulSub(f,this.m_localAnchorC,this.m_lcC),b=_.mulSub(d,this.m_localAnchorA,this.m_lcA);this.m_JvAC=A,this.m_JwC=c.cross(g,A),this.m_JwA=c.cross(b,A),this.m_mass+=this.m_mC+this.m_mA+this.m_iC*this.m_JwC*this.m_JwC+this.m_iA*this.m_JwA*this.m_JwA}if(this.m_type2==u.TYPE)this.m_JvBD=c.zero(),this.m_JwB=this.m_ratio,this.m_JwD=this.m_ratio,this.m_mass+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD);else{A=_.mul(x,this.m_localAxisD);var B=_.mulSub(x,this.m_localAnchorD,this.m_lcD),w=_.mulSub(v,this.m_localAnchorB,this.m_lcB);this.m_JvBD=c.mul(this.m_ratio,A),this.m_JwD=this.m_ratio*c.cross(B,A),this.m_JwB=this.m_ratio*c.cross(w,A),this.m_mass+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*this.m_JwD*this.m_JwD+this.m_iB*this.m_JwB*this.m_JwB}this.m_mass=this.m_mass>0?1/this.m_mass:0,t.warmStarting?(o.wAdd(this.m_mA*this.m_impulse,this.m_JvAC),e+=this.m_iA*this.m_impulse*this.m_JwA,n.wAdd(this.m_mB*this.m_impulse,this.m_JvBD),r+=this.m_iB*this.m_impulse*this.m_JwB,a.wSub(this.m_mC*this.m_impulse,this.m_JvAC),h-=this.m_iC*this.m_impulse*this.m_JwC,p.wSub(this.m_mD*this.m_impulse,this.m_JvBD),y-=this.m_iD*this.m_impulse*this.m_JwD):this.m_impulse=0,this.m_bodyA.c_velocity.v.set(o),this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v.set(n),this.m_bodyB.c_velocity.w=r,this.m_bodyC.c_velocity.v.set(a),this.m_bodyC.c_velocity.w=h,this.m_bodyD.c_velocity.v.set(p),this.m_bodyD.c_velocity.w=y},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,e=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_bodyC.c_velocity.v,r=this.m_bodyC.c_velocity.w,m=this.m_bodyD.c_velocity.v,a=this.m_bodyD.c_velocity.w,h=c.dot(this.m_JvAC,i)-c.dot(this.m_JvAC,n)+c.dot(this.m_JvBD,e)-c.dot(this.m_JvBD,m);h+=this.m_JwA*o-this.m_JwC*r+(this.m_JwB*s-this.m_JwD*a);var _=-this.m_mass*h;this.m_impulse+=_,i.wAdd(this.m_mA*_,this.m_JvAC),o+=this.m_iA*_*this.m_JwA,e.wAdd(this.m_mB*_,this.m_JvBD),s+=this.m_iB*_*this.m_JwB,n.wSub(this.m_mC*_,this.m_JvAC),r-=this.m_iC*_*this.m_JwC,m.wSub(this.m_mD*_,this.m_JvBD),a-=this.m_iD*_*this.m_JwD,this.m_bodyA.c_velocity.v.set(i),this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v.set(e),this.m_bodyB.c_velocity.w=s,this.m_bodyC.c_velocity.v.set(n),this.m_bodyC.c_velocity.w=r,this.m_bodyD.c_velocity.v.set(m),this.m_bodyD.c_velocity.w=a},e.prototype.solvePositionConstraints=function(t){var i,o,e,s,n,r,m,h,l=this.m_bodyA.c_position.c,p=this.m_bodyA.c_position.a,y=this.m_bodyB.c_position.c,d=this.m_bodyB.c_position.a,v=this.m_bodyC.c_position.c,f=this.m_bodyC.c_position.a,x=this.m_bodyD.c_position.c,A=this.m_bodyD.c_position.a,g=_.neo(p),b=_.neo(d),B=_.neo(f),w=_.neo(A),S=0;if(this.m_type1==u.TYPE)e=c.zero(),n=1,m=1,S+=this.m_iA+this.m_iC,i=p-f-this.m_referenceAngleA;else{var C=_.mul(B,this.m_localAxisC),M=_.mulSub(B,this.m_localAnchorC,this.m_lcC),I=_.mulSub(g,this.m_localAnchorA,this.m_lcA);e=C,m=c.cross(M,C),n=c.cross(I,C),S+=this.m_mC+this.m_mA+this.m_iC*m*m+this.m_iA*n*n;var P=c.sub(this.m_localAnchorC,this.m_lcC),T=_.mulT(B,c.add(I,c.sub(l,v)));i=c.dot(c.sub(T,P),this.m_localAxisC)}if(this.m_type2==u.TYPE)s=c.zero(),r=this.m_ratio,h=this.m_ratio,S+=this.m_ratio*this.m_ratio*(this.m_iB+this.m_iD),o=d-A-this.m_referenceAngleB;else{C=_.mul(w,this.m_localAxisD);var V=_.mulSub(w,this.m_localAnchorD,this.m_lcD),z=_.mulSub(b,this.m_localAnchorB,this.m_lcB);s=c.mul(this.m_ratio,C),h=this.m_ratio*c.cross(V,C),r=this.m_ratio*c.cross(z,C),S+=this.m_ratio*this.m_ratio*(this.m_mD+this.m_mB)+this.m_iD*h*h+this.m_iB*r*r;var L=c.sub(this.m_localAnchorD,this.m_lcD),F=_.mulT(w,c.add(z,c.sub(y,x)));o=c.dot(F,this.m_localAxisD)-c.dot(L,this.m_localAxisD)}var q=i+this.m_ratio*o-this.m_constant,k=0;return S>0&&(k=-q/S),l.wAdd(this.m_mA*k,e),p+=this.m_iA*k*n,y.wAdd(this.m_mB*k,s),d+=this.m_iB*k*r,v.wSub(this.m_mC*k,e),f-=this.m_iC*k*m,x.wSub(this.m_mD*k,s),A-=this.m_iD*k*h,this.m_bodyA.c_position.c.set(l),this.m_bodyA.c_position.a=p,this.m_bodyB.c_position.c.set(y),this.m_bodyB.c_position.a=d,this.m_bodyC.c_position.c.set(v),this.m_bodyC.c_position.a=f,this.m_bodyD.c_position.c.set(x),this.m_bodyD.c_position.a=A,0<a.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52,"./PrismaticJoint":32,"./RevoluteJoint":34}],30:[function(t,i,o){function e(t,i,o){if(!(this instanceof e))return new e(t,i,o);t=s(t,_),c.call(this,t,i,o),this.m_type=e.TYPE;var n=o.getPosition();this.m_linearOffset=i.getLocalPoint(n);var r=i.getAngle(),a=o.getAngle();this.m_angularOffset=a-r,this.m_linearImpulse=m.zero(),this.m_angularImpulse=0,this.m_maxForce=t.maxForce,this.m_maxTorque=t.maxTorque,this.m_correctionFactor=t.correctionFactor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_linearError,this.m_angularError,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_linearMass,this.m_angularMass}i.exports=e;t("../util/common");var s=t("../util/options"),n=t("../util/create"),r=(t("../Settings"),t("../common/Math")),m=t("../common/Vec2"),a=(t("../common/Vec3"),t("../common/Mat22")),h=(t("../common/Mat33"),t("../common/Rot")),c=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));e.TYPE="motor-joint";var _={maxForce:1,maxTorque:1,correctionFactor:.3};(e.prototype=n((e._super=c).prototype)).setMaxForce=function(t){this.m_maxForce=t},e.prototype.getMaxForce=function(){return this.m_maxForce},e.prototype.setMaxTorque=function(t){this.m_maxTorque=t},e.prototype.getMaxTorque=function(){return this.m_maxTorque},e.prototype.setCorrectionFactor=function(t){this.m_correctionFactor=t},e.prototype.getCorrectionFactor=function(){return this.m_correctionFactor},e.prototype.setLinearOffset=function(t){t.x==this.m_linearOffset.x&&t.y==this.m_linearOffset.y||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_linearOffset=t)},e.prototype.getLinearOffset=function(){return this.m_linearOffset},e.prototype.setAngularOffset=function(t){t!=this.m_angularOffset&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_angularOffset=t)},e.prototype.getAngularOffset=function(){return this.m_angularOffset},e.prototype.getAnchorA=function(){return this.m_bodyA.getPosition()},e.prototype.getAnchorB=function(){return this.m_bodyB.getPosition()},e.prototype.getReactionForce=function(t){return t*this.m_linearImpulse},e.prototype.getReactionTorque=function(t){return t*this.m_angularImpulse},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,c=this.m_bodyB.c_velocity.v,_=this.m_bodyB.c_velocity.w,l=h.neo(o),u=h.neo(r);this.m_rA=h.mul(l,m.neg(this.m_localCenterA)),this.m_rB=h.mul(u,m.neg(this.m_localCenterB));var p=this.m_invMassA,y=this.m_invMassB,d=this.m_invIA,v=this.m_invIB,f=new a;if(f.ex.x=p+y+d*this.m_rA.y*this.m_rA.y+v*this.m_rB.y*this.m_rB.y,f.ex.y=-d*this.m_rA.x*this.m_rA.y-v*this.m_rB.x*this.m_rB.y,f.ey.x=f.ex.y,f.ey.y=p+y+d*this.m_rA.x*this.m_rA.x+v*this.m_rB.x*this.m_rB.x,this.m_linearMass=f.getInverse(),this.m_angularMass=d+v,this.m_angularMass>0&&(this.m_angularMass=1/this.m_angularMass),this.m_linearError=m.zero(),this.m_linearError.wAdd(1,n,1,this.m_rB),this.m_linearError.wSub(1,i,1,this.m_rA),this.m_linearError.sub(h.mul(l,this.m_linearOffset)),this.m_angularError=r-o-this.m_angularOffset,t.warmStarting){this.m_linearImpulse.mul(t.dtRatio),this.m_angularImpulse*=t.dtRatio;var x=m.neo(this.m_linearImpulse.x,this.m_linearImpulse.y);e.wSub(p,x),s-=d*(m.cross(this.m_rA,x)+this.m_angularImpulse),c.wAdd(y,x),_+=v*(m.cross(this.m_rB,x)+this.m_angularImpulse)}else this.m_linearImpulse.setZero(),this.m_angularImpulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=c,this.m_bodyB.c_velocity.w=_},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,e=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,h=this.m_invMassB,c=this.m_invIA,_=this.m_invIB,l=t.dt,u=t.inv_dt,p=s-o+u*this.m_correctionFactor*this.m_angularError,y=-this.m_angularMass*p,d=this.m_angularImpulse,v=l*this.m_maxTorque;this.m_angularImpulse=r.clamp(this.m_angularImpulse+y,-v,v),o-=c*(y=this.m_angularImpulse-d),s+=_*y;(p=m.zero()).wAdd(1,e,1,m.cross(s,this.m_rB)),p.wSub(1,i,1,m.cross(o,this.m_rA)),p.wAdd(u*this.m_correctionFactor,this.m_linearError);y=m.neg(a.mul(this.m_linearMass,p)),d=m.clone(this.m_linearImpulse);this.m_linearImpulse.add(y);v=l*this.m_maxForce;this.m_linearImpulse.clamp(v),y=m.sub(this.m_linearImpulse,d),i.wSub(n,y),o-=c*m.cross(this.m_rA,y),e.wAdd(h,y),s+=_*m.cross(this.m_rB,y),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=e,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],31:[function(t,i,o){function e(t,i,o,m){if(!(this instanceof e))return new e(t,i,o,m);t=r(t,p),u.call(this,t,i,o),this.m_type=e.TYPE,s&&n.assert(a.isFinite(t.maxForce)&&t.maxForce>=0),s&&n.assert(a.isFinite(t.frequencyHz)&&t.frequencyHz>=0),s&&n.assert(a.isFinite(t.dampingRatio)&&t.dampingRatio>=0),this.m_targetA=h.clone(m),this.m_localAnchorB=l.mulT(this.m_bodyB.getTransform(),this.m_targetA),this.m_maxForce=t.maxForce,this.m_impulse=h.zero(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_beta=0,this.m_gamma=0,this.m_rB=h.zero(),this.m_localCenterB=h.zero(),this.m_invMassB=0,this.m_invIB=0,this.mass=new c,this.m_C=h.zero()}var s=!1;i.exports=e;var n=t("../util/common"),r=t("../util/options"),m=t("../util/create"),a=t("../common/Math"),h=t("../common/Vec2"),c=(t("../common/Vec3"),t("../common/Mat22")),_=(t("../common/Mat33"),t("../common/Rot")),l=(t("../common/Sweep"),t("../common/Transform")),u=(t("../common/Velocity"),t("../common/Position"),t("../Joint"));e.TYPE="mouse-joint";var p={maxForce:0,frequencyHz:5,dampingRatio:.7};(e.prototype=m((e._super=u).prototype)).setTarget=function(t){0==this.m_bodyB.isAwake()&&this.m_bodyB.setAwake(!0),this.m_targetA=h.clone(t)},e.prototype.getTarget=function(){return this.m_targetA},e.prototype.setMaxForce=function(t){this.m_maxForce=t},e.getMaxForce=function(){return this.m_maxForce},e.prototype.setFrequency=function(t){this.m_frequencyHz=t},e.prototype.getFrequency=function(){return this.m_frequencyHz},e.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},e.prototype.getDampingRatio=function(){return this.m_dampingRatio},e.prototype.getAnchorA=function(){return h.clone(this.m_targetA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return h.mul(t,this.m_impulse)},e.prototype.getReactionTorque=function(t){return 0*t},e.prototype.shiftOrigin=function(t){this.m_targetA.sub(t)},e.prototype.initVelocityConstraints=function(t){this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyB.c_position,o=this.m_bodyB.c_velocity,e=i.c,r=i.a,m=o.v,l=o.w,u=_.neo(r),p=this.m_bodyB.getMass(),y=2*a.PI*this.m_frequencyHz,d=2*p*this.m_dampingRatio*y,v=p*(y*y),f=t.dt;s&&n.assert(d+f*v>a.EPSILON),this.m_gamma=f*(d+f*v),0!=this.m_gamma&&(this.m_gamma=1/this.m_gamma),this.m_beta=f*v*this.m_gamma,this.m_rB=_.mul(u,h.sub(this.m_localAnchorB,this.m_localCenterB));var x=new c;x.ex.x=this.m_invMassB+this.m_invIB*this.m_rB.y*this.m_rB.y+this.m_gamma,x.ex.y=-this.m_invIB*this.m_rB.x*this.m_rB.y,x.ey.x=x.ex.y,x.ey.y=this.m_invMassB+this.m_invIB*this.m_rB.x*this.m_rB.x+this.m_gamma,this.m_mass=x.getInverse(),this.m_C.set(e),this.m_C.wAdd(1,this.m_rB,-1,this.m_targetA),this.m_C.mul(this.m_beta),l*=.98,t.warmStarting?(this.m_impulse.mul(t.dtRatio),m.wAdd(this.m_invMassB,this.m_impulse),l+=this.m_invIB*h.cross(this.m_rB,this.m_impulse)):this.m_impulse.setZero(),o.v.set(m),o.w=l},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyB.c_velocity,o=h.clone(i.v),e=i.w,s=h.cross(e,this.m_rB);s.add(o),s.wAdd(1,this.m_C,this.m_gamma,this.m_impulse),s.neg();var n=c.mul(this.m_mass,s),r=h.clone(this.m_impulse);this.m_impulse.add(n);var m=t.dt*this.m_maxForce;this.m_impulse.clamp(m),n=h.sub(this.m_impulse,r),o.wAdd(this.m_invMassB,n),e+=this.m_invIB*h.cross(this.m_rB,n),i.v.set(o),i.w=e},e.prototype.solvePositionConstraints=function(t){return!0}},{"../Joint":5,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],32:[function(t,i,o){function e(t,i,o,n,r){if(!(this instanceof e))return new e(t,i,o,n,r);t=s(t,y),u.call(this,t,i,o),this.m_type=e.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(n),this.m_localAnchorB=t.localAnchorB||o.getLocalPoint(n),this.m_localXAxisA=t.localAxisA||i.getLocalVector(r),this.m_localXAxisA.normalize(),this.m_localYAxisA=a.cross(1,this.m_localXAxisA),this.m_referenceAngle=o.getAngle()-i.getAngle(),this.m_impulse=h(),this.m_motorMass=0,this.m_motorImpulse=0,this.m_lowerTranslation=t.lowerTranslation,this.m_upperTranslation=t.upperTranslation,this.m_maxMotorForce=t.maxMotorForce,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_limitState=p,this.m_axis=a.zero(),this.m_perp=a.zero(),this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_axis,this.m_perp,this.m_s1,this.m_s2,this.m_a1,this.m_a2,this.m_K=new _,this.m_motorMass}i.exports=e;t("../util/common");var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),m=t("../common/Math"),a=t("../common/Vec2"),h=t("../common/Vec3"),c=t("../common/Mat22"),_=t("../common/Mat33"),l=t("../common/Rot"),u=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),p=0;e.TYPE="prismatic-joint";var y={enableLimit:!1,lowerTranslation:0,upperTranslation:0,enableMotor:!1,maxMotorForce:0,motorSpeed:0};(e.prototype=n((e._super=u).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.getLocalAxisA=function(){return this.m_localXAxisA},e.prototype.getReferenceAngle=function(){return this.m_referenceAngle},e.prototype.getJointTranslation=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_bodyB.getWorldPoint(this.m_localAnchorB),o=a.sub(i,t),e=this.m_bodyA.getWorldVector(this.m_localXAxisA);return a.dot(o,e)},e.prototype.getJointSpeed=function(){var t=this.m_bodyA,i=this.m_bodyB,o=Mul(t.m_xf.q,this.m_localAnchorA-t.m_sweep.localCenter),e=Mul(i.m_xf.q,this.m_localAnchorB-i.m_sweep.localCenter),s=t.m_sweep.c+o,n=i.m_sweep.c+e-s,r=Mul(t.m_xf.q,this.m_localXAxisA),m=t.m_linearVelocity,a=i.m_linearVelocity,h=t.m_angularVelocity,c=i.m_angularVelocity;return Dot(n,Cross(h,r))+Dot(r,a+Cross(c,e)-m-Cross(h,o))},e.prototype.isLimitEnabled=function(){return this.m_enableLimit},e.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},e.prototype.getLowerLimit=function(){return this.m_lowerTranslation},e.prototype.getUpperLimit=function(){return this.m_upperTranslation},e.prototype.setLimits=function(t,i){t==this.m_lowerTranslation&&i==this.m_upperTranslation||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_lowerTranslation=t,this.m_upperTranslation=i,this.m_impulse.z=0)},e.prototype.isMotorEnabled=function(){return this.m_enableMotor},e.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},e.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},e.prototype.setMaxMotorForce=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorForce=t},e.prototype.getMotorSpeed=function(){return this.m_motorSpeed},e.prototype.getMotorForce=function(t){return t*this.m_motorImpulse},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return t*(this.m_impulse.x*this.m_perp+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis)},e.prototype.getReactionTorque=function(t){return t*this.m_impulse.y},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,h=this.m_bodyB.c_position.a,c=this.m_bodyB.c_velocity.v,_=this.m_bodyB.c_velocity.w,u=l.neo(o),y=l.neo(h),d=l.mul(u,a.sub(this.m_localAnchorA,this.m_localCenterA)),v=l.mul(y,a.sub(this.m_localAnchorB,this.m_localCenterB)),f=a.zero();f.wAdd(1,n,1,v),f.wSub(1,i,1,d);var x=this.m_invMassA,A=this.m_invMassB,g=this.m_invIA,b=this.m_invIB;this.m_axis=l.mul(u,this.m_localXAxisA),this.m_a1=a.cross(a.add(f,d),this.m_axis),this.m_a2=a.cross(v,this.m_axis),this.m_motorMass=x+A+g*this.m_a1*this.m_a1+b*this.m_a2*this.m_a2,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),this.m_perp=l.mul(u,this.m_localYAxisA),this.m_s1=a.cross(a.add(f,d),this.m_perp),this.m_s2=a.cross(v,this.m_perp);a.cross(d,this.m_perp);var B=x+A+g*this.m_s1*this.m_s1+b*this.m_s2*this.m_s2,w=g*this.m_s1+b*this.m_s2,S=g*this.m_s1*this.m_a1+b*this.m_s2*this.m_a2,C=g+b;0==C&&(C=1);var M=g*this.m_a1+b*this.m_a2,I=x+A+g*this.m_a1*this.m_a1+b*this.m_a2*this.m_a2;if(this.m_K.ex.set(B,w,S),this.m_K.ey.set(w,C,M),this.m_K.ez.set(S,M,I),this.m_enableLimit){var P=a.dot(this.m_axis,f);m.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*r.linearSlop?this.m_limitState=3:P<=this.m_lowerTranslation?1!=this.m_limitState&&(this.m_limitState=1,this.m_impulse.z=0):P>=this.m_upperTranslation?2!=this.m_limitState&&(this.m_limitState=2,this.m_impulse.z=0):(this.m_limitState=p,this.m_impulse.z=0)}else this.m_limitState=p,this.m_impulse.z=0;if(0==this.m_enableMotor&&(this.m_motorImpulse=0),t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var T=a.wAdd(this.m_impulse.x,this.m_perp,this.m_motorImpulse+this.m_impulse.z,this.m_axis),V=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,z=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2;e.wSub(x,T),s-=g*V,c.wAdd(A,T),_+=b*z}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(e),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(c),this.m_bodyB.c_velocity.w=_},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,e=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,c=this.m_invIA,_=this.m_invIB;if(this.m_enableMotor&&3!=this.m_limitState){var l=a.dot(this.m_axis,a.sub(e,i))+this.m_a2*s-this.m_a1*o,u=this.m_motorMass*(this.m_motorSpeed-l),y=this.m_motorImpulse,d=t.dt*this.m_maxMotorForce;this.m_motorImpulse=m.clamp(this.m_motorImpulse+u,-d,d),u=this.m_motorImpulse-y;var v=a.zero().wSet(u,this.m_axis),f=u*this.m_a1,x=u*this.m_a2;i.wSub(n,v),o-=c*f,e.wAdd(r,v),s+=_*x}var A=a.zero();if(A.x+=a.dot(this.m_perp,e)+this.m_s2*s,A.x-=a.dot(this.m_perp,i)+this.m_s1*o,A.y=s-o,this.m_enableLimit&&this.m_limitState!=p){var g=0;g+=a.dot(this.m_axis,e)+this.m_a2*s,g-=a.dot(this.m_axis,i)+this.m_a1*o;l=h(A.x,A.y,g);var b=h(this.m_impulse),B=this.m_K.solve33(h.neg(l));this.m_impulse.add(B),1==this.m_limitState?this.m_impulse.z=m.max(this.m_impulse.z,0):2==this.m_limitState&&(this.m_impulse.z=m.min(this.m_impulse.z,0));var w=a.wAdd(-1,A,-(this.m_impulse.z-b.z),a.neo(this.m_K.ez.x,this.m_K.ez.y)),S=a.add(this.m_K.solve22(w),a.neo(b.x,b.y));this.m_impulse.x=S.x,this.m_impulse.y=S.y,B=h.sub(this.m_impulse,b);v=a.wAdd(B.x,this.m_perp,B.z,this.m_axis),f=B.x*this.m_s1+B.y+B.z*this.m_a1,x=B.x*this.m_s2+B.y+B.z*this.m_a2;i.wSub(n,v),o-=c*f,e.wAdd(r,v),s+=_*x}else{B=this.m_K.solve22(a.neg(A));this.m_impulse.x+=B.x,this.m_impulse.y+=B.y;v=a.zero().wAdd(B.x,this.m_perp),f=B.x*this.m_s1+B.y,x=B.x*this.m_s2+B.y;i.wSub(n,v),o-=c*f,e.wAdd(r,v),s+=_*x}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=e,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=l.neo(o),u=l.neo(s),p=this.m_invMassA,y=this.m_invMassB,d=this.m_invIA,v=this.m_invIB,f=l.mul(n,a.sub(this.m_localAnchorA,this.m_localCenterA)),x=l.mul(u,a.sub(this.m_localAnchorB,this.m_localCenterB)),A=a.sub(a.add(e,x),a.add(i,f)),g=l.mul(n,this.m_localXAxisA),b=a.cross(a.add(A,f),g),B=a.cross(x,g),w=l.mul(n,this.m_localYAxisA),S=a.cross(a.add(A,f),w),C=a.cross(x,w),M=h(),I=a.zero();I.x=a.dot(w,A),I.y=s-o-this.m_referenceAngle;var P=m.abs(I.x),T=m.abs(I.y),V=r.linearSlop,z=r.maxLinearCorrection,L=!1,F=0;if(this.m_enableLimit){var q=a.dot(g,A);m.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*V?(F=m.clamp(q,-z,z),P=m.max(P,m.abs(q)),L=!0):q<=this.m_lowerTranslation?(F=m.clamp(q-this.m_lowerTranslation+V,-z,0),P=m.max(P,this.m_lowerTranslation-q),L=!0):q>=this.m_upperTranslation&&(F=m.clamp(q-this.m_upperTranslation-V,0,z),P=m.max(P,q-this.m_upperTranslation),L=!0)}if(L){var k=p+y+d*S*S+v*C*C,R=d*S+v*C,D=d*S*b+v*C*B;0==(O=d+v)&&(O=1);var E=d*b+v*B,j=p+y+d*b*b+v*B*B;(N=new _).ex.set(k,R,D),N.ey.set(R,O,E),N.ez.set(D,E,j);var J=h();J.x=I.x,J.y=I.y,J.z=F,M=N.solve33(h.neg(J))}else{var O;k=p+y+d*S*S+v*C*C,R=d*S+v*C;0==(O=d+v)&&(O=1);var N;(N=new c).ex.set(k,R),N.ey.set(R,O);var Y=N.solve(a.neg(I));M.x=Y.x,M.y=Y.y,M.z=0}var W=a.wAdd(M.x,w,M.z,g),H=M.x*S+M.y+M.z*b,Z=M.x*C+M.y+M.z*B;return i.wSub(p,W),o-=d*H,e.wAdd(y,W),s+=v*Z,this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=o,this.m_bodyB.c_position.c=e,this.m_bodyB.c_position.a=s,P<=r.linearSlop&&T<=r.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],33:[function(t,i,o){function e(t,i,o,m,a,_,l,y){if(!(this instanceof e))return new e(t,i,o,m,a,_,l,y);t=r(t,p),u.call(this,t,i,o),this.m_type=e.TYPE,this.m_groundAnchorA=m,this.m_groundAnchorB=a,this.m_localAnchorA=i.getLocalPoint(_),this.m_localAnchorB=o.getLocalPoint(l),this.m_lengthA=c.distance(_,m),this.m_lengthB=c.distance(l,a),this.m_ratio=t.ratio||y,s&&n.assert(y>h.EPSILON),this.m_constant=this.m_lengthA+this.m_ratio*this.m_lengthB,this.m_impulse=0,this.m_uA,this.m_uB,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}var s=!1;i.exports=e;var n=t("../util/common"),r=t("../util/options"),m=t("../util/create"),a=t("../Settings"),h=t("../common/Math"),c=t("../common/Vec2"),_=t("../common/Vec3"),l=(t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),u=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));e.TYPE="pulley-joint",e.MIN_PULLEY_LENGTH=2;var p={collideConnected:!0};(e.prototype=m((e._super=u).prototype)).getGroundAnchorA=function(){return this.m_groundAnchorA},e.prototype.getGroundAnchorB=function(){return this.m_groundAnchorB},e.prototype.getLengthA=function(){return this.m_lengthA},e.prototype.getLengthB=function(){return this.m_lengthB},e.prototype.getRatio=function(){return this.m_ratio},e.prototype.getCurrentLengthA=function(){var t=this.m_bodyA.getWorldPoint(this.m_localAnchorA),i=this.m_groundAnchorA;return c.distance(t,i)},e.prototype.getCurrentLengthB=function(){var t=this.m_bodyB.getWorldPoint(this.m_localAnchorB),i=this.m_groundAnchorB;return c.distance(t,i)},e.prototype.shiftOrigin=function(t){this.m_groundAnchorA-=t,this.m_groundAnchorB-=t},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return _.mul(t*this.m_impulse,this.m_uB)},e.prototype.getReactionTorque=function(t){return 0},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,r=this.m_bodyB.c_position.a,m=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,_=l.neo(o),u=l.neo(r);this.m_rA=l.mul(_,c.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=l.mul(u,c.sub(this.m_localAnchorB,this.m_localCenterB)),this.m_uA=c.sub(c.add(i,this.m_rA),this.m_groundAnchorA),this.m_uB=c.sub(c.add(n,this.m_rB),this.m_groundAnchorB);var p=this.m_uA.length(),y=this.m_uB.length();p>10*a.linearSlop?this.m_uA.mul(1/p):this.m_uA.setZero(),y>10*a.linearSlop?this.m_uB.mul(1/y):this.m_uB.setZero();var d=c.cross(this.m_rA,this.m_uA),v=c.cross(this.m_rB,this.m_uB),f=this.m_invMassA+this.m_invIA*d*d,x=this.m_invMassB+this.m_invIB*v*v;if(this.m_mass=f+this.m_ratio*this.m_ratio*x,this.m_mass>0&&(this.m_mass=1/this.m_mass),t.warmStarting){this.m_impulse*=t.dtRatio;var A=c.mul(-this.m_impulse,this.m_uA),g=c.mul(-this.m_ratio*this.m_impulse,this.m_uB);e.wAdd(this.m_invMassA,A),s+=this.m_invIA*c.cross(this.m_rA,A),m.wAdd(this.m_invMassB,g),h+=this.m_invIB*c.cross(this.m_rB,g)}else this.m_impulse=0;this.m_bodyA.c_velocity.v=e,this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v=m,this.m_bodyB.c_velocity.w=h},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,e=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=c.add(i,c.cross(o,this.m_rA)),r=c.add(e,c.cross(s,this.m_rB)),m=-c.dot(this.m_uA,n)-this.m_ratio*c.dot(this.m_uB,r),a=-this.m_mass*m;this.m_impulse+=a;var h=c.zero().wSet(-a,this.m_uA),_=c.zero().wSet(-this.m_ratio*a,this.m_uB);i.wAdd(this.m_invMassA,h),o+=this.m_invIA*c.cross(this.m_rA,h),e.wAdd(this.m_invMassB,_),s+=this.m_invIB*c.cross(this.m_rB,_),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=e,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=l.neo(o),r=l.neo(s),m=l.mul(n,c.sub(this.m_localAnchorA,this.m_localCenterA)),_=l.mul(r,c.sub(this.m_localAnchorB,this.m_localCenterB)),u=c.sub(c.add(i,this.m_rA),this.m_groundAnchorA),p=c.sub(c.add(e,this.m_rB),this.m_groundAnchorB),y=u.length(),d=p.length();y>10*a.linearSlop?u.mul(1/y):u.setZero(),d>10*a.linearSlop?p.mul(1/d):p.setZero();var v=c.cross(m,u),f=c.cross(_,p),x=this.m_invMassA+this.m_invIA*v*v,A=this.m_invMassB+this.m_invIB*f*f,g=x+this.m_ratio*this.m_ratio*A;g>0&&(g=1/g);var b=this.m_constant-y-this.m_ratio*d,B=h.abs(b),w=-g*b,S=c.zero().wSet(-w,u),C=c.zero().wSet(-this.m_ratio*w,p);return i.wAdd(this.m_invMassA,S),o+=this.m_invIA*c.cross(m,S),e.wAdd(this.m_invMassB,C),s+=this.m_invIB*c.cross(_,C),this.m_bodyA.c_position.c=i,this.m_bodyA.c_position.a=o,this.m_bodyB.c_position.c=e,this.m_bodyB.c_position.a=s,B<a.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],34:[function(t,i,o){function e(t,i,o,n){if(!(this instanceof e))return new e(t,i,o,n);t=s(t,y),u.call(this,t,i,o),this.m_type=e.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(n),this.m_localAnchorB=t.localAnchorB||o.getLocalPoint(n),this.m_referenceAngle=o.getAngle()-i.getAngle(),this.m_impulse=h(),this.m_motorImpulse=0,this.m_lowerAngle=t.lowerAngle,this.m_upperAngle=t.upperAngle,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableLimit=t.enableLimit,this.m_enableMotor=t.enableMotor,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new _,this.m_motorMass,this.m_limitState=p}i.exports=e;t("../util/common");var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),m=t("../common/Math"),a=t("../common/Vec2"),h=t("../common/Vec3"),c=t("../common/Mat22"),_=t("../common/Mat33"),l=t("../common/Rot"),u=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),p=0;e.TYPE="revolute-joint";var y={lowerAngle:0,upperAngle:0,maxMotorTorque:0,motorSpeed:0,enableLimit:!1,enableMotor:!1};(e.prototype=n((e._super=u).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.getReferenceAngle=function(){return this.m_referenceAngle},e.prototype.getJointAngle=function(){var t=this.m_bodyA;return this.m_bodyB.m_sweep.a-t.m_sweep.a-this.m_referenceAngle},e.prototype.getJointSpeed=function(){var t=this.m_bodyA;return this.m_bodyB.m_angularVelocity-t.m_angularVelocity},e.prototype.isMotorEnabled=function(){return this.m_enableMotor},e.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},e.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},e.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},e.prototype.getMotorSpeed=function(){return this.m_motorSpeed},e.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},e.prototype.isLimitEnabled=function(){return this.m_enableLimit},e.prototype.enableLimit=function(t){t!=this.m_enableLimit&&(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableLimit=t,this.m_impulse.z=0)},e.prototype.getLowerLimit=function(){return this.m_lowerAngle},e.prototype.getUpperLimit=function(){return this.m_upperAngle},e.prototype.setLimits=function(t,i){t==this.m_lowerAngle&&i==this.m_upperAngle||(this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_impulse.z=0,this.m_lowerAngle=t,this.m_upperAngle=i)},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return t*a.neo(this.m_impulse.x,this.m_impulse.y)},e.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,h=this.m_bodyB.c_velocity.w,c=l.neo(i),_=l.neo(s);this.m_rA=l.mul(c,a.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=l.mul(_,a.sub(this.m_localAnchorB,this.m_localCenterB));var u=this.m_invMassA,y=this.m_invMassB,d=this.m_invIA,v=this.m_invIB,f=d+v==0;if(this.m_mass.ex.x=u+y+this.m_rA.y*this.m_rA.y*d+this.m_rB.y*this.m_rB.y*v,this.m_mass.ey.x=-this.m_rA.y*this.m_rA.x*d-this.m_rB.y*this.m_rB.x*v,this.m_mass.ez.x=-this.m_rA.y*d-this.m_rB.y*v,this.m_mass.ex.y=this.m_mass.ey.x,this.m_mass.ey.y=u+y+this.m_rA.x*this.m_rA.x*d+this.m_rB.x*this.m_rB.x*v,this.m_mass.ez.y=this.m_rA.x*d+this.m_rB.x*v,this.m_mass.ex.z=this.m_mass.ez.x,this.m_mass.ey.z=this.m_mass.ez.y,this.m_mass.ez.z=d+v,this.m_motorMass=d+v,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass),(0==this.m_enableMotor||f)&&(this.m_motorImpulse=0),this.m_enableLimit&&0==f){var x=s-i-this.m_referenceAngle;m.abs(this.m_upperAngle-this.m_lowerAngle)<2*r.angularSlop?this.m_limitState=3:x<=this.m_lowerAngle?(1!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=1):x>=this.m_upperAngle?(2!=this.m_limitState&&(this.m_impulse.z=0),this.m_limitState=2):(this.m_limitState=p,this.m_impulse.z=0)}else this.m_limitState=p;if(t.warmStarting){this.m_impulse.mul(t.dtRatio),this.m_motorImpulse*=t.dtRatio;var A=a.neo(this.m_impulse.x,this.m_impulse.y);o.wSub(u,A),e-=d*(a.cross(this.m_rA,A)+this.m_motorImpulse+this.m_impulse.z),n.wAdd(y,A),h+=v*(a.cross(this.m_rB,A)+this.m_motorImpulse+this.m_impulse.z)}else this.m_impulse.setZero(),this.m_motorImpulse=0;this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=h},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,e=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,c=this.m_invIA,_=this.m_invIB,l=c+_==0;if(this.m_enableMotor&&3!=this.m_limitState&&0==l){var u=s-o-this.m_motorSpeed,y=-this.m_motorMass*u,d=this.m_motorImpulse,v=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=m.clamp(this.m_motorImpulse+y,-v,v),o-=c*(y=this.m_motorImpulse-d),s+=_*y}if(this.m_enableLimit&&this.m_limitState!=p&&0==l){var f=a.zero();f.wAdd(1,e,1,a.cross(s,this.m_rB)),f.wSub(1,i,1,a.cross(o,this.m_rA));var x=s-o;u=h(f.x,f.y,x),y=h.neg(this.m_mass.solve33(u));if(3==this.m_limitState)this.m_impulse.add(y);else if(1==this.m_limitState){if(this.m_impulse.z+y.z<0){var A=a.wAdd(-1,f,this.m_impulse.z,a.neo(this.m_mass.ez.x,this.m_mass.ez.y)),g=this.m_mass.solve22(A);y.x=g.x,y.y=g.y,y.z=-this.m_impulse.z,this.m_impulse.x+=g.x,this.m_impulse.y+=g.y,this.m_impulse.z=0}else this.m_impulse.add(y)}else if(2==this.m_limitState){if(this.m_impulse.z+y.z>0){A=a.wAdd(-1,f,this.m_impulse.z,a.neo(this.m_mass.ez.x,this.m_mass.ez.y)),g=this.m_mass.solve22(A);y.x=g.x,y.y=g.y,y.z=-this.m_impulse.z,this.m_impulse.x+=g.x,this.m_impulse.y+=g.y,this.m_impulse.z=0}else this.m_impulse.add(y)}var b=a.neo(y.x,y.y);i.wSub(n,b),o-=c*(a.cross(this.m_rA,b)+y.z),e.wAdd(r,b),s+=_*(a.cross(this.m_rB,b)+y.z)}else{(u=a.zero()).wAdd(1,e,1,a.cross(s,this.m_rB)),u.wSub(1,i,1,a.cross(o,this.m_rA));y=this.m_mass.solve22(a.neg(u));this.m_impulse.x+=y.x,this.m_impulse.y+=y.y,i.wSub(n,y),o-=c*a.cross(this.m_rA,y),e.wAdd(r,y),s+=_*a.cross(this.m_rB,y)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=e,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=l.neo(o),h=l.neo(s),_=0,u=0,y=this.m_invIA+this.m_invIB==0;if(this.m_enableLimit&&this.m_limitState!=p&&0==y){var d=s-o-this.m_referenceAngle,v=0;if(3==this.m_limitState){var f=m.clamp(d-this.m_lowerAngle,-r.maxAngularCorrection,r.maxAngularCorrection);v=-this.m_motorMass*f,_=m.abs(f)}else if(1==this.m_limitState){_=-(f=d-this.m_lowerAngle),f=m.clamp(f+r.angularSlop,-r.maxAngularCorrection,0),v=-this.m_motorMass*f}else if(2==this.m_limitState){_=f=d-this.m_upperAngle,f=m.clamp(f-r.angularSlop,0,r.maxAngularCorrection),v=-this.m_motorMass*f}o-=this.m_invIA*v,s+=this.m_invIB*v}n.set(o),h.set(s);var x=l.mul(n,a.sub(this.m_localAnchorA,this.m_localCenterA)),A=l.mul(h,a.sub(this.m_localAnchorB,this.m_localCenterB));(f=a.zero()).wAdd(1,e,1,A),f.wSub(1,i,1,x),u=f.length();var g=this.m_invMassA,b=this.m_invMassB,B=this.m_invIA,w=this.m_invIB,S=new c;S.ex.x=g+b+B*x.y*x.y+w*A.y*A.y,S.ex.y=-B*x.x*x.y-w*A.x*A.y,S.ey.x=S.ex.y,S.ey.y=g+b+B*x.x*x.x+w*A.x*A.x;var C=a.neg(S.solve(f));return i.wSub(g,C),o-=B*a.cross(x,C),e.wAdd(b,C),s+=w*a.cross(A,C),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=o,this.m_bodyB.c_position.c.set(e),this.m_bodyB.c_position.a=s,u<=r.linearSlop&&_<=r.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/common":50,"../util/create":51,"../util/options":52}],35:[function(t,i,o){function e(t,i,o,n){if(!(this instanceof e))return new e(t,i,o,n);t=s(t,l),c.call(this,t,i,o),this.m_type=e.TYPE,this.m_localAnchorA=t.localAnchorA||i.getLocalPoint(n),this.m_localAnchorB=t.localAnchorB||o.getLocalPoint(n),this.m_maxLength=t.maxLength,this.m_mass=0,this.m_impulse=0,this.m_length=0,this.m_state=_,this.m_u,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass}i.exports=e;var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),m=t("../common/Math"),a=t("../common/Vec2"),h=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),c=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint")),_=0;e.TYPE="rope-joint";var l={maxLength:0};(e.prototype=n((e._super=c).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.setMaxLength=function(t){this.m_maxLength=t},e.prototype.getMaxLength=function(){return this.m_maxLength},e.prototype.getLimitState=function(){return this.m_state},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return t*this.m_impulse*this.m_u},e.prototype.getReactionTorque=function(t){return 0},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyA.c_velocity.v,s=this.m_bodyA.c_velocity.w,n=this.m_bodyB.c_position.c,m=this.m_bodyB.c_position.a,c=this.m_bodyB.c_velocity.v,l=this.m_bodyB.c_velocity.w,u=h.neo(o),p=h.neo(m);this.m_rA=h.mulSub(u,this.m_localAnchorA,this.m_localCenterA),this.m_rB=h.mulSub(p,this.m_localAnchorB,this.m_localCenterB),this.m_u=a.zero(),this.m_u.wAdd(1,n,1,this.m_rB),this.m_u.wSub(1,i,1,this.m_rA),this.m_length=this.m_u.length();var y=this.m_length-this.m_maxLength;if(this.m_state=y>0?2:_,!(this.m_length>r.linearSlop))return this.m_u.setZero(),this.m_mass=0,void(this.m_impulse=0);this.m_u.mul(1/this.m_length);var d=a.cross(this.m_rA,this.m_u),v=a.cross(this.m_rB,this.m_u),f=this.m_invMassA+this.m_invIA*d*d+this.m_invMassB+this.m_invIB*v*v;if(this.m_mass=0!=f?1/f:0,t.warmStarting){this.m_impulse*=t.dtRatio;var x=a.mul(this.m_impulse,this.m_u);e.wSub(this.m_invMassA,x),s-=this.m_invIA*a.cross(this.m_rA,x),c.wAdd(this.m_invMassB,x),l+=this.m_invIB*a.cross(this.m_rB,x)}else this.m_impulse=0;this.m_bodyA.c_velocity.v.set(e),this.m_bodyA.c_velocity.w=s,this.m_bodyB.c_velocity.v.set(c),this.m_bodyB.c_velocity.w=l},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,e=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=a.addCross(i,o,this.m_rA),r=a.addCross(e,s,this.m_rB),h=this.m_length-this.m_maxLength,c=a.dot(this.m_u,a.sub(r,n));h<0&&(c+=t.inv_dt*h);var _=-this.m_mass*c,l=this.m_impulse;this.m_impulse=m.min(0,this.m_impulse+_),_=this.m_impulse-l;var u=a.mul(_,this.m_u);i.wSub(this.m_invMassA,u),o-=this.m_invIA*a.cross(this.m_rA,u),e.wAdd(this.m_invMassB,u),s+=this.m_invIB*a.cross(this.m_rB,u),this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=e,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=h.neo(o),c=h.neo(s),_=h.mulSub(n,this.m_localAnchorA,this.m_localCenterA),l=h.mulSub(c,this.m_localAnchorB,this.m_localCenterB),u=a.zero();u.wAdd(1,e,1,l),u.wSub(1,i,1,_);var p=u.normalize(),y=p-this.m_maxLength;y=m.clamp(y,0,r.maxLinearCorrection);var d=-this.m_mass*y,v=a.mul(d,u);return i.wSub(this.m_invMassA,v),o-=this.m_invIA*a.cross(_,v),e.wAdd(this.m_invMassB,v),s+=this.m_invIB*a.cross(l,v),this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=o,this.m_bodyB.c_position.c.set(e),this.m_bodyB.c_position.a=s,p-this.m_maxLength<r.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":51,"../util/options":52}],36:[function(t,i,o){function e(t,i,o,n){if(!(this instanceof e))return new e(t,i,o,n);t=s(t,u),l.call(this,t,i,o),this.m_type=e.TYPE,this.m_localAnchorA=i.getLocalPoint(n),this.m_localAnchorB=o.getLocalPoint(n),this.m_referenceAngle=o.getAngle()-i.getAngle(),this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_impulse=h(),this.m_bias=0,this.m_gamma=0,this.m_rA,this.m_rB,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_mass=new c}i.exports=e;var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),m=t("../common/Math"),a=t("../common/Vec2"),h=t("../common/Vec3"),c=(t("../common/Mat22"),t("../common/Mat33")),_=t("../common/Rot"),l=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));e.TYPE="weld-joint";var u={frequencyHz:0,dampingRatio:0};(e.prototype=n((e._super=l).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.getReferenceAngle=function(){return this.m_referenceAngle},e.prototype.setFrequency=function(t){this.m_frequencyHz=t},e.prototype.getFrequency=function(){return this.m_frequencyHz},e.prototype.setDampingRatio=function(t){this.m_dampingRatio=t},e.prototype.getDampingRatio=function(){return this.m_dampingRatio},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return t*a.neo(this.m_impulse.x,this.m_impulse.y)},e.prototype.getReactionTorque=function(t){return t*this.m_impulse.z},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_bodyA.c_position.a,o=this.m_bodyA.c_velocity.v,e=this.m_bodyA.c_velocity.w,s=this.m_bodyB.c_position.a,n=this.m_bodyB.c_velocity.v,r=this.m_bodyB.c_velocity.w,h=_.neo(i),l=_.neo(s);this.m_rA=_.mul(h,a.sub(this.m_localAnchorA,this.m_localCenterA)),this.m_rB=_.mul(l,a.sub(this.m_localAnchorB,this.m_localCenterB));var u=this.m_invMassA,p=this.m_invMassB,y=this.m_invIA,d=this.m_invIB,v=new c;if(v.ex.x=u+p+this.m_rA.y*this.m_rA.y*y+this.m_rB.y*this.m_rB.y*d,v.ey.x=-this.m_rA.y*this.m_rA.x*y-this.m_rB.y*this.m_rB.x*d,v.ez.x=-this.m_rA.y*y-this.m_rB.y*d,v.ex.y=v.ey.x,v.ey.y=u+p+this.m_rA.x*this.m_rA.x*y+this.m_rB.x*this.m_rB.x*d,v.ez.y=this.m_rA.x*y+this.m_rB.x*d,v.ex.z=v.ez.x,v.ey.z=v.ez.y,v.ez.z=y+d,this.m_frequencyHz>0){v.getInverse22(this.m_mass);var f=y+d,x=f>0?1/f:0,A=s-i-this.m_referenceAngle,g=2*m.PI*this.m_frequencyHz,b=2*x*this.m_dampingRatio*g,B=x*g*g,w=t.dt;this.m_gamma=w*(b+w*B),this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0,this.m_bias=A*w*B*this.m_gamma,f+=this.m_gamma,this.m_mass.ez.z=0!=f?1/f:0}else 0==v.ez.z?(v.getInverse22(this.m_mass),this.m_gamma=0,this.m_bias=0):(v.getSymInverse33(this.m_mass),this.m_gamma=0,this.m_bias=0);if(t.warmStarting){this.m_impulse.mul(t.dtRatio);var S=a.neo(this.m_impulse.x,this.m_impulse.y);o.wSub(u,S),e-=y*(a.cross(this.m_rA,S)+this.m_impulse.z),n.wAdd(p,S),r+=d*(a.cross(this.m_rB,S)+this.m_impulse.z)}else this.m_impulse.setZero();this.m_bodyA.c_velocity.v=o,this.m_bodyA.c_velocity.w=e,this.m_bodyB.c_velocity.v=n,this.m_bodyB.c_velocity.w=r},e.prototype.solveVelocityConstraints=function(t){var i=this.m_bodyA.c_velocity.v,o=this.m_bodyA.c_velocity.w,e=this.m_bodyB.c_velocity.v,s=this.m_bodyB.c_velocity.w,n=this.m_invMassA,r=this.m_invMassB,m=this.m_invIA,_=this.m_invIB;if(this.m_frequencyHz>0){var l=s-o,u=-this.m_mass.ez.z*(l+this.m_bias+this.m_gamma*this.m_impulse.z);this.m_impulse.z+=u,o-=m*u,s+=_*u;(d=a.zero()).wAdd(1,e,1,a.cross(s,this.m_rB)),d.wSub(1,i,1,a.cross(o,this.m_rA));var p=a.neg(c.mul(this.m_mass,d));this.m_impulse.x+=p.x,this.m_impulse.y+=p.y;var y=a.clone(p);i.wSub(n,y),o-=m*a.cross(this.m_rA,y),e.wAdd(r,y),s+=_*a.cross(this.m_rB,y)}else{var d;(d=a.zero()).wAdd(1,e,1,a.cross(s,this.m_rB)),d.wSub(1,i,1,a.cross(o,this.m_rA));l=s-o;var v=h(d.x,d.y,l),f=h.neg(c.mul(this.m_mass,v));this.m_impulse.add(f);y=a.neo(f.x,f.y);i.wSub(n,y),o-=m*(a.cross(this.m_rA,y)+f.z),e.wAdd(r,y),s+=_*(a.cross(this.m_rB,y)+f.z)}this.m_bodyA.c_velocity.v=i,this.m_bodyA.c_velocity.w=o,this.m_bodyB.c_velocity.v=e,this.m_bodyB.c_velocity.w=s},e.prototype.solvePositionConstraints=function(t){var i,o,e=this.m_bodyA.c_position.c,s=this.m_bodyA.c_position.a,n=this.m_bodyB.c_position.c,l=this.m_bodyB.c_position.a,u=_.neo(s),p=_.neo(l),y=this.m_invMassA,d=this.m_invMassB,v=this.m_invIA,f=this.m_invIB,x=_.mul(u,a.sub(this.m_localAnchorA,this.m_localCenterA)),A=_.mul(p,a.sub(this.m_localAnchorB,this.m_localCenterB)),g=new c;if(g.ex.x=y+d+x.y*x.y*v+A.y*A.y*f,g.ey.x=-x.y*x.x*v-A.y*A.x*f,g.ez.x=-x.y*v-A.y*f,g.ex.y=g.ey.x,g.ey.y=y+d+x.x*x.x*v+A.x*A.x*f,g.ez.y=x.x*v+A.x*f,g.ex.z=g.ez.x,g.ey.z=g.ez.y,g.ez.z=v+f,this.m_frequencyHz>0){(B=a.zero()).wAdd(1,n,1,A),B.wSub(1,e,1,x),i=B.length(),o=0;var b=a.neg(g.solve22(B));e.wSub(y,b),s-=v*a.cross(x,b),n.wAdd(d,b),l+=f*a.cross(A,b)}else{var B;(B=a.zero()).wAdd(1,n,1,A),B.wSub(1,e,1,x);var w=l-s-this.m_referenceAngle;i=B.length(),o=m.abs(w);var S=h(B.x,B.y,w),C=h();if(g.ez.z>0)C=h.neg(g.solve33(S));else{var M=a.neg(g.solve22(B));C.set(M.x,M.y,0)}b=a.neo(C.x,C.y);e.wSub(y,b),s-=v*(a.cross(x,b)+C.z),n.wAdd(d,b),l+=f*(a.cross(A,b)+C.z)}return this.m_bodyA.c_position.c=e,this.m_bodyA.c_position.a=s,this.m_bodyB.c_position.c=n,this.m_bodyB.c_position.a=l,i<=r.linearSlop&&o<=r.angularSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":51,"../util/options":52}],37:[function(t,i,o){function e(t,i,o,n,r){if(!(this instanceof e))return new e(t,i,o,n,r);t=s(t,_),c.call(this,t,i,o),this.m_type=e.TYPE,this.m_localAnchorA=i.getLocalPoint(n),this.m_localAnchorB=o.getLocalPoint(n),this.m_localXAxisA=i.getLocalVector(r||a.neo(1,0)),this.m_localYAxisA=a.cross(1,this.m_localXAxisA),this.m_mass=0,this.m_impulse=0,this.m_motorMass=0,this.m_motorImpulse=0,this.m_springMass=0,this.m_springImpulse=0,this.m_maxMotorTorque=t.maxMotorTorque,this.m_motorSpeed=t.motorSpeed,this.m_enableMotor=t.enableMotor,this.m_frequencyHz=t.frequencyHz,this.m_dampingRatio=t.dampingRatio,this.m_bias=0,this.m_gamma=0,this.m_localCenterA,this.m_localCenterB,this.m_invMassA,this.m_invMassB,this.m_invIA,this.m_invIB,this.m_ax=a.zero(),this.m_ay=a.zero(),this.m_sAx,this.m_sBx,this.m_sAy,this.m_sBy}i.exports=e;var s=t("../util/options"),n=t("../util/create"),r=t("../Settings"),m=t("../common/Math"),a=t("../common/Vec2"),h=(t("../common/Vec3"),t("../common/Mat22"),t("../common/Mat33"),t("../common/Rot")),c=(t("../common/Sweep"),t("../common/Transform"),t("../common/Velocity"),t("../common/Position"),t("../Joint"));e.TYPE="wheel-joint";var _={enableMotor:!1,maxMotorTorque:0,motorSpeed:0,frequencyHz:2,dampingRatio:.7};(e.prototype=n((e._super=c).prototype)).getLocalAnchorA=function(){return this.m_localAnchorA},e.prototype.getLocalAnchorB=function(){return this.m_localAnchorB},e.prototype.getLocalAxisA=function(){return this.m_localXAxisA},e.prototype.getJointTranslation=function(){var t=this.m_bodyA,i=this.m_bodyB,o=t.getWorldPoint(this.m_localAnchorA),e=i.getWorldPoint(this.m_localAnchorB)-o,s=t.getWorldVector(this.m_localXAxisA);return Dot(e,s)},e.prototype.getJointSpeed=function(){var t=this.m_bodyA.m_angularVelocity;return this.m_bodyB.m_angularVelocity-t},e.prototype.isMotorEnabled=function(){return this.m_enableMotor},e.prototype.enableMotor=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_enableMotor=t},e.prototype.setMotorSpeed=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_motorSpeed=t},e.prototype.getMotorSpeed=function(){return this.m_motorSpeed},e.prototype.setMaxMotorTorque=function(t){this.m_bodyA.setAwake(!0),this.m_bodyB.setAwake(!0),this.m_maxMotorTorque=t},e.prototype.getMaxMotorTorque=function(){return this.m_maxMotorTorque},e.prototype.getMotorTorque=function(t){return t*this.m_motorImpulse},e.prototype.setSpringFrequencyHz=function(t){this.m_frequencyHz=t},e.prototype.getSpringFrequencyHz=function(){return this.m_frequencyHz},e.prototype.setSpringDampingRatio=function(t){this.m_dampingRatio=t},e.prototype.getSpringDampingRatio=function(){return this.m_dampingRatio},e.prototype.getAnchorA=function(){return this.m_bodyA.getWorldPoint(this.m_localAnchorA)},e.prototype.getAnchorB=function(){return this.m_bodyB.getWorldPoint(this.m_localAnchorB)},e.prototype.getReactionForce=function(t){return t*(this.m_impulse*this.m_ay+this.m_springImpulse*this.m_ax)},e.prototype.getReactionTorque=function(t){return t*this.m_motorImpulse},e.prototype.initVelocityConstraints=function(t){this.m_localCenterA=this.m_bodyA.m_sweep.localCenter,this.m_localCenterB=this.m_bodyB.m_sweep.localCenter,this.m_invMassA=this.m_bodyA.m_invMass,this.m_invMassB=this.m_bodyB.m_invMass,this.m_invIA=this.m_bodyA.m_invI,this.m_invIB=this.m_bodyB.m_invI;var i=this.m_invMassA,o=this.m_invMassB,e=this.m_invIA,s=this.m_invIB,n=this.m_bodyA.c_position.c,r=this.m_bodyA.c_position.a,c=this.m_bodyA.c_velocity.v,_=this.m_bodyA.c_velocity.w,l=this.m_bodyB.c_position.c,u=this.m_bodyB.c_position.a,p=this.m_bodyB.c_velocity.v,y=this.m_bodyB.c_velocity.w,d=h.neo(r),v=h.neo(u),f=h.mul(d,a.sub(this.m_localAnchorA,this.m_localCenterA)),x=h.mul(v,a.sub(this.m_localAnchorB,this.m_localCenterB));if((B=a.zero()).wAdd(1,l,1,x),B.wSub(1,n,1,f),this.m_ay=h.mul(d,this.m_localYAxisA),this.m_sAy=a.cross(a.add(B,f),this.m_ay),this.m_sBy=a.cross(x,this.m_ay),this.m_mass=i+o+e*this.m_sAy*this.m_sAy+s*this.m_sBy*this.m_sBy,this.m_mass>0&&(this.m_mass=1/this.m_mass),this.m_springMass=0,this.m_bias=0,this.m_gamma=0,this.m_frequencyHz>0){this.m_ax=h.mul(d,this.m_localXAxisA),this.m_sAx=a.cross(a.add(B,f),this.m_ax),this.m_sBx=a.cross(x,this.m_ax);var A=i+o+e*this.m_sAx*this.m_sAx+s*this.m_sBx*this.m_sBx;if(A>0){this.m_springMass=1/A;var g=a.dot(B,this.m_ax),b=2*m.PI*this.m_frequencyHz,B=2*this.m_springMass*this.m_dampingRatio*b,w=this.m_springMass*b*b,S=t.dt;this.m_gamma=S*(B+S*w),this.m_gamma>0&&(this.m_gamma=1/this.m_gamma),this.m_bias=g*S*w*this.m_gamma,this.m_springMass=A+this.m_gamma,this.m_springMass>0&&(this.m_springMass=1/this.m_springMass)}}else this.m_springImpulse=0;if(this.m_enableMotor?(this.m_motorMass=e+s,this.m_motorMass>0&&(this.m_motorMass=1/this.m_motorMass)):(this.m_motorMass=0,this.m_motorImpulse=0),t.warmStarting){this.m_impulse*=t.dtRatio,this.m_springImpulse*=t.dtRatio,this.m_motorImpulse*=t.dtRatio;var C=a.wAdd(this.m_impulse,this.m_ay,this.m_springImpulse,this.m_ax),M=this.m_impulse*this.m_sAy+this.m_springImpulse*this.m_sAx+this.m_motorImpulse,I=this.m_impulse*this.m_sBy+this.m_springImpulse*this.m_sBx+this.m_motorImpulse;c.wSub(this.m_invMassA,C),_-=this.m_invIA*M,p.wAdd(this.m_invMassB,C),y+=this.m_invIB*I}else this.m_impulse=0,this.m_springImpulse=0,this.m_motorImpulse=0;this.m_bodyA.c_velocity.v.set(c),this.m_bodyA.c_velocity.w=_,this.m_bodyB.c_velocity.v.set(p),this.m_bodyB.c_velocity.w=y},e.prototype.solveVelocityConstraints=function(t){var i=this.m_invMassA,o=this.m_invMassB,e=this.m_invIA,s=this.m_invIB,n=this.m_bodyA.c_velocity.v,r=this.m_bodyA.c_velocity.w,h=this.m_bodyB.c_velocity.v,c=this.m_bodyB.c_velocity.w,_=a.dot(this.m_ax,h)-a.dot(this.m_ax,n)+this.m_sBx*c-this.m_sAx*r,l=-this.m_springMass*(_+this.m_bias+this.m_gamma*this.m_springImpulse);this.m_springImpulse+=l;var u=a.zero().wSet(l,this.m_ax),p=l*this.m_sAx,y=l*this.m_sBx;n.wSub(i,u),r-=e*p,h.wAdd(o,u);_=(c+=s*y)-r-this.m_motorSpeed,l=-this.m_motorMass*_;var d=this.m_motorImpulse,v=t.dt*this.m_maxMotorTorque;this.m_motorImpulse=m.clamp(this.m_motorImpulse+l,-v,v),r-=e*(l=this.m_motorImpulse-d),c+=s*l;_=a.dot(this.m_ay,h)-a.dot(this.m_ay,n)+this.m_sBy*c-this.m_sAy*r,l=-this.m_mass*_;this.m_impulse+=l;u=a.zero().wSet(l,this.m_ay),p=l*this.m_sAy,y=l*this.m_sBy;n.wSub(i,u),r-=e*p,h.wAdd(o,u),c+=s*y,this.m_bodyA.c_velocity.v.set(n),this.m_bodyA.c_velocity.w=r,this.m_bodyB.c_velocity.v.set(h),this.m_bodyB.c_velocity.w=c},e.prototype.solvePositionConstraints=function(t){var i=this.m_bodyA.c_position.c,o=this.m_bodyA.c_position.a,e=this.m_bodyB.c_position.c,s=this.m_bodyB.c_position.a,n=h.neo(o),c=h.neo(s),_=h.mul(n,a.sub(this.m_localAnchorA,this.m_localCenterA)),l=h.mul(c,a.sub(this.m_localAnchorB,this.m_localCenterB)),u=a.zero();u.wAdd(1,e,1,l),u.wSub(1,i,1,_);var p,y=h.mul(n,this.m_localYAxisA),d=a.cross(a.add(u,_),y),v=a.cross(l,y),f=a.dot(u,y),x=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_sAy*this.m_sAy+this.m_invIB*this.m_sBy*this.m_sBy;p=0!=x?-f/x:0;var A=a.zero().wSet(p,y),g=p*d,b=p*v;return i.wSub(this.m_invMassA,A),o-=this.m_invIA*g,e.wAdd(this.m_invMassB,A),s+=this.m_invIB*b,this.m_bodyA.c_position.c.set(i),this.m_bodyA.c_position.a=o,this.m_bodyB.c_position.c.set(e),this.m_bodyB.c_position.a=s,m.abs(f)<=r.linearSlop}},{"../Joint":5,"../Settings":7,"../common/Mat22":16,"../common/Mat33":17,"../common/Math":18,"../common/Position":19,"../common/Rot":20,"../common/Sweep":21,"../common/Transform":22,"../common/Vec2":23,"../common/Vec3":24,"../common/Velocity":25,"../util/create":51,"../util/options":52}],38:[function(t,i,o){function e(t,i,o,s){if(!(this instanceof e))return new e(t,i,o,s);e._super.call(this),this._setAsBox(t,i,o,s)}i.exports=e;t("../util/common");var s=t("../util/create"),n=t("./PolygonShape");e.prototype=s((e._super=n).prototype),e.TYPE="polygon"},{"../util/common":50,"../util/create":51,"./PolygonShape":47}],39:[function(t,i,o){function e(t,i){if(!(this instanceof e))return new e(t,i);e._super.call(this),this.m_type=e.TYPE,this.m_radius=m.polygonRadius,this.m_vertices=[],this.m_count=0,this.m_prevVertex=null,this.m_nextVertex=null,this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,t&&t.length&&(i?this._createLoop(t):this._createChain(t))}i.exports=e;t("../util/common");var s=t("../util/create"),n=(t("../util/options"),t("../common/Math"),t("../common/Transform")),r=(t("../common/Rot"),t("../common/Vec2")),m=(t("../collision/AABB"),t("../Settings")),a=t("../Shape"),h=t("./EdgeShape");e.prototype=s((e._super=a).prototype),e.TYPE="chain",e.prototype._createLoop=function(t){for(var i=1;i<t.length;++i)t[i-1],t[i];this.m_vertices.length=0,this.m_count=t.length+1;for(i=0;i<t.length;++i)this.m_vertices[i]=t[i].clone();return this.m_vertices[t.length]=t[0].clone(),this.m_prevVertex=this.m_vertices[this.m_count-2],this.m_nextVertex=this.m_vertices[1],this.m_hasPrevVertex=!0,this.m_hasNextVertex=!0,this},e.prototype._createChain=function(t){for(var i=1;i<t.length;++i)t[i-1],t[i];this.m_count=t.length;for(i=0;i<t.length;++i)this.m_vertices[i]=t[i].clone();return this.m_hasPrevVertex=!1,this.m_hasNextVertex=!1,this.m_prevVertex=null,this.m_nextVertex=null,this},e.prototype._setPrevVertex=function(t){this.m_prevVertex=t,this.m_hasPrevVertex=!0},e.prototype._setNextVertex=function(t){this.m_nextVertex=t,this.m_hasNextVertex=!0},e.prototype._clone=function(){var t=new e;return t.createChain(this.m_vertices),t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_prevVertex=this.m_prevVertex,t.m_nextVertex=this.m_nextVertex,t.m_hasPrevVertex=this.m_hasPrevVertex,t.m_hasNextVertex=this.m_hasNextVertex,t},e.prototype.getChildCount=function(){return this.m_count-1},e.prototype.getChildEdge=function(t,i){t.m_type=h.TYPE,t.m_radius=this.m_radius,t.m_vertex1=this.m_vertices[i],t.m_vertex2=this.m_vertices[i+1],i>0?(t.m_vertex0=this.m_vertices[i-1],t.m_hasVertex0=!0):(t.m_vertex0=this.m_prevVertex,t.m_hasVertex0=this.m_hasPrevVertex),i<this.m_count-2?(t.m_vertex3=this.m_vertices[i+2],t.m_hasVertex3=!0):(t.m_vertex3=this.m_nextVertex,t.m_hasVertex3=this.m_hasNextVertex)},e.prototype.getVertex=function(t){return t<this.m_count?this.m_vertices[t]:this.m_vertices[0]},e.prototype.testPoint=function(t,i){return!1},e.prototype.rayCast=function(t,i,o,e){return new h(this.getVertex(e),this.getVertex(e+1)).rayCast(t,i,o,0)},e.prototype.computeAABB=function(t,i,o){var e=n.mul(i,this.getVertex(o)),s=n.mul(i,this.getVertex(o+1));t.combinePoints(e,s)},e.prototype.computeMass=function(t,i){t.mass=0,t.center=r.neo(),t.I=0},e.prototype.computeDistanceProxy=function(t,i){t.m_buffer[0]=this.getVertex(i),t.m_buffer[1]=this.getVertex(i+1),t.m_vertices=t.m_buffer,t.m_count=2,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"../util/options":52,"./EdgeShape":46}],40:[function(t,i,o){function e(t,i){if(!(this instanceof e))return new e(t,i);e._super.call(this),this.m_type=e.TYPE,this.m_p=m.zero(),this.m_radius=1,"object"==typeof t&&m.isValid(t)?(this.m_p.set(t),"number"==typeof i&&(this.m_radius=i)):"number"==typeof t&&(this.m_radius=t)}i.exports=e;t("../util/common");var s=t("../util/create"),n=(t("../util/options"),t("../common/Math")),r=(t("../common/Transform"),t("../common/Rot")),m=t("../common/Vec2"),a=(t("../collision/AABB"),t("../Settings"),t("../Shape"));e.prototype=s((e._super=a).prototype),e.TYPE="circle",e.prototype.getRadius=function(){return this.m_radius},e.prototype.getCenter=function(){return this.m_p},e.prototype.getSupportVertex=function(t){return this.m_p},e.prototype.getVertex=function(t){return this.m_p},e.prototype.getVertexCount=function(t){return 1},e.prototype._clone=function(){var t=new e;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_p=this.m_p.clone(),t},e.prototype.getChildCount=function(){return 1},e.prototype.testPoint=function(t,i){var o=m.add(t.p,r.mul(t.q,this.m_p)),e=m.sub(i,o);return m.dot(e,e)<=this.m_radius*this.m_radius},e.prototype.rayCast=function(t,i,o,e){var s=m.add(o.p,r.mul(o.q,this.m_p)),a=m.sub(i.p1,s),h=m.dot(a,a)-this.m_radius*this.m_radius,c=m.sub(i.p2,i.p1),_=m.dot(a,c),l=m.dot(c,c),u=_*_-l*h;if(u<0||l<n.EPSILON)return!1;var p=-(_+n.sqrt(u));return 0<=p&&p<=i.maxFraction*l&&(p/=l,t.fraction=p,t.normal=m.add(a,m.mul(p,c)),t.normal.normalize(),!0)},e.prototype.computeAABB=function(t,i,o){var e=m.add(i.p,r.mul(i.q,this.m_p));t.lowerBound.set(e.x-this.m_radius,e.y-this.m_radius),t.upperBound.set(e.x+this.m_radius,e.y+this.m_radius)},e.prototype.computeMass=function(t,i){t.mass=i*n.PI*this.m_radius*this.m_radius,t.center=this.m_p,t.I=t.mass*(.5*this.m_radius*this.m_radius+m.dot(this.m_p,this.m_p))},e.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_p),t.m_count=1,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"../util/options":52}],41:[function(t,i,o){function e(t,i,o,e,s){t.pointCount=0;var n=r.mul(o,i.m_p),a=r.mul(s,e.m_p),c=m.distanceSquared(a,n),_=i.m_radius+e.m_radius;c>_*_||(t.type=h.e_circles,t.localPoint.set(i.m_p),t.localNormal.setZero(),t.pointCount=1,t.points[0].localPoint.set(e.m_p),t.points[0].id.key=0)}var s=!1,n=t("../util/common"),r=(t("../util/create"),t("../common/Math"),t("../common/Transform")),m=t("../common/Vec2"),a=(t("../Settings"),t("../Shape"),t("../Contact")),h=t("../Manifold"),c=t("./CircleShape");a.addType(c.TYPE,c.TYPE,function(t,i,o,r,m,a,h){s&&n.assert(o.getType()==c.TYPE),s&&n.assert(a.getType()==c.TYPE),e(t,o.getShape(),i,a.getShape(),m)}),o.CollideCircles=e},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"./CircleShape":40}],42:[function(t,i,o){var e=!1,s=t("../util/common"),n=t("../common/Math"),r=t("../common/Transform"),m=(t("../common/Rot"),t("../common/Vec2")),a=(t("../collision/AABB"),t("../Settings"),t("../Manifold")),h=t("../Contact"),c=(t("../Shape"),t("./CircleShape")),_=t("./PolygonShape");h.addType(_.TYPE,c.TYPE,function(t,i,o,h,l,u,p){e&&s.assert(o.getType()==_.TYPE),e&&s.assert(u.getType()==c.TYPE),function(t,i,o,e,s){t.pointCount=0;for(var h=r.mul(s,e.m_p),c=r.mulT(o,h),_=0,l=-1/0,u=i.m_radius+e.m_radius,p=i.m_count,y=i.m_vertices,d=i.m_normals,v=0;v<p;++v){var f=m.dot(d[v],m.sub(c,y[v]));if(f>u)return;f>l&&(l=f,_=v)}var x=_,A=x+1<p?x+1:0,g=y[x],b=y[A];if(l<n.EPSILON)return t.pointCount=1,t.type=a.e_faceA,t.localNormal.set(d[_]),t.localPoint.wSet(.5,g,.5,b),t.points[0].localPoint=e.m_p,void(t.points[0].id.key=0);var B=m.dot(m.sub(c,g),m.sub(b,g)),w=m.dot(m.sub(c,b),m.sub(g,b));if(B<=0){if(m.distanceSquared(c,g)>u*u)return;t.pointCount=1,t.type=a.e_faceA,t.localNormal.wSet(1,c,-1,g),t.localNormal.normalize(),t.localPoint=g,t.points[0].localPoint.set(e.m_p),t.points[0].id.key=0}else if(w<=0){if(m.distanceSquared(c,b)>u*u)return;t.pointCount=1,t.type=a.e_faceA,t.localNormal.wSet(1,c,-1,b),t.localNormal.normalize(),t.localPoint.set(b),t.points[0].localPoint.set(e.m_p),t.points[0].id.key=0}else{var S=m.mid(g,b),l=m.dot(c,d[x])-m.dot(S,d[x]);if(l>u)return;t.pointCount=1,t.type=a.e_faceA,t.localNormal.set(d[x]),t.localPoint.set(S),t.points[0].localPoint.set(e.m_p),t.points[0].id.key=0}}(t,o.getShape(),i,u.getShape(),l)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"./CircleShape":40,"./PolygonShape":47}],43:[function(t,i,o){function e(t,i,o,e,a){t.pointCount=0;var c=r.mulT(o,r.mul(a,e.m_p)),_=i.m_vertex1,l=i.m_vertex2,u=m.sub(l,_),p=m.dot(u,m.sub(l,c)),y=m.dot(u,m.sub(c,_)),d=i.m_radius+e.m_radius;if(y<=0){var v=m.clone(_),f=m.sub(c,v);if(m.dot(f,f)>d*d)return;if(i.m_hasVertex0){var x=i.m_vertex0,A=_,g=m.sub(A,x);if(m.dot(g,m.sub(A,c))>0)return}return t.type=h.e_circles,t.localNormal.setZero(),t.localPoint.set(v),t.pointCount=1,t.points[0].localPoint.set(e.m_p),t.points[0].id.key=0,t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=h.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=h.e_vertex)}if(p<=0){v=m.clone(l),f=m.sub(c,v);if(m.dot(f,f)>d*d)return;if(i.m_hasVertex3){var b=i.m_vertex3,B=l,w=m.sub(b,B);if(m.dot(w,m.sub(c,B))>0)return}return t.type=h.e_circles,t.localNormal.setZero(),t.localPoint.set(v),t.pointCount=1,t.points[0].localPoint.set(e.m_p),t.points[0].id.key=0,t.points[0].id.cf.indexA=1,t.points[0].id.cf.typeA=h.e_vertex,t.points[0].id.cf.indexB=0,void(t.points[0].id.cf.typeB=h.e_vertex)}var S=m.dot(u,u);s&&n.assert(S>0);v=m.wAdd(p/S,_,y/S,l),f=m.sub(c,v);if(!(m.dot(f,f)>d*d)){var C=m.neo(-u.y,u.x);m.dot(C,m.sub(c,_))<0&&C.set(-C.x,-C.y),C.normalize(),t.type=h.e_faceA,t.localNormal=C,t.localPoint.set(_),t.pointCount=1,t.points[0].localPoint.set(e.m_p),t.points[0].id.key=0,t.points[0].id.cf.indexA=0,t.points[0].id.cf.typeA=h.e_face,t.points[0].id.cf.indexB=0,t.points[0].id.cf.typeB=h.e_vertex}}var s=!1,n=t("../util/common"),r=(t("../util/create"),t("../common/Math"),t("../common/Transform")),m=t("../common/Vec2"),a=(t("../common/Rot"),t("../Settings"),t("../Shape"),t("../Contact")),h=t("../Manifold"),c=t("./EdgeShape"),_=t("./ChainShape"),l=t("./CircleShape");a.addType(c.TYPE,l.TYPE,function(t,i,o,r,m,a,h){s&&n.assert(o.getType()==c.TYPE),s&&n.assert(a.getType()==l.TYPE),e(t,o.getShape(),i,a.getShape(),m)}),a.addType(_.TYPE,l.TYPE,function(t,i,o,r,m,a,h){s&&n.assert(o.getType()==_.TYPE),s&&n.assert(a.getType()==l.TYPE);var u=o.getShape(),p=new c;u.getChildEdge(p,r),e(t,p,i,a.getShape(),m)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"./ChainShape":39,"./CircleShape":40,"./EdgeShape":46}],44:[function(t,i,o){function e(){this.type,this.index,this.separation}function s(t,i,o,e,s){var n=a.mulT(o,s),r=a.mul(n,e.m_centroid),l=i.m_vertex0,p=i.m_vertex1,y=i.m_vertex2,d=i.m_vertex3,w=i.m_hasVertex0,S=i.m_hasVertex3,C=h.sub(y,p);C.normalize();var M=h.neo(C.y,-C.x),I=h.dot(M,h.sub(r,p)),P=0,T=0,V=!1,z=!1;if(w){var L=h.sub(p,l);L.normalize();var F=h.neo(L.y,-L.x);V=h.cross(L,C)>=0,P=h.dot(F,r)-h.dot(F,l)}if(S){var q=h.sub(d,y);q.normalize();var k=h.neo(q.y,-q.x);z=h.cross(C,q)>0,T=h.dot(k,r)-h.dot(k,y)}var R,D=h.zero(),E=h.zero(),j=h.zero();w&&S?V&&z?(R=P>=0||I>=0||T>=0)?(D.set(M),E.set(F),j.set(k)):(D.wSet(-1,M),E.wSet(-1,M),j.wSet(-1,M)):V?(R=P>=0||I>=0&&T>=0)?(D.set(M),E.set(F),j.set(M)):(D.wSet(-1,M),E.wSet(-1,k),j.wSet(-1,M)):z?(R=T>=0||P>=0&&I>=0)?(D.set(M),E.set(M),j.set(k)):(D.wSet(-1,M),E.wSet(-1,M),j.wSet(-1,F)):(R=P>=0&&I>=0&&T>=0)?(D.set(M),E.set(M),j.set(M)):(D.wSet(-1,M),E.wSet(-1,k),j.wSet(-1,F)):w?V?(R=P>=0||I>=0)?(D.set(M),E.set(F),j.wSet(-1,M)):(D.wSet(-1,M),E.set(M),j.wSet(-1,M)):(R=P>=0&&I>=0)?(D.set(M),E.set(M),j.wSet(-1,M)):(D.wSet(-1,M),E.set(M),j.wSet(-1,F)):S?z?(R=I>=0||T>=0)?(D.set(M),E.wSet(-1,M),j.set(k)):(D.wSet(-1,M),E.wSet(-1,M),j.set(M)):(R=I>=0&&T>=0)?(D.set(M),E.wSet(-1,M),j.set(M)):(D.wSet(-1,M),E.wSet(-1,k),j.set(M)):(R=I>=0)?(D.set(M),E.wSet(-1,M),j.wSet(-1,M)):(D.wSet(-1,M),E.set(M),j.set(M)),b.count=e.m_count;for(var J=0;J<e.m_count;++J)b.vertices[J]=a.mul(n,e.m_vertices[J]),b.normals[J]=c.mul(n.q,e.m_normals[J]);var O=2*_.polygonRadius;t.pointCount=0,A.type=f,A.index=R?0:1,A.separation=1/0;for(J=0;J<b.count;++J){(Y=h.dot(D,h.sub(b.vertices[J],p)))<A.separation&&(A.separation=Y)}if(A.type!=v&&!(A.separation>O)){g.type=v,g.index=-1,g.separation=-1/0;var N=h.neo(-D.y,D.x);for(J=0;J<b.count;++J){var Y,W=h.neg(b.normals[J]),H=h.dot(W,h.sub(b.vertices[J],p)),Z=h.dot(W,h.sub(b.vertices[J],y));if((Y=m.min(H,Z))>O){g.type=x,g.index=J,g.separation=Y;break}if(h.dot(W,N)>=0){if(h.dot(h.sub(W,j),D)<-_.angularSlop)continue}else if(h.dot(h.sub(W,E),D)<-_.angularSlop)continue;Y>g.separation&&(g.type=x,g.index=J,g.separation=Y)}if(!(g.type!=v&&g.separation>O)){var K;K=g.type==v?A:g.separation>.98*A.separation+.001?g:A;var G=[new u.clipVertex,new u.clipVertex];if(K.type==f){t.type=u.e_faceA;var U=0,X=h.dot(D,b.normals[0]);for(J=1;J<b.count;++J){var Q=h.dot(D,b.normals[J]);Q<X&&(X=Q,U=J)}var $=U,tt=$+1<b.count?$+1:0;G[0].v=b.vertices[$],G[0].id.cf.indexA=0,G[0].id.cf.indexB=$,G[0].id.cf.typeA=u.e_face,G[0].id.cf.typeB=u.e_vertex,G[1].v=b.vertices[tt],G[1].id.cf.indexA=0,G[1].id.cf.indexB=tt,G[1].id.cf.typeA=u.e_face,G[1].id.cf.typeB=u.e_vertex,R?(B.i1=0,B.i2=1,B.v1=p,B.v2=y,B.normal.set(M)):(B.i1=1,B.i2=0,B.v1=y,B.v2=p,B.normal.wSet(-1,M))}else t.type=u.e_faceB,G[0].v=p,G[0].id.cf.indexA=0,G[0].id.cf.indexB=K.index,G[0].id.cf.typeA=u.e_vertex,G[0].id.cf.typeB=u.e_face,G[1].v=y,G[1].id.cf.indexA=0,G[1].id.cf.indexB=K.index,G[1].id.cf.typeA=u.e_vertex,G[1].id.cf.typeB=u.e_face,B.i1=K.index,B.i2=B.i1+1<b.count?B.i1+1:0,B.v1=b.vertices[B.i1],B.v2=b.vertices[B.i2],B.normal.set(b.normals[B.i1]);B.sideNormal1.set(B.normal.y,-B.normal.x),B.sideNormal2.wSet(-1,B.sideNormal1),B.sideOffset1=h.dot(B.sideNormal1,B.v1),B.sideOffset2=h.dot(B.sideNormal2,B.v2);var it=[new u.clipVertex,new u.clipVertex],ot=[new u.clipVertex,new u.clipVertex];if(!(u.clipSegmentToLine(it,G,B.sideNormal1,B.sideOffset1,B.i1)<_.maxManifoldPoints||u.clipSegmentToLine(ot,it,B.sideNormal2,B.sideOffset2,B.i2)<_.maxManifoldPoints)){K.type==f?(t.localNormal=h.clone(B.normal),t.localPoint=h.clone(B.v1)):(t.localNormal=h.clone(e.m_normals[B.i1]),t.localPoint=h.clone(e.m_vertices[B.i1]));var et=0;for(J=0;J<_.maxManifoldPoints;++J){if(h.dot(B.normal,h.sub(ot[J].v,B.v1))<=O){var st=t.points[et];K.type==f?(st.localPoint=a.mulT(n,ot[J].v),st.id=ot[J].id):(st.localPoint=ot[J].v,st.id.cf.typeA=ot[J].id.cf.typeB,st.id.cf.typeB=ot[J].id.cf.typeA,st.id.cf.indexA=ot[J].id.cf.indexB,st.id.cf.indexB=ot[J].id.cf.indexA),++et}}t.pointCount=et}}}}var n=!1,r=t("../util/common"),m=(t("../util/create"),t("../common/Math")),a=t("../common/Transform"),h=t("../common/Vec2"),c=t("../common/Rot"),_=t("../Settings"),l=(t("../Shape"),t("../Contact")),u=t("../Manifold"),p=t("./EdgeShape"),y=t("./ChainShape"),d=t("./PolygonShape");l.addType(p.TYPE,d.TYPE,function(t,i,o,e,m,a,h){n&&r.assert(o.getType()==p.TYPE),n&&r.assert(a.getType()==d.TYPE),s(t,o.getShape(),i,a.getShape(),m)}),l.addType(y.TYPE,d.TYPE,function(t,i,o,e,m,a,h){n&&r.assert(o.getType()==y.TYPE),n&&r.assert(a.getType()==d.TYPE);var c=o.getShape(),_=new p;c.getChildEdge(_,e),s(t,_,i,a.getShape(),m)});var v=-1,f=1,x=2,A=new e,g=new e,b=new function(){this.vertices=[],this.normals=[],this.count=0},B=new function(){this.i1,this.i2,this.v1,this.v2,this.normal=h.zero(),this.sideNormal1=h.zero(),this.sideOffset1,this.sideNormal2=h.zero(),this.sideOffset2}},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"./ChainShape":39,"./EdgeShape":46,"./PolygonShape":47}],45:[function(t,i,o){function e(t,i,o,s){for(var n=t.m_count,r=o.m_count,c=t.m_normals,_=t.m_vertices,l=o.m_vertices,u=m.mulT(s,i),p=0,y=-1/0,d=0;d<n;++d){for(var v=a.mul(u.q,c[d]),f=m.mul(u,_[d]),x=1/0,A=0;A<r;++A){var g=h.dot(v,l[A])-h.dot(v,f);g<x&&(x=g)}x>y&&(y=x,p=d)}e._maxSeparation=y,e._bestIndex=p}function s(t,i,o,s,l){t.pointCount=0;var u=i.m_radius+s.m_radius;e(i,o,s,l);var p=e._bestIndex,y=e._maxSeparation;if(!(y>u)){e(s,l,i,o);var d=e._bestIndex,v=e._maxSeparation;if(!(v>u)){var f,x,A,g,b,B;v>y+.1*c.linearSlop?(f=s,x=i,A=l,g=o,b=d,t.type=_.e_faceB,B=1):(f=i,x=s,A=o,g=l,b=p,t.type=_.e_faceA,B=0);var w=[new _.clipVertex,new _.clipVertex];!function(t,i,o,e,s,c){var l=i.m_normals,u=s.m_count,p=s.m_vertices,y=s.m_normals;n&&r.assert(0<=e&&e<i.m_count);for(var d=a.mulT(c.q,a.mul(o.q,l[e])),v=0,f=1/0,x=0;x<u;++x){var A=h.dot(d,y[x]);A<f&&(f=A,v=x)}var g=v,b=g+1<u?g+1:0;t[0].v=m.mul(c,p[g]),t[0].id.cf.indexA=e,t[0].id.cf.indexB=g,t[0].id.cf.typeA=_.e_face,t[0].id.cf.typeB=_.e_vertex,t[1].v=m.mul(c,p[b]),t[1].id.cf.indexA=e,t[1].id.cf.indexB=b,t[1].id.cf.typeA=_.e_face,t[1].id.cf.typeB=_.e_vertex}(w,f,A,b,x,g);var S=f.m_count,C=f.m_vertices,M=b,I=b+1<S?b+1:0,P=C[M],T=C[I],V=h.sub(T,P);V.normalize();var z=h.cross(V,1),L=h.wAdd(.5,P,.5,T),F=a.mul(A.q,V),q=h.cross(F,1);P=m.mul(A,P),T=m.mul(A,T);var k=h.dot(q,P),R=-h.dot(F,P)+u,D=h.dot(F,T)+u,E=[new _.clipVertex,new _.clipVertex],j=[new _.clipVertex,new _.clipVertex];if(!(_.clipSegmentToLine(E,w,h.neg(F),R,M)<2||_.clipSegmentToLine(j,E,F,D,I)<2)){t.localNormal=z,t.localPoint=L;for(var J=0,O=0;O<j.length;++O){if(h.dot(q,j[O].v)-k<=u){var N=t.points[J];if(N.localPoint.set(m.mulT(g,j[O].v)),N.id=j[O].id,B){var Y=N.id.cf,W=Y.indexA,H=Y.indexB,Z=Y.typeA,K=Y.typeB;Y.indexA=H,Y.indexB=W,Y.typeA=K,Y.typeB=Z}++J}}t.pointCount=J}}}}var n=!1,r=t("../util/common"),m=(t("../common/Math"),t("../common/Transform")),a=t("../common/Rot"),h=t("../common/Vec2"),c=(t("../collision/AABB"),t("../Settings")),_=t("../Manifold"),l=t("../Contact"),u=(t("../Shape"),t("./PolygonShape"));i.exports=s,l.addType(u.TYPE,u.TYPE,function(t,i,o,e,m,a,h){n&&r.assert(o.getType()==u.TYPE),n&&r.assert(a.getType()==u.TYPE),s(t,o.getShape(),i,a.getShape(),m)})},{"../Contact":3,"../Manifold":6,"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"./PolygonShape":47}],46:[function(t,i,o){function e(t,i){if(!(this instanceof e))return new e(t,i);e._super.call(this),this.m_type=e.TYPE,this.m_radius=n.polygonRadius,this.m_vertex1=t?h.clone(t):h.zero(),this.m_vertex2=i?h.clone(i):h.zero(),this.m_vertex0=h.zero(),this.m_vertex3=h.zero(),this.m_hasVertex0=!1,this.m_hasVertex3=!1}i.exports=e;var s=t("../util/create"),n=(t("../util/options"),t("../Settings")),r=t("../Shape"),m=(t("../common/Math"),t("../common/Transform")),a=t("../common/Rot"),h=t("../common/Vec2");t("../collision/AABB");e.prototype=s((e._super=r).prototype),e.TYPE="edge",e.prototype.setNext=function(t){return t?(this.m_vertex3.set(t),this.m_hasVertex3=!0):(this.m_vertex3.setZero(),this.m_hasVertex3=!1),this},e.prototype.setPrev=function(t){return t?(this.m_vertex0.set(t),this.m_hasVertex0=!0):(this.m_vertex0.setZero(),this.m_hasVertex0=!1),this},e.prototype._set=function(t,i){return this.m_vertex1.set(t),this.m_vertex2.set(i),this.m_hasVertex0=!1,this.m_hasVertex3=!1,this},e.prototype._clone=function(){var t=new e;return t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_vertex1.set(this.m_vertex1),t.m_vertex2.set(this.m_vertex2),t.m_vertex0.set(this.m_vertex0),t.m_vertex3.set(this.m_vertex3),t.m_hasVertex0=this.m_hasVertex0,t.m_hasVertex3=this.m_hasVertex3,t},e.prototype.getChildCount=function(){return 1},e.prototype.testPoint=function(t,i){return!1},e.prototype.rayCast=function(t,i,o,e){var s=a.mulT(o.q,h.sub(i.p1,o.p)),n=a.mulT(o.q,h.sub(i.p2,o.p)),r=h.sub(n,s),m=this.m_vertex1,c=this.m_vertex2,_=h.sub(c,m),l=h.neo(_.y,-_.x);l.normalize();var u=h.dot(l,h.sub(m,s)),p=h.dot(l,r);if(0==p)return!1;var y=u/p;if(y<0||i.maxFraction<y)return!1;var d=h.add(s,h.mul(y,r)),v=h.sub(c,m),f=h.dot(v,v);if(0==f)return!1;var x=h.dot(h.sub(d,m),v)/f;return!(x<0||1<x)&&(t.fraction=y,t.normal=u>0?a.mul(o.q,l).neg():a.mul(o.q,l),!0)},e.prototype.computeAABB=function(t,i,o){var e=m.mul(i,this.m_vertex1),s=m.mul(i,this.m_vertex2);t.combinePoints(e,s),t.extend(this.m_radius)},e.prototype.computeMass=function(t,i){t.mass=0,t.center.wSet(.5,this.m_vertex1,.5,this.m_vertex2),t.I=0},e.prototype.computeDistanceProxy=function(t){t.m_vertices.push(this.m_vertex1),t.m_vertices.push(this.m_vertex2),t.m_count=2,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/create":51,"../util/options":52}],47:[function(t,i,o){function e(t){if(!(this instanceof e))return new e(t);e._super.call(this),this.m_type=e.TYPE,this.m_radius=_.polygonRadius,this.m_centroid=c.zero(),this.m_vertices=[],this.m_normals=[],this.m_count=0,t&&t.length&&this._set(t)}var s=!1;i.exports=e;var n=t("../util/common"),r=t("../util/create"),m=(t("../util/options"),t("../common/Math")),a=t("../common/Transform"),h=t("../common/Rot"),c=t("../common/Vec2"),_=(t("../collision/AABB"),t("../Settings")),l=t("../Shape");e.prototype=r((e._super=l).prototype),e.TYPE="polygon",e.prototype.getVertex=function(t){return s&&n.assert(0<=t&&t<this.m_count),this.m_vertices[t]},e.prototype._clone=function(){var t=new e;t.m_type=this.m_type,t.m_radius=this.m_radius,t.m_count=this.m_count,t.m_centroid.set(this.m_centroid);for(var i=0;i<this.m_count;i++)t.m_vertices.push(this.m_vertices[i].clone());for(i=0;i<this.m_normals.length;i++)t.m_normals.push(this.m_normals[i].clone());return t},e.prototype.getChildCount=function(){return 1},e.prototype._set=function(t){if(s&&n.assert(3<=t.length&&t.length<=_.maxPolygonVertices),t.length<3)this._setAsBox(1,1);else{for(var i=m.min(t.length,_.maxPolygonVertices),o=[],e=0,r=0;r<i;++r){for(var a=t[r],h=!0,l=0;l<e;++l)if(c.distanceSquared(a,o[l])<.25*_.linearSlopSquared){h=!1;break}h&&(o[e++]=a)}if((i=e)<3)return s&&n.assert(!1),void this._setAsBox(1,1);var u=0,p=o[0].x;for(r=1;r<i;++r){var y=o[r].x;(y>p||y==p&&o[r].y<o[u].y)&&(u=r,p=y)}for(var d=[],v=0,f=u;;){d[v]=f;var x=0;for(l=1;l<i;++l)if(x!=f){var A=c.sub(o[x],o[d[v]]),g=(a=c.sub(o[l],o[d[v]]),c.cross(A,a));g<0&&(x=l),0==g&&a.lengthSquared()>A.lengthSquared()&&(x=l)}else x=l;if(++v,f=x,x==u)break}if(v<3)return s&&n.assert(!1),void this._setAsBox(1,1);this.m_count=v;for(r=0;r<v;++r)this.m_vertices[r]=o[d[r]];for(r=0;r<v;++r){var b=r,B=r+1<v?r+1:0,w=c.sub(this.m_vertices[B],this.m_vertices[b]);s&&n.assert(w.lengthSquared()>m.EPSILON*m.EPSILON),this.m_normals[r]=c.cross(w,1),this.m_normals[r].normalize()}this.m_centroid=function(t,i){s&&n.assert(i>=3);for(var o=c.zero(),e=0,r=c.zero(),a=0;a<i;++a){var h=r,_=t[a],l=a+1<i?t[a+1]:t[0],u=c.sub(_,h),p=c.sub(l,h),y=.5*c.cross(u,p);e+=y,o.wAdd(y*(1/3),h),o.wAdd(y*(1/3),_),o.wAdd(y*(1/3),l)}return s&&n.assert(e>m.EPSILON),o.mul(1/e),o}(this.m_vertices,v)}},e.prototype._setAsBox=function(t,i,o,e){if(this.m_vertices[0]=c.neo(-t,-i),this.m_vertices[1]=c.neo(t,-i),this.m_vertices[2]=c.neo(t,i),this.m_vertices[3]=c.neo(-t,i),this.m_normals[0]=c.neo(0,-1),this.m_normals[1]=c.neo(1,0),this.m_normals[2]=c.neo(0,1),this.m_normals[3]=c.neo(-1,0),this.m_count=4,c.isValid(o)){e=e||0,this.m_centroid.set(o);var s=a.identity();s.p.set(o),s.q.set(e);for(var n=0;n<this.m_count;++n)this.m_vertices[n]=a.mul(s,this.m_vertices[n]),this.m_normals[n]=h.mul(s.q,this.m_normals[n])}},e.prototype.testPoint=function(t,i){for(var o=h.mulT(t.q,c.sub(i,t.p)),e=0;e<this.m_count;++e){if(c.dot(this.m_normals[e],c.sub(o,this.m_vertices[e]))>0)return!1}return!0},e.prototype.rayCast=function(t,i,o,e){for(var r=h.mulT(o.q,c.sub(i.p1,o.p)),m=h.mulT(o.q,c.sub(i.p2,o.p)),a=c.sub(m,r),_=0,l=i.maxFraction,u=-1,p=0;p<this.m_count;++p){var y=c.dot(this.m_normals[p],c.sub(this.m_vertices[p],r)),d=c.dot(this.m_normals[p],a);if(0==d){if(y<0)return!1}else d<0&&y<_*d?(_=y/d,u=p):d>0&&y<l*d&&(l=y/d);if(l<_)return!1}return s&&n.assert(0<=_&&_<=i.maxFraction),u>=0&&(t.fraction=_,t.normal=h.mul(o.q,this.m_normals[u]),!0)},e.prototype.computeAABB=function(t,i,o){for(var e=1/0,s=1/0,n=-1/0,r=-1/0,h=0;h<this.m_count;++h){var c=a.mul(i,this.m_vertices[h]);e=m.min(e,c.x),n=m.max(n,c.x),s=m.min(s,c.y),r=m.max(r,c.y)}t.lowerBound.set(e,s),t.upperBound.set(n,r),t.extend(this.m_radius)},e.prototype.computeMass=function(t,i){s&&n.assert(this.m_count>=3);for(var o=c.zero(),e=0,r=0,a=c.zero(),h=0;h<this.m_count;++h)a.add(this.m_vertices[h]);a.mul(1/this.m_count);for(h=0;h<this.m_count;++h){var _=c.sub(this.m_vertices[h],a),l=h+1<this.m_count?c.sub(this.m_vertices[h+1],a):c.sub(this.m_vertices[0],a),u=c.cross(_,l),p=.5*u;e+=p,o.wAdd(p*(1/3),_,p*(1/3),l);var y=_.x,d=_.y,v=l.x,f=l.y;r+=1/3*.25*u*(y*y+v*y+v*v+(d*d+f*d+f*f))}t.mass=i*e,s&&n.assert(e>m.EPSILON),o.mul(1/e),t.center.wSet(1,o,1,a),t.I=i*r,t.I+=t.mass*(c.dot(t.center,t.center)-c.dot(o,o))},e.prototype.validate=function(){for(var t=0;t<this.m_count;++t)for(var i=t,o=t<this.m_count-1?i+1:0,e=this.m_vertices[i],s=c.sub(this.m_vertices[o],e),n=0;n<this.m_count;++n)if(n!=i&&n!=o){var r=c.sub(this.m_vertices[n],e);if(c.cross(s,r)<0)return!1}return!0},e.prototype.computeDistanceProxy=function(t){t.m_vertices=this.m_vertices,t.m_count=this.m_count,t.m_radius=this.m_radius}},{"../Settings":7,"../Shape":8,"../collision/AABB":11,"../common/Math":18,"../common/Rot":20,"../common/Transform":22,"../common/Vec2":23,"../util/common":50,"../util/create":51,"../util/options":52}],48:[function(t,i,o){i.exports=function(t){var i=[],o=t.max||1/0,e=t.create,s=t.allocate,n=t.release,r=t.discard,m=0,a=0,h=0,c=0;this.max=function(t){return"number"==typeof t?(o=t,this):o},this.size=function(){return i.length},this.allocate=function(){var t;return i.length>0?t=i.shift():(m++,t="function"==typeof e?e():{}),a++,"function"==typeof s&&s(t),t},this.release=function(t){i.length<o?(h++,"function"==typeof n&&n(t),i.push(t)):(c++,"function"==typeof r&&(t=r(t)))},this.toString=function(){return" +"+m+" >"+a+" <"+h+" -"+c+" ="+i.length+"/"+o}}},{}],49:[function(t,i,o){i.exports.now=function(){return Date.now()},i.exports.diff=function(t){return Date.now()-t}},{}],50:[function(t,i,o){o.debug=function(){},o.assert=function(t,i,o){}},{}],51:[function(t,i,o){function e(){}"function"==typeof Object.create?i.exports=function(t,i){return Object.create.call(Object,t,i)}:i.exports=function(t,i){if(i)throw Error("Second argument is not supported!");if("object"!=typeof t||null===t)throw Error("Invalid prototype!");return e.prototype=t,new e}},{}],52:[function(t,i,o){Object.prototype.propertyIsEnumerable;i.exports=function(t,i){null!==t&&void 0!==t||(t={});for(var o in i)i.hasOwnProperty(o)&&void 0===t[o]&&(t[o]=i[o]);if("function"==typeof Object.getOwnPropertySymbols)for(var e=Object.getOwnPropertySymbols(i),s=0;s<e.length;s++){var n=e[s];i.propertyIsEnumerable(n)&&void 0===t[o]&&(t[n]=i[n])}return t}},{}]},{},[1])(1)});